#include <stdio.h>
#include "lp.h"
#include "defs.h"

#define d 4  
#define MAX_CONST	1000
#define WORK_CONST	10*MAX_CONST
#define DISP		1e-9

int do_lin_prog(tp0, tp1, patch_or_curve)
TENSOR_PATCH tp0, tp1;
int patch_or_curve;
{
  double halves[300][d+1];
  double n_vec[d+1], d_vec[d+1], opt[d+1];
  int m /* d */ ;
  double work[WORK_CONST];
  int istart;
  int next[MAX_CONST], prev[MAX_CONST], max_size;
  int i, j, k, l;
  int rl, cl, rh, ch;
  int status;

  rl = cl = 0;
  rh = tp1.iDeg0;
  ch = tp1.iDeg1;
  switch (patch_or_curve)
  {
    case 0:
      rl = rh = cl = 0;
      ch = tp1.iDeg1;
      break;
    case 1:
      rl = rh = tp1.iDeg0;
      cl = 0;
      ch = tp1.iDeg1;
      break;
    case 2:
      rl = cl = ch = 0;
      rh = tp1.iDeg0;
      break;
    case 3:
      cl = ch = tp1.iDeg1;
      rl = 0;
      rh = tp1.iDeg0;
      break;
    default:
      break;
  }
  
  for (i=0; i<=d; i++)
    if (i == d) halves[0][i] = 1;
    else halves[0][i] = 0;

  l = 1;
  for (i=0; i<=tp0.iDeg0; i++)
  for (j=0; j<=tp0.iDeg1; j++)
  {
    for (k=0; k<d-1; k++) 
      halves[l][k] = -(tp0.coeffs[i][j].dCoord[k]/tp0.coeffs[i][j].dCoord[d-1]);
    halves[l][d-1] = -1.0;
    halves[l][d] = -DISP;
    l++;
  }

  for (i=rl; i<=rh; i++)
  for (j=cl; j<=ch; j++)
  {
    for (k=0; k<d-1; k++) 
      halves[l][k] = tp1.coeffs[i][j].dCoord[k]/tp1.coeffs[i][j].dCoord[d-1];
    halves[l][d-1] = 1.0;
    halves[l][d] = -DISP; 
    l++;
  }

  m = l;
  istart = 0;
  max_size = MAX_CONST;

  for (i = 0; i < MAX_CONST; i++) {
    next[i] = i + 1;
    prev[i] = i - 1;
  }

  for (i = 0; i < d; i++) { d_vec[i] = 0; n_vec[i] = 0; }
  d_vec[d] = 1;
  n_vec[d] = 0;

   /* printf("calling linProg...\n"); */
  status = linprog(halves,istart,m,n_vec,d_vec,d,opt,work,next,prev,max_size);

  return status;
}

