#include <stdio.h>
/* #include <defs.h> */
#include <libinterf.h>

int main()
{
  POINT4D a, b, c, d;
  double l, r1, r2;
  TRIM_PATCH_INFO* cone1;
  TRIM_PATCH_INFO* cone2;
  TRIM_PATCH_INFO* cone3;
  int ncone1, ncone2, ncone3;
  FILE* fp1;
  FILE* fp2;
  FILE* fp3;

  a.dCoord[0] = 1;
  a.dCoord[1] = 0.1;
  a.dCoord[2] = 0.1;
  a.dCoord[3] = 1;

  b.dCoord[0] = 0;
  b.dCoord[1] = 0;
  b.dCoord[2] = 10;
  b.dCoord[3] = 1;

  c.dCoord[0] = -5;
  c.dCoord[1] = 2;
  c.dCoord[2] = 0;
  c.dCoord[3] = 1;

  d.dCoord[0] = 5;
  d.dCoord[1] = 0;
  d.dCoord[2] = 0;
  d.dCoord[3] = 1;

  /* Space is allocated in new_cone */
  
  new_cone(a, b, 10, 4, 2,
	   &cone1, &ncone1);

  new_cone(c, d, 15, 3, 1,
	   &cone2, &ncone2);

  fp1 = fopen("cone1", "w");
  write_solid_tagged(cone1, ncone1, fp1);
  fclose(fp1);

  fp2 = fopen("cone2", "w");
  write_solid_tagged(cone2, ncone2, fp2);
  fclose(fp2);

  operate(&cone1, ncone1, &cone2, ncone2, 3 /* difference */,
	  &cone3, &ncone3, 0.03);

  fp3 = fopen("cones", "w");
  if (fp1 == NULL || fp2 == NULL || fp3 == NULL) {
    printf("Couldn't open output file\n");
    return (-1);
  }
  write_solid_tagged(cone3, ncone3, fp3);
  fclose(fp3);

  return (0);
}
