
/* Some basic typedefs which are used throughout the code. Copied */
/* almost as exactly specified in the documentation */

typedef double matrix_t[16];

typedef double vector_t[4];

typedef struct point_s {
  double x, y, z;
} point_typ;

typedef struct  line_s {
  double u0, u1;
  vector_t v;			/* Unit vector */
  vector_t o;
} line_t;

typedef struct plane_s {
  vector_t coeff;
} plane_typ;

typedef struct  circle_s {
  plane_typ pl;
  vector_t c;
  double r, a0, a1;
} circle_t;

typedef struct  ellipse_s {
  plane_typ pl;
  vector_t c;
  double rmaj, rmin;
  double ang, a0, a1;
} ellipse_t;

typedef struct gcurveseg_s {
  int ord;
  vector_t *v;
} gcurveseg_t;

typedef struct gcurve_s {
  int iarc1, iarcn, narc, maxord;
  double w0, w1;
  gcurveseg_t *seg;
} gcurve_t;

typedef struct curve_s {
  int ctype;
  union {
    line_t *lp;
    circle_t *cp;
    ellipse_t *ep;
    gcurve_t *gp;
  } p;
} curve_t;

typedef struct domain_s {
  int ncrv;
  curve_t *crv;
} domain_t;

