#include <stdio.h>
#include <signal.h>

#include "timesgi.h"
#include "defs.h"
#undef W

/* #include "conf.h" */

#include <stdio.h>
#include <math.h>
/* #include "machine.h" */
/* #include "nmg.h" */
/* #include "vmath.h" */
#define KEYSERTREE
/* #include "raytrace.h" */
/* #include "debug.h" */

extern char *optarg;
extern int  optind;

static int	NMG_debug;	/* saved arg of -X, for longjmp handling */
static int	verbose;
static int	debug_plots;	/* Make debugging plots */
static int	ncpu = 1;	/* Number of processors */
static char	*prefix = NULL;	/* output filename prefix. */
static char	*outfilname = NULL;
static struct db_i		*dbip;
/* the following structure gave an error, and I saw no reason to
   keep it, so I took it and its associated destroy out */
/*static struct rt_vls		base_seg;*/
/*
  static struct rt_tess_tol	ttol;
static struct rt_tol		tol;
static struct model		*the_model;
static double			ssize;

static struct db_tree_state	bool_tree_state; */
/* includes tol & model */

static int	regions_tried = 0;
static int	regions_done = 0;

void xcpu()
{
  fprintf(stderr,"Used too much cpu time\n");
  fflush(stderr);
  exit(1);
}

void catchsigs()
{
  struct sigaction x;
  x.sa_flags = 0;
  x.sa_handler = xcpu;
  sigfillset(&(x.sa_mask));
  sigaction(SIGXCPU, &x, NULL);
}

/* TRANSFORM_TRIM and associated functions
*/
transform_ten_p(TENSOR_PATCH *tp, double trans[16])
{
   int i, j, k;
   double p[4];

   for (i=0; i<=tp->iDeg0; i++)
      for (j=0; j<=tp->iDeg1; j++) {
         p[0] = tp->coeffs[i][j].dCoord[0] * trans[0] +
                tp->coeffs[i][j].dCoord[1] * trans[4] +
                tp->coeffs[i][j].dCoord[2] * trans[8] +
                tp->coeffs[i][j].dCoord[3] * trans[12];
         p[1] = tp->coeffs[i][j].dCoord[0] * trans[1] +
                tp->coeffs[i][j].dCoord[1] * trans[5] +
                tp->coeffs[i][j].dCoord[2] * trans[9] +
                tp->coeffs[i][j].dCoord[3] * trans[13];
         p[2] = tp->coeffs[i][j].dCoord[0] * trans[2] +
                tp->coeffs[i][j].dCoord[1] * trans[6] +
                tp->coeffs[i][j].dCoord[2] * trans[10] +
                tp->coeffs[i][j].dCoord[3] * trans[14];
         p[3] = tp->coeffs[i][j].dCoord[0] * trans[3] +
                tp->coeffs[i][j].dCoord[1] * trans[7] +
                tp->coeffs[i][j].dCoord[2] * trans[11] +
                tp->coeffs[i][j].dCoord[3] * trans[15];
         for (k=0; k<4; k++)
            tp->coeffs[i][j].dCoord[k] = p[k];
      }
}

transform_trim_por_spline(TRIM_PORTION_SPLINE_TYPE* tpt, double trans[16])
{
   int i,j,k;
   double p[4];

   for (i=0;i<tpt->NumOfCurves;i++) {
      for (j=0;j<=tpt->XYZ_Splines[i].Deg;j++) {
         p[0] = tpt->XYZ_Splines[i].CntrlPts[j].dCoord[0] * trans[0] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[1] * trans[4] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[2] * trans[8] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[3] * trans[12];
         p[1] = tpt->XYZ_Splines[i].CntrlPts[j].dCoord[0] * trans[1] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[1] * trans[5] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[2] * trans[9] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[3] * trans[13];
         p[2] = tpt->XYZ_Splines[i].CntrlPts[j].dCoord[0] * trans[2] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[1] * trans[6] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[2] * trans[10] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[3] * trans[14];
         p[3] = tpt->XYZ_Splines[i].CntrlPts[j].dCoord[0] * trans[3] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[1] * trans[7] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[2] * trans[11] +
                tpt->XYZ_Splines[i].CntrlPts[j].dCoord[3] * trans[15];
         for (k=0;k<4;k++)
            tpt->XYZ_Splines[i].CntrlPts[j].dCoord[k] = p[k];
      }
   }
}

/*transform_trim_por_piece(TRIM_PORTION_PIECEWISE_TYPE* tpt, double trans[16])
{
}*/


void
transform_trim(TRIM_PATCH_INFO* p, int npatches, double trans[16])
{
   int i,j,k;
   TRIM_PATCH_INFO* q;

   q = p;
   for(i=0;i<npatches;i++, q++) {
      transform_ten_p(&(q->tp),trans);
      transform_ten_p(&(q->orig_tp),trans);
      for (j=0;j<q->NumTrimPortions;j++) {
/*        if (q->SplineReprn) */
           transform_trim_por_spline(&(q->TrimPortion[j].SplinePortion),
                                     trans);
/*        else
           transform_trim_por_piece(&(q->TrimPortion[j].PiecePortion),
                                    trans); */
      }
   }
}


