#ifndef _macro_h
#define _macro_h

/* All macros should go in here!!!!! */

#define CROSS(v0, v1, vr) vr[0] = v0[1]*v1[2] - v1[1]*v0[2];\
                          vr[1] = -1.0*v0[0]*v1[2] + v1[0]*v0[2];\
                          vr[2] = v0[0]*v1[1] - v1[0]*v0[1]

#define DOT(v0, v1) (v0[0]*v1[0] + v0[1]*v1[1] + v0[2]*v1[2])

#define NORMALISE(v, denom) v[0] /= denom;\
                            v[1] /= denom;\
                            v[2] /= denom;\
                            v[3] /= denom;

#define point_to_4D(pt, vect)  vect[0] = pt.x;\
			       vect[1] = pt.y;\
			       vect[2] = pt.z;\
			       vect[3] = 1.0

#define mypt_to_yourpt(mpt, ypt) ypt.dCoord[0] = mpt[0];\
                                 ypt.dCoord[1] = mpt[1];\
                                 ypt.dCoord[2] = mpt[2];\
                                 ypt.dCoord[3] = mpt[3]

#define mypt_to_yourpt_no_w(mpt, ypt) ypt.dCoord[0] = mpt[0];\
                                      ypt.dCoord[1] = mpt[1];\
                                      ypt.dCoord[2] = mpt[2]


#define yourpt_to_mypt(ypt, mpt) mpt[0] = ypt.dCoord[0];\
                                 mpt[1] = ypt.dCoord[1];\
                                 mpt[2] = ypt.dCoord[2];\
                                 mpt[3] = ypt.dCoord[3]


#define _LENGTH(v) (sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]))

#define TOLERANCE  1.0e-3
#define FP_EQUAL(a, b)  ((((a) - (b)) < TOLERANCE) &&  \
			 (((a) - (b)) > -TOLERANCE)) 
#define FP_EQUAL_TOL(a, b, t)  ((((a) - (b)) < t) &&  \
			     (((a) - (b)) > -t)) 



/***********************************************************/
#define TOLERANCE_4D 0.5e-3
#define FP_EQUAL_4D(a, b)  ((((a) - (b)) < TOLERANCE_4D) &&  \
			    (((a) - (b)) > -TOLERANCE_4D)) 

#define EQUAL_4D(a, b) ((FP_EQUAL_4D((a).dCoord[0]/(a).dCoord[3],\
				     (b).dCoord[0]/(b).dCoord[3])) && \
			(FP_EQUAL_4D((a).dCoord[1]/(a).dCoord[3],\
				     (b).dCoord[1]/(b).dCoord[3])) && \
			(FP_EQUAL_4D((a).dCoord[2]/(a).dCoord[3],\
				     (b).dCoord[2]/(b).dCoord[3])))

/***********************************************************/


/* The tolerance is higher for this function because of the data read */
/* from the CATIA files. Data inaccurate in many places */

#define FP_EQUAL_4DPAR(a, b, tol)  ((((a) - (b)) < tol) &&  \
				    (((a) - (b)) > -tol)) 

#define EQUAL_4D_PAR(a, b, tol) ((FP_EQUAL_4DPAR((a).dCoord[0]/(a).dCoord[3],\
						 (b).dCoord[0]/(b).dCoord[3],\
						 tol)) && \
				 (FP_EQUAL_4DPAR((a).dCoord[1]/(a).dCoord[3],\
						 (b).dCoord[1]/(b).dCoord[3],\
						 tol)) && \
				 (FP_EQUAL_4DPAR((a).dCoord[2]/(a).dCoord[3],\
						 (b).dCoord[2]/(b).dCoord[3],\
						 tol)))


#endif /* _macro_h */
