#include <math.h>
#include "defs.h"

void normalise(vec)
POINT4D *vec;
{
  double len;

  len = sqrt((vec->dCoord[X])*(vec->dCoord[X]) +
             (vec->dCoord[Y])*(vec->dCoord[Y]) +
             (vec->dCoord[Z])*(vec->dCoord[Z]));
  vec->dCoord[X] = vec->dCoord[X] / len;
  vec->dCoord[Y] = vec->dCoord[Y] / len;
  vec->dCoord[Z] = vec->dCoord[Z] / len;
}

void XformPatch(tp, numPatches, sDeg, tDeg, Xform)
TENSOR_PATCH *tp;
int numPatches, sDeg, tDeg;
double **Xform;
{
  int i, j, k, l, m;
  double tmp[4];

  for (k=0; k<numPatches; k++) {
    sDeg = tp[k].iDeg0;
    tDeg = tp[k].iDeg1;
    for (i=0; i<=sDeg; i++)
    for (j=0; j<=tDeg; j++) {
      tmp[0] = tmp[1] = tmp[2] = tmp[3] = 0.0;
      for (l=X; l<=W; l++)
      for (m=X; m<=W; m++)
        tmp[l] += tp[k].coeffs[i][j].dCoord[m] * Xform[m][l];
      for (l=X; l<=W; l++)
        tp[k].coeffs[i][j].dCoord[l] = tmp[l];
    }
  }
}

void WriteControlPtsInFile(fp, tp, numPatches)
FILE *fp;
TENSOR_PATCH *tp;
int numPatches;
{
  int i, j, k, l;

  for (k=0; k<numPatches; k++) {
    fprintf(fp, "%d %d\n", tp[k].iDeg0, tp[k].iDeg1);
    for (i=0; i<=tp[k].iDeg0; i++)
    for (j=0; j<=tp[k].iDeg1; j++) {
      for (l=X; l<=W; l++)
        fprintf(fp, "%g  ", tp[k].coeffs[i][j].dCoord[l]);
      fprintf(fp, "\n");
    }
    fprintf(fp, "0\n");
  }
}

