#include <stdio.h>
#include <math.h>
#include "defs.h"
#include "linalg.h"

#if 0
#define	NUM_TOR_PATCHES		16
#else
#define	NUM_TOR_PATCHES		9
#endif

#define	TOR_SDEGREE		2	
#define	TOR_TDEGREE		2	

EXTERN_LINALG

extern void normalise();
extern void allocate_tensor_patch();
extern void XformPatch();

static double **TmpMat;
static POINT4D CircPts[7];

void getXformMatTor(center, axis_vec, Xform)
POINT4D center, axis_vec;
double **Xform;
{
  double a, b, c, d, px, py, pz;

  a = axis_vec.dCoord[X];
  b = axis_vec.dCoord[Y];
  c = axis_vec.dCoord[Z];
  d = sqrt(b*b + c*c);
  px = center.dCoord[X];
  py = center.dCoord[Y];
  pz = center.dCoord[Z];

  if (d < 1e-5) {
    Xform[0][0] = 0.0;
    Xform[0][1] = 0.0;
    Xform[0][2] = -1.0;
    Xform[0][3] = 0.0;
 
    Xform[1][0] = 0.0;
    Xform[1][1] = 1.0;
    Xform[1][2] = 0.0;
    Xform[1][3] = 0.0;
 
    Xform[2][0] = 1.0;
    Xform[2][1] = 0.0;
    Xform[2][2] = 0.0;
    Xform[2][3] = 0.0;

    Xform[3][0] = px;
    Xform[3][1] = py;
    Xform[3][2] = pz;
    Xform[3][3] = 1.0;
    return;
  }

  Xform[0][0] = d;
  Xform[0][1] = -a*b/d;
  Xform[0][2] = -a*c/d;
  Xform[0][3] = 0.0;
  
  Xform[1][0] = 0.0;
  Xform[1][1] = c/d;
  Xform[1][2] = -b/d;
  Xform[1][3] = 0.0;
  
  Xform[2][0] = a;
  Xform[2][1] = b;
  Xform[2][2] = c;
  Xform[2][3] = 0.0;
  
  Xform[3][0] = px;
  Xform[3][1] = py;
  Xform[3][2] = pz;
  Xform[3][3] = 1.0;
}
  
#if 0
void GetNormTorusControlPts(tp, torus_iradius, torus_oradius)
TENSOR_PATCH *tp;
double torus_iradius, torus_oradius;
{
  double w, ww, r1, r2, r3;

  w = sqrt(2.0) / 2.0;  
  ww = 0.5;
  r1 = torus_iradius;
  r2 = torus_oradius;
  r3 = (r2 - r1)/ 2.0;

  tp[0].coeffs[0][0].dCoord[X] = r1;
  tp[0].coeffs[0][0].dCoord[Y] = 0.0;
  tp[0].coeffs[0][0].dCoord[Z] = 0.0;
  tp[0].coeffs[0][0].dCoord[W] = 1.0;

  tp[0].coeffs[1][0].dCoord[X] = r1*w;
  tp[0].coeffs[1][0].dCoord[Y] = 0.0;
  tp[0].coeffs[1][0].dCoord[Z] = r3*w;
  tp[0].coeffs[1][0].dCoord[W] = w;

  tp[0].coeffs[2][0].dCoord[X] = (r1 + r3);
  tp[0].coeffs[2][0].dCoord[Y] = 0.0;
  tp[0].coeffs[2][0].dCoord[Z] = r3;
  tp[0].coeffs[2][0].dCoord[W] = 1.0;

  tp[0].coeffs[0][1].dCoord[X] = r1*w;
  tp[0].coeffs[0][1].dCoord[Y] = r1*w;
  tp[0].coeffs[0][1].dCoord[Z] = 0.0;
  tp[0].coeffs[0][1].dCoord[W] = w;

  tp[0].coeffs[1][1].dCoord[X] = r1*ww;
  tp[0].coeffs[1][1].dCoord[Y] = r1*ww;
  tp[0].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[0].coeffs[1][1].dCoord[W] = ww;

  tp[0].coeffs[2][1].dCoord[X] = (r1 + r3)*w;
  tp[0].coeffs[2][1].dCoord[Y] = (r1 + r3)*w;
  tp[0].coeffs[2][1].dCoord[Z] = r3*w;
  tp[0].coeffs[2][1].dCoord[W] = w;

  tp[0].coeffs[0][2].dCoord[X] = 0.0;
  tp[0].coeffs[0][2].dCoord[Y] = r1;
  tp[0].coeffs[0][2].dCoord[Z] = 0.0;
  tp[0].coeffs[0][2].dCoord[W] = 1.0;

  tp[0].coeffs[1][2].dCoord[X] = 0.0;
  tp[0].coeffs[1][2].dCoord[Y] = r1*w;
  tp[0].coeffs[1][2].dCoord[Z] = r3*w;
  tp[0].coeffs[1][2].dCoord[W] = w;

  tp[0].coeffs[2][2].dCoord[X] = 0.0;
  tp[0].coeffs[2][2].dCoord[Y] = (r1 + r3);
  tp[0].coeffs[2][2].dCoord[Z] = r3;
  tp[0].coeffs[2][2].dCoord[W] = 1.0;

  tp[1].coeffs[0][0].dCoord[X] = (r1 + r3);
  tp[1].coeffs[0][0].dCoord[Y] = 0.0;
  tp[1].coeffs[0][0].dCoord[Z] = r3;
  tp[1].coeffs[0][0].dCoord[W] = 1.0;

  tp[1].coeffs[1][0].dCoord[X] = r2*w;
  tp[1].coeffs[1][0].dCoord[Y] = 0.0;
  tp[1].coeffs[1][0].dCoord[Z] = r3*w;
  tp[1].coeffs[1][0].dCoord[W] = w;

  tp[1].coeffs[2][0].dCoord[X] = r2;
  tp[1].coeffs[2][0].dCoord[Y] = 0.0;
  tp[1].coeffs[2][0].dCoord[Z] = 0.0;
  tp[1].coeffs[2][0].dCoord[W] = 1.0;

  tp[1].coeffs[0][1].dCoord[X] = (r1 + r3)*w;
  tp[1].coeffs[0][1].dCoord[Y] = (r1 + r3)*w;
  tp[1].coeffs[0][1].dCoord[Z] = r3*w;
  tp[1].coeffs[0][1].dCoord[W] = w;

  tp[1].coeffs[1][1].dCoord[X] = r2*ww;
  tp[1].coeffs[1][1].dCoord[Y] = r2*ww;
  tp[1].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[1].coeffs[1][1].dCoord[W] = ww;

  tp[1].coeffs[2][1].dCoord[X] = r2*w;
  tp[1].coeffs[2][1].dCoord[Y] = r2*w;
  tp[1].coeffs[2][1].dCoord[Z] = 0.0;
  tp[1].coeffs[2][1].dCoord[W] = w;

  tp[1].coeffs[0][2].dCoord[X] = 0.0;
  tp[1].coeffs[0][2].dCoord[Y] = (r1 + r3);
  tp[1].coeffs[0][2].dCoord[Z] = r3;
  tp[1].coeffs[0][2].dCoord[W] = 1.0;

  tp[1].coeffs[1][2].dCoord[X] = 0.0;
  tp[1].coeffs[1][2].dCoord[Y] = r2*w;
  tp[1].coeffs[1][2].dCoord[Z] = r3*w;
  tp[1].coeffs[1][2].dCoord[W] = w;

  tp[1].coeffs[2][2].dCoord[X] = 0.0;
  tp[1].coeffs[2][2].dCoord[Y] = r2;
  tp[1].coeffs[2][2].dCoord[Z] = 0.0;
  tp[1].coeffs[2][2].dCoord[W] = 1.0;

  tp[2].coeffs[0][0].dCoord[X] = -r1;
  tp[2].coeffs[0][0].dCoord[Y] = 0.0;
  tp[2].coeffs[0][0].dCoord[Z] = 0.0;
  tp[2].coeffs[0][0].dCoord[W] = 1.0;

  tp[2].coeffs[0][1].dCoord[X] = -r1*w;
  tp[2].coeffs[0][1].dCoord[Y] = 0.0;
  tp[2].coeffs[0][1].dCoord[Z] = r3*w;
  tp[2].coeffs[0][1].dCoord[W] = w;

  tp[2].coeffs[0][2].dCoord[X] = -(r1 + r3);
  tp[2].coeffs[0][2].dCoord[Y] = 0.0;
  tp[2].coeffs[0][2].dCoord[Z] = r3;
  tp[2].coeffs[0][2].dCoord[W] = 1.0;

  tp[2].coeffs[1][0].dCoord[X] = -r1*w;
  tp[2].coeffs[1][0].dCoord[Y] = r1*w;
  tp[2].coeffs[1][0].dCoord[Z] = 0.0;
  tp[2].coeffs[1][0].dCoord[W] = w;

  tp[2].coeffs[1][1].dCoord[X] = -r1*ww;
  tp[2].coeffs[1][1].dCoord[Y] = r1*ww;
  tp[2].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[2].coeffs[1][1].dCoord[W] = ww;

  tp[2].coeffs[1][2].dCoord[X] = -(r1 + r3)*w;
  tp[2].coeffs[1][2].dCoord[Y] = (r1 + r3)*w;
  tp[2].coeffs[1][2].dCoord[Z] = r3*w;
  tp[2].coeffs[1][2].dCoord[W] = w;

  tp[2].coeffs[2][0].dCoord[X] = 0.0;
  tp[2].coeffs[2][0].dCoord[Y] = r1;
  tp[2].coeffs[2][0].dCoord[Z] = 0.0;
  tp[2].coeffs[2][0].dCoord[W] = 1.0;

  tp[2].coeffs[2][1].dCoord[X] = 0.0;
  tp[2].coeffs[2][1].dCoord[Y] = r1*w;
  tp[2].coeffs[2][1].dCoord[Z] = r3*w;
  tp[2].coeffs[2][1].dCoord[W] = w;

  tp[2].coeffs[2][2].dCoord[X] = 0.0;
  tp[2].coeffs[2][2].dCoord[Y] = (r1 + r3);
  tp[2].coeffs[2][2].dCoord[Z] = r3;
  tp[2].coeffs[2][2].dCoord[W] = 1.0;

  tp[3].coeffs[0][0].dCoord[X] = -(r1 + r3);
  tp[3].coeffs[0][0].dCoord[Y] = 0.0;
  tp[3].coeffs[0][0].dCoord[Z] = r3;
  tp[3].coeffs[0][0].dCoord[W] = 1.0;

  tp[3].coeffs[0][1].dCoord[X] = -r2*w;
  tp[3].coeffs[0][1].dCoord[Y] = 0.0;
  tp[3].coeffs[0][1].dCoord[Z] = r3*w;
  tp[3].coeffs[0][1].dCoord[W] = w;

  tp[3].coeffs[0][2].dCoord[X] = -r2;
  tp[3].coeffs[0][2].dCoord[Y] = 0.0;
  tp[3].coeffs[0][2].dCoord[Z] = 0.0;
  tp[3].coeffs[0][2].dCoord[W] = 1.0;

  tp[3].coeffs[1][0].dCoord[X] = -(r1 + r3)*w;
  tp[3].coeffs[1][0].dCoord[Y] = (r1 + r3)*w;
  tp[3].coeffs[1][0].dCoord[Z] = r3*w;
  tp[3].coeffs[1][0].dCoord[W] = w;

  tp[3].coeffs[1][1].dCoord[X] = -r2*ww;
  tp[3].coeffs[1][1].dCoord[Y] = r2*ww;
  tp[3].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[3].coeffs[1][1].dCoord[W] = ww;

  tp[3].coeffs[1][2].dCoord[X] = -r2*w;
  tp[3].coeffs[1][2].dCoord[Y] = r2*w;
  tp[3].coeffs[1][2].dCoord[Z] = 0.0;
  tp[3].coeffs[1][2].dCoord[W] = w;

  tp[3].coeffs[2][0].dCoord[X] = 0.0;
  tp[3].coeffs[2][0].dCoord[Y] = (r1 + r3);
  tp[3].coeffs[2][0].dCoord[Z] = r3;
  tp[3].coeffs[2][0].dCoord[W] = 1.0;

  tp[3].coeffs[2][1].dCoord[X] = 0.0;
  tp[3].coeffs[2][1].dCoord[Y] = r2*w;
  tp[3].coeffs[2][1].dCoord[Z] = r3*w;
  tp[3].coeffs[2][1].dCoord[W] = w;

  tp[3].coeffs[2][2].dCoord[X] = 0.0;
  tp[3].coeffs[2][2].dCoord[Y] = r2;
  tp[3].coeffs[2][2].dCoord[Z] = 0.0;
  tp[3].coeffs[2][2].dCoord[W] = 1.0;

  tp[4].coeffs[0][0].dCoord[X] = r1;
  tp[4].coeffs[0][0].dCoord[Y] = 0.0;
  tp[4].coeffs[0][0].dCoord[Z] = 0.0;
  tp[4].coeffs[0][0].dCoord[W] = 1.0;

  tp[4].coeffs[0][1].dCoord[X] = r1*w;
  tp[4].coeffs[0][1].dCoord[Y] = 0.0;
  tp[4].coeffs[0][1].dCoord[Z] = r3*w;
  tp[4].coeffs[0][1].dCoord[W] = w;

  tp[4].coeffs[0][2].dCoord[X] = (r1 + r3);
  tp[4].coeffs[0][2].dCoord[Y] = 0.0;
  tp[4].coeffs[0][2].dCoord[Z] = r3;
  tp[4].coeffs[0][2].dCoord[W] = 1.0;

  tp[4].coeffs[1][0].dCoord[X] = r1*w;
  tp[4].coeffs[1][0].dCoord[Y] = -r1*w;
  tp[4].coeffs[1][0].dCoord[Z] = 0.0;
  tp[4].coeffs[1][0].dCoord[W] = w;

  tp[4].coeffs[1][1].dCoord[X] = r1*ww;
  tp[4].coeffs[1][1].dCoord[Y] = -r1*ww;
  tp[4].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[4].coeffs[1][1].dCoord[W] = ww;

  tp[4].coeffs[1][2].dCoord[X] = (r1 + r3)*w;
  tp[4].coeffs[1][2].dCoord[Y] = -(r1 + r3)*w;
  tp[4].coeffs[1][2].dCoord[Z] = r3*w;
  tp[4].coeffs[1][2].dCoord[W] = w;

  tp[4].coeffs[2][0].dCoord[X] = 0.0;
  tp[4].coeffs[2][0].dCoord[Y] = -r1;
  tp[4].coeffs[2][0].dCoord[Z] = 0.0;
  tp[4].coeffs[2][0].dCoord[W] = 1.0;

  tp[4].coeffs[2][1].dCoord[X] = 0.0;
  tp[4].coeffs[2][1].dCoord[Y] = -r1*w;
  tp[4].coeffs[2][1].dCoord[Z] = r3*w;
  tp[4].coeffs[2][1].dCoord[W] = w;

  tp[4].coeffs[2][2].dCoord[X] = 0.0;
  tp[4].coeffs[2][2].dCoord[Y] = -(r1 + r3);
  tp[4].coeffs[2][2].dCoord[Z] = r3;
  tp[4].coeffs[2][2].dCoord[W] = 1.0;

  tp[5].coeffs[0][0].dCoord[X] = (r1 + r3);
  tp[5].coeffs[0][0].dCoord[Y] = 0.0;
  tp[5].coeffs[0][0].dCoord[Z] = r3;
  tp[5].coeffs[0][0].dCoord[W] = 1.0;

  tp[5].coeffs[0][1].dCoord[X] = r2*w;
  tp[5].coeffs[0][1].dCoord[Y] = 0.0;
  tp[5].coeffs[0][1].dCoord[Z] = r3*w;
  tp[5].coeffs[0][1].dCoord[W] = w;

  tp[5].coeffs[0][2].dCoord[X] = r2;
  tp[5].coeffs[0][2].dCoord[Y] = 0.0;
  tp[5].coeffs[0][2].dCoord[Z] = 0.0;
  tp[5].coeffs[0][2].dCoord[W] = 1.0;

  tp[5].coeffs[1][0].dCoord[X] = (r1 + r3)*w;
  tp[5].coeffs[1][0].dCoord[Y] = -(r1 + r3)*w;
  tp[5].coeffs[1][0].dCoord[Z] = r3*w;
  tp[5].coeffs[1][0].dCoord[W] = w;

  tp[5].coeffs[1][1].dCoord[X] = r2*ww;
  tp[5].coeffs[1][1].dCoord[Y] = -r2*ww;
  tp[5].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[5].coeffs[1][1].dCoord[W] = ww;

  tp[5].coeffs[1][2].dCoord[X] = r2*w;
  tp[5].coeffs[1][2].dCoord[Y] = -r2*w;
  tp[5].coeffs[1][2].dCoord[Z] = 0.0;
  tp[5].coeffs[1][2].dCoord[W] = w;

  tp[5].coeffs[2][0].dCoord[X] = 0.0;
  tp[5].coeffs[2][0].dCoord[Y] = -(r1 + r3);
  tp[5].coeffs[2][0].dCoord[Z] = r3;
  tp[5].coeffs[2][0].dCoord[W] = 1.0;

  tp[5].coeffs[2][1].dCoord[X] = 0.0;
  tp[5].coeffs[2][1].dCoord[Y] = -r2*w;
  tp[5].coeffs[2][1].dCoord[Z] = r3*w;
  tp[5].coeffs[2][1].dCoord[W] = w;

  tp[5].coeffs[2][2].dCoord[X] = 0.0;
  tp[5].coeffs[2][2].dCoord[Y] = -r2;
  tp[5].coeffs[2][2].dCoord[Z] = 0.0;
  tp[5].coeffs[2][2].dCoord[W] = 1.0;

  tp[6].coeffs[0][0].dCoord[X] = -r1;
  tp[6].coeffs[0][0].dCoord[Y] = 0.0;
  tp[6].coeffs[0][0].dCoord[Z] = 0.0;
  tp[6].coeffs[0][0].dCoord[W] = 1.0;

  tp[6].coeffs[1][0].dCoord[X] = -r1*w;
  tp[6].coeffs[1][0].dCoord[Y] = 0.0;
  tp[6].coeffs[1][0].dCoord[Z] = r3*w;
  tp[6].coeffs[1][0].dCoord[W] = w;

  tp[6].coeffs[2][0].dCoord[X] = -(r1 + r3);
  tp[6].coeffs[2][0].dCoord[Y] = 0.0;
  tp[6].coeffs[2][0].dCoord[Z] = r3;
  tp[6].coeffs[2][0].dCoord[W] = 1.0;

  tp[6].coeffs[0][1].dCoord[X] = -r1*w;
  tp[6].coeffs[0][1].dCoord[Y] = -r1*w;
  tp[6].coeffs[0][1].dCoord[Z] = 0.0;
  tp[6].coeffs[0][1].dCoord[W] = w;

  tp[6].coeffs[1][1].dCoord[X] = -r1*ww;
  tp[6].coeffs[1][1].dCoord[Y] = -r1*ww;
  tp[6].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[6].coeffs[1][1].dCoord[W] = ww;

  tp[6].coeffs[2][1].dCoord[X] = -(r1 + r3)*w;
  tp[6].coeffs[2][1].dCoord[Y] = -(r1 + r3)*w;
  tp[6].coeffs[2][1].dCoord[Z] = r3*w;
  tp[6].coeffs[2][1].dCoord[W] = w;

  tp[6].coeffs[0][2].dCoord[X] = 0.0;
  tp[6].coeffs[0][2].dCoord[Y] = -r1;
  tp[6].coeffs[0][2].dCoord[Z] = 0.0;
  tp[6].coeffs[0][2].dCoord[W] = 1.0;

  tp[6].coeffs[1][2].dCoord[X] = 0.0;
  tp[6].coeffs[1][2].dCoord[Y] = -r1*w;
  tp[6].coeffs[1][2].dCoord[Z] = r3*w;
  tp[6].coeffs[1][2].dCoord[W] = w;

  tp[6].coeffs[2][2].dCoord[X] = 0.0;
  tp[6].coeffs[2][2].dCoord[Y] = -(r1 + r3);
  tp[6].coeffs[2][2].dCoord[Z] = r3;
  tp[6].coeffs[2][2].dCoord[W] = 1.0;

  tp[7].coeffs[0][0].dCoord[X] = -(r1 + r3);
  tp[7].coeffs[0][0].dCoord[Y] = 0.0;
  tp[7].coeffs[0][0].dCoord[Z] = r3;
  tp[7].coeffs[0][0].dCoord[W] = 1.0;

  tp[7].coeffs[1][0].dCoord[X] = -r2*w;
  tp[7].coeffs[1][0].dCoord[Y] = 0.0;
  tp[7].coeffs[1][0].dCoord[Z] = r3*w;
  tp[7].coeffs[1][0].dCoord[W] = w;

  tp[7].coeffs[2][0].dCoord[X] = -r2;
  tp[7].coeffs[2][0].dCoord[Y] = 0.0;
  tp[7].coeffs[2][0].dCoord[Z] = 0.0;
  tp[7].coeffs[2][0].dCoord[W] = 1.0;

  tp[7].coeffs[0][1].dCoord[X] = -(r1 + r3)*w;
  tp[7].coeffs[0][1].dCoord[Y] = -(r1 + r3)*w;
  tp[7].coeffs[0][1].dCoord[Z] = r3*w;
  tp[7].coeffs[0][1].dCoord[W] = w;

  tp[7].coeffs[1][1].dCoord[X] = -r2*ww;
  tp[7].coeffs[1][1].dCoord[Y] = -r2*ww;
  tp[7].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[7].coeffs[1][1].dCoord[W] = ww;

  tp[7].coeffs[2][1].dCoord[X] = -r2*w;
  tp[7].coeffs[2][1].dCoord[Y] = -r2*w;
  tp[7].coeffs[2][1].dCoord[Z] = 0.0;
  tp[7].coeffs[2][1].dCoord[W] = w;

  tp[7].coeffs[0][2].dCoord[X] = 0.0;
  tp[7].coeffs[0][2].dCoord[Y] = -(r1 + r3);
  tp[7].coeffs[0][2].dCoord[Z] = r3;
  tp[7].coeffs[0][2].dCoord[W] = 1.0;

  tp[7].coeffs[1][2].dCoord[X] = 0.0;
  tp[7].coeffs[1][2].dCoord[Y] = -r2*w;
  tp[7].coeffs[1][2].dCoord[Z] = r3*w;
  tp[7].coeffs[1][2].dCoord[W] = w;

  tp[7].coeffs[2][2].dCoord[X] = 0.0;
  tp[7].coeffs[2][2].dCoord[Y] = -r2;
  tp[7].coeffs[2][2].dCoord[Z] = 0.0;
  tp[7].coeffs[2][2].dCoord[W] = 1.0;

  tp[8].coeffs[0][0].dCoord[X] = r1;
  tp[8].coeffs[0][0].dCoord[Y] = 0.0;
  tp[8].coeffs[0][0].dCoord[Z] = 0.0;
  tp[8].coeffs[0][0].dCoord[W] = 1.0;

  tp[8].coeffs[0][1].dCoord[X] = r1*w;
  tp[8].coeffs[0][1].dCoord[Y] = 0.0;
  tp[8].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[8].coeffs[0][1].dCoord[W] = w;

  tp[8].coeffs[0][2].dCoord[X] = (r1 + r3);
  tp[8].coeffs[0][2].dCoord[Y] = 0.0;
  tp[8].coeffs[0][2].dCoord[Z] = -r3;
  tp[8].coeffs[0][2].dCoord[W] = 1.0;

  tp[8].coeffs[1][0].dCoord[X] = r1*w;
  tp[8].coeffs[1][0].dCoord[Y] = r1*w;
  tp[8].coeffs[1][0].dCoord[Z] = 0.0;
  tp[8].coeffs[1][0].dCoord[W] = w;

  tp[8].coeffs[1][1].dCoord[X] = r1*ww;
  tp[8].coeffs[1][1].dCoord[Y] = r1*ww;
  tp[8].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[8].coeffs[1][1].dCoord[W] = ww;

  tp[8].coeffs[1][2].dCoord[X] = (r1 + r3)*w;
  tp[8].coeffs[1][2].dCoord[Y] = (r1 + r3)*w;
  tp[8].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[8].coeffs[1][2].dCoord[W] = w;

  tp[8].coeffs[2][0].dCoord[X] = 0.0;
  tp[8].coeffs[2][0].dCoord[Y] = r1;
  tp[8].coeffs[2][0].dCoord[Z] = 0.0;
  tp[8].coeffs[2][0].dCoord[W] = 1.0;

  tp[8].coeffs[2][1].dCoord[X] = 0.0;
  tp[8].coeffs[2][1].dCoord[Y] = r1*w;
  tp[8].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[8].coeffs[2][1].dCoord[W] = w;

  tp[8].coeffs[2][2].dCoord[X] = 0.0;
  tp[8].coeffs[2][2].dCoord[Y] = (r1 + r3);
  tp[8].coeffs[2][2].dCoord[Z] = -r3;
  tp[8].coeffs[2][2].dCoord[W] = 1.0;

  tp[9].coeffs[0][0].dCoord[X] = (r1 + r3);
  tp[9].coeffs[0][0].dCoord[Y] = 0.0;
  tp[9].coeffs[0][0].dCoord[Z] = -r3;
  tp[9].coeffs[0][0].dCoord[W] = 1.0;

  tp[9].coeffs[0][1].dCoord[X] = r2*w;
  tp[9].coeffs[0][1].dCoord[Y] = 0.0;
  tp[9].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[9].coeffs[0][1].dCoord[W] = w;

  tp[9].coeffs[0][2].dCoord[X] = r2;
  tp[9].coeffs[0][2].dCoord[Y] = 0.0;
  tp[9].coeffs[0][2].dCoord[Z] = 0.0;
  tp[9].coeffs[0][2].dCoord[W] = 1.0;

  tp[9].coeffs[1][0].dCoord[X] = (r1 + r3)*w;
  tp[9].coeffs[1][0].dCoord[Y] = (r1 + r3)*w;
  tp[9].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[9].coeffs[1][0].dCoord[W] = w;

  tp[9].coeffs[1][1].dCoord[X] = r2*ww;
  tp[9].coeffs[1][1].dCoord[Y] = r2*ww;
  tp[9].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[9].coeffs[1][1].dCoord[W] = ww;

  tp[9].coeffs[1][2].dCoord[X] = r2*w;
  tp[9].coeffs[1][2].dCoord[Y] = r2*w;
  tp[9].coeffs[1][2].dCoord[Z] = 0.0;
  tp[9].coeffs[1][2].dCoord[W] = w;

  tp[9].coeffs[2][0].dCoord[X] = 0.0;
  tp[9].coeffs[2][0].dCoord[Y] = (r1 + r3);
  tp[9].coeffs[2][0].dCoord[Z] = -r3;
  tp[9].coeffs[2][0].dCoord[W] = 1.0;

  tp[9].coeffs[2][1].dCoord[X] = 0.0;
  tp[9].coeffs[2][1].dCoord[Y] = r2*w;
  tp[9].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[9].coeffs[2][1].dCoord[W] = w;

  tp[9].coeffs[2][2].dCoord[X] = 0.0;
  tp[9].coeffs[2][2].dCoord[Y] = r2;
  tp[9].coeffs[2][2].dCoord[Z] = 0.0;
  tp[9].coeffs[2][2].dCoord[W] = 1.0;

  tp[10].coeffs[0][0].dCoord[X] = -r1;
  tp[10].coeffs[0][0].dCoord[Y] = 0.0;
  tp[10].coeffs[0][0].dCoord[Z] = 0.0;
  tp[10].coeffs[0][0].dCoord[W] = 1.0;

  tp[10].coeffs[1][0].dCoord[X] = -r1*w;
  tp[10].coeffs[1][0].dCoord[Y] = 0.0;
  tp[10].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[10].coeffs[1][0].dCoord[W] = w;

  tp[10].coeffs[2][0].dCoord[X] = -(r1 + r3);
  tp[10].coeffs[2][0].dCoord[Y] = 0.0;
  tp[10].coeffs[2][0].dCoord[Z] = -r3;
  tp[10].coeffs[2][0].dCoord[W] = 1.0;

  tp[10].coeffs[0][1].dCoord[X] = -r1*w;
  tp[10].coeffs[0][1].dCoord[Y] = r1*w;
  tp[10].coeffs[0][1].dCoord[Z] = 0.0;
  tp[10].coeffs[0][1].dCoord[W] = w;

  tp[10].coeffs[1][1].dCoord[X] = -r1*ww;
  tp[10].coeffs[1][1].dCoord[Y] = r1*ww;
  tp[10].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[10].coeffs[1][1].dCoord[W] = ww;

  tp[10].coeffs[2][1].dCoord[X] = -(r1 + r3)*w;
  tp[10].coeffs[2][1].dCoord[Y] = (r1 + r3)*w;
  tp[10].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[10].coeffs[2][1].dCoord[W] = w;

  tp[10].coeffs[0][2].dCoord[X] = 0.0;
  tp[10].coeffs[0][2].dCoord[Y] = r1;
  tp[10].coeffs[0][2].dCoord[Z] = 0.0;
  tp[10].coeffs[0][2].dCoord[W] = 1.0;

  tp[10].coeffs[1][2].dCoord[X] = 0.0;
  tp[10].coeffs[1][2].dCoord[Y] = r1*w;
  tp[10].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[10].coeffs[1][2].dCoord[W] = w;

  tp[10].coeffs[2][2].dCoord[X] = 0.0;
  tp[10].coeffs[2][2].dCoord[Y] = (r1 + r3);
  tp[10].coeffs[2][2].dCoord[Z] = -r3;
  tp[10].coeffs[2][2].dCoord[W] = 1.0;

  tp[11].coeffs[0][0].dCoord[X] = -(r1 + r3);
  tp[11].coeffs[0][0].dCoord[Y] = 0.0;
  tp[11].coeffs[0][0].dCoord[Z] = -r3;
  tp[11].coeffs[0][0].dCoord[W] = 1.0;

  tp[11].coeffs[1][0].dCoord[X] = -r2*w;
  tp[11].coeffs[1][0].dCoord[Y] = 0.0;
  tp[11].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[11].coeffs[1][0].dCoord[W] = w;

  tp[11].coeffs[2][0].dCoord[X] = -r2;
  tp[11].coeffs[2][0].dCoord[Y] = 0.0;
  tp[11].coeffs[2][0].dCoord[Z] = 0.0;
  tp[11].coeffs[2][0].dCoord[W] = 1.0;

  tp[11].coeffs[0][1].dCoord[X] = -(r1 + r3)*w;
  tp[11].coeffs[0][1].dCoord[Y] = (r1 + r3)*w;
  tp[11].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[11].coeffs[0][1].dCoord[W] = w;

  tp[11].coeffs[1][1].dCoord[X] = -r2*ww;
  tp[11].coeffs[1][1].dCoord[Y] = r2*ww;
  tp[11].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[11].coeffs[1][1].dCoord[W] = ww;

  tp[11].coeffs[2][1].dCoord[X] = -r2*w;
  tp[11].coeffs[2][1].dCoord[Y] = r2*w;
  tp[11].coeffs[2][1].dCoord[Z] = 0.0;
  tp[11].coeffs[2][1].dCoord[W] = w;

  tp[11].coeffs[0][2].dCoord[X] = 0.0;
  tp[11].coeffs[0][2].dCoord[Y] = (r1 + r3);
  tp[11].coeffs[0][2].dCoord[Z] = -r3;
  tp[11].coeffs[0][2].dCoord[W] = 1.0;

  tp[11].coeffs[1][2].dCoord[X] = 0.0;
  tp[11].coeffs[1][2].dCoord[Y] = r2*w;
  tp[11].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[11].coeffs[1][2].dCoord[W] = w;

  tp[11].coeffs[2][2].dCoord[X] = 0.0;
  tp[11].coeffs[2][2].dCoord[Y] = r2;
  tp[11].coeffs[2][2].dCoord[Z] = 0.0;
  tp[11].coeffs[2][2].dCoord[W] = 1.0;

  tp[12].coeffs[0][0].dCoord[X] = r1;
  tp[12].coeffs[0][0].dCoord[Y] = 0.0;
  tp[12].coeffs[0][0].dCoord[Z] = 0.0;
  tp[12].coeffs[0][0].dCoord[W] = 1.0;

  tp[12].coeffs[1][0].dCoord[X] = r1*w;
  tp[12].coeffs[1][0].dCoord[Y] = 0.0;
  tp[12].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[12].coeffs[1][0].dCoord[W] = w;

  tp[12].coeffs[2][0].dCoord[X] = (r1 + r3);
  tp[12].coeffs[2][0].dCoord[Y] = 0.0;
  tp[12].coeffs[2][0].dCoord[Z] = -r3;
  tp[12].coeffs[2][0].dCoord[W] = 1.0;

  tp[12].coeffs[0][1].dCoord[X] = r1*w;
  tp[12].coeffs[0][1].dCoord[Y] = -r1*w;
  tp[12].coeffs[0][1].dCoord[Z] = 0.0;
  tp[12].coeffs[0][1].dCoord[W] = w;

  tp[12].coeffs[1][1].dCoord[X] = r1*ww;
  tp[12].coeffs[1][1].dCoord[Y] = -r1*ww;
  tp[12].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[12].coeffs[1][1].dCoord[W] = ww;

  tp[12].coeffs[2][1].dCoord[X] = (r1 + r3)*w;
  tp[12].coeffs[2][1].dCoord[Y] = -(r1 + r3)*w;
  tp[12].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[12].coeffs[2][1].dCoord[W] = w;

  tp[12].coeffs[0][2].dCoord[X] = 0.0;
  tp[12].coeffs[0][2].dCoord[Y] = -r1;
  tp[12].coeffs[0][2].dCoord[Z] = 0.0;
  tp[12].coeffs[0][2].dCoord[W] = 1.0;

  tp[12].coeffs[1][2].dCoord[X] = 0.0;
  tp[12].coeffs[1][2].dCoord[Y] = -r1*w;
  tp[12].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[12].coeffs[1][2].dCoord[W] = w;

  tp[12].coeffs[2][2].dCoord[X] = 0.0;
  tp[12].coeffs[2][2].dCoord[Y] = -(r1 + r3);
  tp[12].coeffs[2][2].dCoord[Z] = -r3;
  tp[12].coeffs[2][2].dCoord[W] = 1.0;

  tp[13].coeffs[0][0].dCoord[X] = (r1 + r3);
  tp[13].coeffs[0][0].dCoord[Y] = 0.0;
  tp[13].coeffs[0][0].dCoord[Z] = -r3;
  tp[13].coeffs[0][0].dCoord[W] = 1.0;

  tp[13].coeffs[1][0].dCoord[X] = r2*w;
  tp[13].coeffs[1][0].dCoord[Y] = 0.0;
  tp[13].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[13].coeffs[1][0].dCoord[W] = w;

  tp[13].coeffs[2][0].dCoord[X] = r2;
  tp[13].coeffs[2][0].dCoord[Y] = 0.0;
  tp[13].coeffs[2][0].dCoord[Z] = 0.0;
  tp[13].coeffs[2][0].dCoord[W] = 1.0;

  tp[13].coeffs[0][1].dCoord[X] = (r1 + r3)*w;
  tp[13].coeffs[0][1].dCoord[Y] = -(r1 + r3)*w;
  tp[13].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[13].coeffs[0][1].dCoord[W] = w;

  tp[13].coeffs[1][1].dCoord[X] = r2*ww;
  tp[13].coeffs[1][1].dCoord[Y] = -r2*ww;
  tp[13].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[13].coeffs[1][1].dCoord[W] = ww;

  tp[13].coeffs[2][1].dCoord[X] = r2*w;
  tp[13].coeffs[2][1].dCoord[Y] = -r2*w;
  tp[13].coeffs[2][1].dCoord[Z] = 0.0;
  tp[13].coeffs[2][1].dCoord[W] = w;

  tp[13].coeffs[0][2].dCoord[X] = 0.0;
  tp[13].coeffs[0][2].dCoord[Y] = -(r1 + r3);
  tp[13].coeffs[0][2].dCoord[Z] = -r3;
  tp[13].coeffs[0][2].dCoord[W] = 1.0;

  tp[13].coeffs[1][2].dCoord[X] = 0.0;
  tp[13].coeffs[1][2].dCoord[Y] = -r2*w;
  tp[13].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[13].coeffs[1][2].dCoord[W] = w;

  tp[13].coeffs[2][2].dCoord[X] = 0.0;
  tp[13].coeffs[2][2].dCoord[Y] = -r2;
  tp[13].coeffs[2][2].dCoord[Z] = 0.0;
  tp[13].coeffs[2][2].dCoord[W] = 1.0;

  tp[14].coeffs[0][0].dCoord[X] = -r1;
  tp[14].coeffs[0][0].dCoord[Y] = 0.0;
  tp[14].coeffs[0][0].dCoord[Z] = 0.0;
  tp[14].coeffs[0][0].dCoord[W] = 1.0;

  tp[14].coeffs[0][1].dCoord[X] = -r1*w;
  tp[14].coeffs[0][1].dCoord[Y] = 0.0;
  tp[14].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[14].coeffs[0][1].dCoord[W] = w;

  tp[14].coeffs[0][2].dCoord[X] = -(r1 + r3);
  tp[14].coeffs[0][2].dCoord[Y] = 0.0;
  tp[14].coeffs[0][2].dCoord[Z] = -r3;
  tp[14].coeffs[0][2].dCoord[W] = 1.0;

  tp[14].coeffs[1][0].dCoord[X] = -r1*w;
  tp[14].coeffs[1][0].dCoord[Y] = -r1*w;
  tp[14].coeffs[1][0].dCoord[Z] = 0.0;
  tp[14].coeffs[1][0].dCoord[W] = w;

  tp[14].coeffs[1][1].dCoord[X] = -r1*ww;
  tp[14].coeffs[1][1].dCoord[Y] = -r1*ww;
  tp[14].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[14].coeffs[1][1].dCoord[W] = ww;

  tp[14].coeffs[1][2].dCoord[X] = -(r1 + r3)*w;
  tp[14].coeffs[1][2].dCoord[Y] = -(r1 + r3)*w;
  tp[14].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[14].coeffs[1][2].dCoord[W] = w;

  tp[14].coeffs[2][0].dCoord[X] = 0.0;
  tp[14].coeffs[2][0].dCoord[Y] = -r1;
  tp[14].coeffs[2][0].dCoord[Z] = 0.0;
  tp[14].coeffs[2][0].dCoord[W] = 1.0;

  tp[14].coeffs[2][1].dCoord[X] = 0.0;
  tp[14].coeffs[2][1].dCoord[Y] = -r1*w;
  tp[14].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[14].coeffs[2][1].dCoord[W] = w;

  tp[14].coeffs[2][2].dCoord[X] = 0.0;
  tp[14].coeffs[2][2].dCoord[Y] = -(r1 + r3);
  tp[14].coeffs[2][2].dCoord[Z] = -r3;
  tp[14].coeffs[2][2].dCoord[W] = 1.0;

  tp[15].coeffs[0][0].dCoord[X] = -(r1 + r3);
  tp[15].coeffs[0][0].dCoord[Y] = 0.0;
  tp[15].coeffs[0][0].dCoord[Z] = -r3;
  tp[15].coeffs[0][0].dCoord[W] = 1.0;

  tp[15].coeffs[0][1].dCoord[X] = -r2*w;
  tp[15].coeffs[0][1].dCoord[Y] = 0.0;
  tp[15].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[15].coeffs[0][1].dCoord[W] = w;

  tp[15].coeffs[0][2].dCoord[X] = -r2;
  tp[15].coeffs[0][2].dCoord[Y] = 0.0;
  tp[15].coeffs[0][2].dCoord[Z] = 0.0;
  tp[15].coeffs[0][2].dCoord[W] = 1.0;

  tp[15].coeffs[1][0].dCoord[X] = -(r1 + r3)*w;
  tp[15].coeffs[1][0].dCoord[Y] = -(r1 + r3)*w;
  tp[15].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[15].coeffs[1][0].dCoord[W] = w;

  tp[15].coeffs[1][1].dCoord[X] = -r2*ww;
  tp[15].coeffs[1][1].dCoord[Y] = -r2*ww;
  tp[15].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[15].coeffs[1][1].dCoord[W] = ww;

  tp[15].coeffs[1][2].dCoord[X] = -r2*w;
  tp[15].coeffs[1][2].dCoord[Y] = -r2*w;
  tp[15].coeffs[1][2].dCoord[Z] = 0.0;
  tp[15].coeffs[1][2].dCoord[W] = w;

  tp[15].coeffs[2][0].dCoord[X] = 0.0;
  tp[15].coeffs[2][0].dCoord[Y] = -(r1 + r3);
  tp[15].coeffs[2][0].dCoord[Z] = -r3;
  tp[15].coeffs[2][0].dCoord[W] = 1.0;

  tp[15].coeffs[2][1].dCoord[X] = 0.0;
  tp[15].coeffs[2][1].dCoord[Y] = -r2*w;
  tp[15].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[15].coeffs[2][1].dCoord[W] = w;

  tp[15].coeffs[2][2].dCoord[X] = 0.0;
  tp[15].coeffs[2][2].dCoord[Y] = -r2;
  tp[15].coeffs[2][2].dCoord[Z] = 0.0;
  tp[15].coeffs[2][2].dCoord[W] = 1.0;
}
#else
void FillCircPts(rad)
double rad;
{
  double w, w1;

  w = 0.5;
  w1 = sqrt(3.0) / 2.0;

  CircPts[0].dCoord[0] = 0.0;
  CircPts[0].dCoord[1] = -rad;
  CircPts[0].dCoord[2] = 0.0;
  CircPts[0].dCoord[3] = 1.0;

  CircPts[1].dCoord[0] = -w1*rad;
  CircPts[1].dCoord[1] = -w*rad;
  CircPts[1].dCoord[2] = 0.0;
  CircPts[1].dCoord[3] = w;

  CircPts[2].dCoord[0] = -w1*rad;
  CircPts[2].dCoord[1] = w*rad;
  CircPts[2].dCoord[2] = 0.0;
  CircPts[2].dCoord[3] = 1.0;

  CircPts[3].dCoord[0] = 0.0;
  CircPts[3].dCoord[1] = rad;
  CircPts[3].dCoord[2] = 0.0;
  CircPts[3].dCoord[3] = w;

  CircPts[4].dCoord[0] = w1*rad;
  CircPts[4].dCoord[1] = w*rad;
  CircPts[4].dCoord[2] = 0.0;
  CircPts[4].dCoord[3] = 1.0;

  CircPts[5].dCoord[0] = w1*rad;
  CircPts[5].dCoord[1] = -w*rad;
  CircPts[5].dCoord[2] = 0.0;
  CircPts[5].dCoord[3] = w;

  CircPts[6] = CircPts[0];
}

void GetMatForAngle(TmpMat, theta, Rad)
double **TmpMat;
double theta, Rad;
{
  TmpMat[0][0] = cos(theta);
  TmpMat[0][2] = sin(theta);
  TmpMat[0][3] = Rad*TmpMat[0][0];
  TmpMat[1][0] = TmpMat[0][2];
  TmpMat[1][2] = -TmpMat[0][0];
  TmpMat[1][3] = Rad*TmpMat[0][2];
}

static POINT4D MatrMult(Mat, p4d, fac)
double **Mat;
POINT4D *p4d;
double fac;
{
  POINT4D res;
  int i, j, k;
  
  for (i=0; i<4; i++) {
    res.dCoord[i] = 0.0;
    for (j=0; j<4; j++) {
      res.dCoord[i] += Mat[i][j]*(p4d->dCoord[j]);
    }
  }
  res.dCoord[2] *= fac;
  res.dCoord[3] *= fac;
  return res;
}

void FillTorCntrlPts(tp, indx, TmpMat, col)
TENSOR_PATCH *tp;
int indx, col;
double **TmpMat;
{
  int i, j, k;
  int act_idx, cnt, row;
  double mult_fact;

  if ((col < 0) || (col > 2)) {
    printf("FillTorCntrlPts: Bad column value\n");
    exit(-1);
  }

  i = cnt = 0;
  while (i < 7) {
    if (cnt < 3)
      act_idx = indx;
    else {
      if (cnt < 6)
	act_idx = indx + 1;
      else 
	act_idx = indx + 2;
    }
    
    row = cnt % 3;
    if (col == 1)
      mult_fact = 0.5;
    else 
      mult_fact = 1.0;

    tp[act_idx].coeffs[row][col] = MatrMult(TmpMat, &CircPts[i],
					    mult_fact);
/*
    mult_fact = 1.0;
    if (row == 1) {
      if (col != 1)
	mult_fact = 0.5;
      else 
	mult_fact = 0.25;
    } else {
      if (col == 1)
	mult_fact = 0.5;
    }

    for (j=0; j<4; j++)
      tp[act_idx].coeffs[row][col].dCoord[j] *= mult_fact;
*/

    cnt++;
    if ((cnt != 3) && (cnt != 6))
      i++;
  }
}
  
void GetNormTorusControlPts(tp, torus_iradius, torus_oradius)
TENSOR_PATCH *tp;
double torus_iradius, torus_oradius;
{
  double w, f, w1, ww, r1, r2, r3;
  int i, j;
  double Ang, StepAng;

  Ang = -M_PI/2.0;
  StepAng = M_PI/3.0;
  w = 0.5;
  ww = 0.25;
  w1 = sqrt(3.0) / 2.0;
  f = sqrt(3.0) - 1;
  r1 = torus_iradius;
  r2 = torus_oradius;
  r3 = (r2 - r1)/ 2.0;

  FillCircPts(r3);

  ALLOCMAT(TmpMat, 4, 4, double);
  for (i=0; i<4; i++) 
    for (j=0; j<4; j++)
      TmpMat[i][j] = 0.0;
  TmpMat[2][1] = 1.0;
  TmpMat[3][3] = 1.0;

  for (i=0; i<3; i++) {
    GetMatForAngle(TmpMat, Ang, (r1+r3));
    FillTorCntrlPts(tp, 3*i, TmpMat, 0);

    Ang += StepAng;
    GetMatForAngle(TmpMat, Ang, (r1+r3));
    FillTorCntrlPts(tp, 3*i, TmpMat, 1);

    Ang += StepAng;
    GetMatForAngle(TmpMat, Ang, (r1+r3));
    FillTorCntrlPts(tp, 3*i, TmpMat, 2);
  }
/*
  tp[0].coeffs[0][0].dCoord[X] = 0.0;
  tp[0].coeffs[0][0].dCoord[Y] = -(r1+r3);
  tp[0].coeffs[0][0].dCoord[Z] = -r3;
  tp[0].coeffs[0][0].dCoord[W] = 1.0;

  tp[0].coeffs[1][0].dCoord[X] = 0.0;
  tp[0].coeffs[1][0].dCoord[Y] = -(r1 - f*r3)*w;
  tp[0].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[0].coeffs[1][0].dCoord[W] = w;

  tp[0].coeffs[2][0].dCoord[X] = 0.0;
  tp[0].coeffs[2][0].dCoord[Y] = -(r1 + (1-w1)*r3);
  tp[0].coeffs[2][0].dCoord[Z] = r3*w;
  tp[0].coeffs[2][0].dCoord[W] = 1.0;

  tp[0].coeffs[0][1].dCoord[X] = (r1+r3)*w1;
  tp[0].coeffs[0][1].dCoord[Y] = -(r1+r3)*w;
  tp[0].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[0].coeffs[0][1].dCoord[W] = w;

  tp[0].coeffs[1][1].dCoord[X] = (r1 + (1-w1)*r3)*w1;
  tp[0].coeffs[1][1].dCoord[Y] = 
  tp[0].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[0].coeffs[1][1].dCoord[W] = ww;

  tp[0].coeffs[2][1].dCoord[X] = (r1 + (1-w1)*r3)*w1;
  tp[0].coeffs[2][1].dCoord[Y] = -(r1 + (1-w1)*r3)*w;
  tp[0].coeffs[2][1].dCoord[Z] = r3*ww;
  tp[0].coeffs[2][1].dCoord[W] = w;

  tp[0].coeffs[0][2].dCoord[X] = (r1+r3)*w1;
  tp[0].coeffs[0][2].dCoord[Y] = (r1+r3)*w;
  tp[0].coeffs[0][2].dCoord[Z] = -r3;
  tp[0].coeffs[0][2].dCoord[W] = 1.0;

  tp[0].coeffs[1][2].dCoord[X] = (r1 - f*r3)*w1*w;
  tp[0].coeffs[1][2].dCoord[Y] = (r1 - f*r3)*ww;
  tp[0].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[0].coeffs[1][2].dCoord[W] = w;

  tp[0].coeffs[2][2].dCoord[X] = (r1 + (1-w1)*r3)*w1;
  tp[0].coeffs[2][2].dCoord[Y] = (r1 + (1-w1)*r3)*w;
  tp[0].coeffs[2][2].dCoord[Z] = r3*w;
  tp[0].coeffs[2][2].dCoord[W] = 1.0;

  tp[1].coeffs[0][0].dCoord[X] = (r1 + r3);
  tp[1].coeffs[0][0].dCoord[Y] = 0.0;
  tp[1].coeffs[0][0].dCoord[Z] = r3;
  tp[1].coeffs[0][0].dCoord[W] = 1.0;

  tp[1].coeffs[1][0].dCoord[X] = r2*w;
  tp[1].coeffs[1][0].dCoord[Y] = 0.0;
  tp[1].coeffs[1][0].dCoord[Z] = r3*w;
  tp[1].coeffs[1][0].dCoord[W] = w;

  tp[1].coeffs[2][0].dCoord[X] = r2;
  tp[1].coeffs[2][0].dCoord[Y] = 0.0;
  tp[1].coeffs[2][0].dCoord[Z] = 0.0;
  tp[1].coeffs[2][0].dCoord[W] = 1.0;

  tp[1].coeffs[0][1].dCoord[X] = (r1 + r3)*w;
  tp[1].coeffs[0][1].dCoord[Y] = (r1 + r3)*w;
  tp[1].coeffs[0][1].dCoord[Z] = r3*w;
  tp[1].coeffs[0][1].dCoord[W] = w;

  tp[1].coeffs[1][1].dCoord[X] = r2*ww;
  tp[1].coeffs[1][1].dCoord[Y] = r2*ww;
  tp[1].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[1].coeffs[1][1].dCoord[W] = ww;

  tp[1].coeffs[2][1].dCoord[X] = r2*w;
  tp[1].coeffs[2][1].dCoord[Y] = r2*w;
  tp[1].coeffs[2][1].dCoord[Z] = 0.0;
  tp[1].coeffs[2][1].dCoord[W] = w;

  tp[1].coeffs[0][2].dCoord[X] = 0.0;
  tp[1].coeffs[0][2].dCoord[Y] = (r1 + r3);
  tp[1].coeffs[0][2].dCoord[Z] = r3;
  tp[1].coeffs[0][2].dCoord[W] = 1.0;

  tp[1].coeffs[1][2].dCoord[X] = 0.0;
  tp[1].coeffs[1][2].dCoord[Y] = r2*w;
  tp[1].coeffs[1][2].dCoord[Z] = r3*w;
  tp[1].coeffs[1][2].dCoord[W] = w;

  tp[1].coeffs[2][2].dCoord[X] = 0.0;
  tp[1].coeffs[2][2].dCoord[Y] = r2;
  tp[1].coeffs[2][2].dCoord[Z] = 0.0;
  tp[1].coeffs[2][2].dCoord[W] = 1.0;

  tp[2].coeffs[0][0].dCoord[X] = -r1;
  tp[2].coeffs[0][0].dCoord[Y] = 0.0;
  tp[2].coeffs[0][0].dCoord[Z] = 0.0;
  tp[2].coeffs[0][0].dCoord[W] = 1.0;

  tp[2].coeffs[0][1].dCoord[X] = -r1*w;
  tp[2].coeffs[0][1].dCoord[Y] = 0.0;
  tp[2].coeffs[0][1].dCoord[Z] = r3*w;
  tp[2].coeffs[0][1].dCoord[W] = w;

  tp[2].coeffs[0][2].dCoord[X] = -(r1 + r3);
  tp[2].coeffs[0][2].dCoord[Y] = 0.0;
  tp[2].coeffs[0][2].dCoord[Z] = r3;
  tp[2].coeffs[0][2].dCoord[W] = 1.0;

  tp[2].coeffs[1][0].dCoord[X] = -r1*w;
  tp[2].coeffs[1][0].dCoord[Y] = r1*w;
  tp[2].coeffs[1][0].dCoord[Z] = 0.0;
  tp[2].coeffs[1][0].dCoord[W] = w;

  tp[2].coeffs[1][1].dCoord[X] = -r1*ww;
  tp[2].coeffs[1][1].dCoord[Y] = r1*ww;
  tp[2].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[2].coeffs[1][1].dCoord[W] = ww;

  tp[2].coeffs[1][2].dCoord[X] = -(r1 + r3)*w;
  tp[2].coeffs[1][2].dCoord[Y] = (r1 + r3)*w;
  tp[2].coeffs[1][2].dCoord[Z] = r3*w;
  tp[2].coeffs[1][2].dCoord[W] = w;

  tp[2].coeffs[2][0].dCoord[X] = 0.0;
  tp[2].coeffs[2][0].dCoord[Y] = r1;
  tp[2].coeffs[2][0].dCoord[Z] = 0.0;
  tp[2].coeffs[2][0].dCoord[W] = 1.0;

  tp[2].coeffs[2][1].dCoord[X] = 0.0;
  tp[2].coeffs[2][1].dCoord[Y] = r1*w;
  tp[2].coeffs[2][1].dCoord[Z] = r3*w;
  tp[2].coeffs[2][1].dCoord[W] = w;

  tp[2].coeffs[2][2].dCoord[X] = 0.0;
  tp[2].coeffs[2][2].dCoord[Y] = (r1 + r3);
  tp[2].coeffs[2][2].dCoord[Z] = r3;
  tp[2].coeffs[2][2].dCoord[W] = 1.0;

  tp[3].coeffs[0][0].dCoord[X] = -(r1 + r3);
  tp[3].coeffs[0][0].dCoord[Y] = 0.0;
  tp[3].coeffs[0][0].dCoord[Z] = r3;
  tp[3].coeffs[0][0].dCoord[W] = 1.0;

  tp[3].coeffs[0][1].dCoord[X] = -r2*w;
  tp[3].coeffs[0][1].dCoord[Y] = 0.0;
  tp[3].coeffs[0][1].dCoord[Z] = r3*w;
  tp[3].coeffs[0][1].dCoord[W] = w;

  tp[3].coeffs[0][2].dCoord[X] = -r2;
  tp[3].coeffs[0][2].dCoord[Y] = 0.0;
  tp[3].coeffs[0][2].dCoord[Z] = 0.0;
  tp[3].coeffs[0][2].dCoord[W] = 1.0;

  tp[3].coeffs[1][0].dCoord[X] = -(r1 + r3)*w;
  tp[3].coeffs[1][0].dCoord[Y] = (r1 + r3)*w;
  tp[3].coeffs[1][0].dCoord[Z] = r3*w;
  tp[3].coeffs[1][0].dCoord[W] = w;

  tp[3].coeffs[1][1].dCoord[X] = -r2*ww;
  tp[3].coeffs[1][1].dCoord[Y] = r2*ww;
  tp[3].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[3].coeffs[1][1].dCoord[W] = ww;

  tp[3].coeffs[1][2].dCoord[X] = -r2*w;
  tp[3].coeffs[1][2].dCoord[Y] = r2*w;
  tp[3].coeffs[1][2].dCoord[Z] = 0.0;
  tp[3].coeffs[1][2].dCoord[W] = w;

  tp[3].coeffs[2][0].dCoord[X] = 0.0;
  tp[3].coeffs[2][0].dCoord[Y] = (r1 + r3);
  tp[3].coeffs[2][0].dCoord[Z] = r3;
  tp[3].coeffs[2][0].dCoord[W] = 1.0;

  tp[3].coeffs[2][1].dCoord[X] = 0.0;
  tp[3].coeffs[2][1].dCoord[Y] = r2*w;
  tp[3].coeffs[2][1].dCoord[Z] = r3*w;
  tp[3].coeffs[2][1].dCoord[W] = w;

  tp[3].coeffs[2][2].dCoord[X] = 0.0;
  tp[3].coeffs[2][2].dCoord[Y] = r2;
  tp[3].coeffs[2][2].dCoord[Z] = 0.0;
  tp[3].coeffs[2][2].dCoord[W] = 1.0;

  tp[4].coeffs[0][0].dCoord[X] = r1;
  tp[4].coeffs[0][0].dCoord[Y] = 0.0;
  tp[4].coeffs[0][0].dCoord[Z] = 0.0;
  tp[4].coeffs[0][0].dCoord[W] = 1.0;

  tp[4].coeffs[0][1].dCoord[X] = r1*w;
  tp[4].coeffs[0][1].dCoord[Y] = 0.0;
  tp[4].coeffs[0][1].dCoord[Z] = r3*w;
  tp[4].coeffs[0][1].dCoord[W] = w;

  tp[4].coeffs[0][2].dCoord[X] = (r1 + r3);
  tp[4].coeffs[0][2].dCoord[Y] = 0.0;
  tp[4].coeffs[0][2].dCoord[Z] = r3;
  tp[4].coeffs[0][2].dCoord[W] = 1.0;

  tp[4].coeffs[1][0].dCoord[X] = r1*w;
  tp[4].coeffs[1][0].dCoord[Y] = -r1*w;
  tp[4].coeffs[1][0].dCoord[Z] = 0.0;
  tp[4].coeffs[1][0].dCoord[W] = w;

  tp[4].coeffs[1][1].dCoord[X] = r1*ww;
  tp[4].coeffs[1][1].dCoord[Y] = -r1*ww;
  tp[4].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[4].coeffs[1][1].dCoord[W] = ww;

  tp[4].coeffs[1][2].dCoord[X] = (r1 + r3)*w;
  tp[4].coeffs[1][2].dCoord[Y] = -(r1 + r3)*w;
  tp[4].coeffs[1][2].dCoord[Z] = r3*w;
  tp[4].coeffs[1][2].dCoord[W] = w;

  tp[4].coeffs[2][0].dCoord[X] = 0.0;
  tp[4].coeffs[2][0].dCoord[Y] = -r1;
  tp[4].coeffs[2][0].dCoord[Z] = 0.0;
  tp[4].coeffs[2][0].dCoord[W] = 1.0;

  tp[4].coeffs[2][1].dCoord[X] = 0.0;
  tp[4].coeffs[2][1].dCoord[Y] = -r1*w;
  tp[4].coeffs[2][1].dCoord[Z] = r3*w;
  tp[4].coeffs[2][1].dCoord[W] = w;

  tp[4].coeffs[2][2].dCoord[X] = 0.0;
  tp[4].coeffs[2][2].dCoord[Y] = -(r1 + r3);
  tp[4].coeffs[2][2].dCoord[Z] = r3;
  tp[4].coeffs[2][2].dCoord[W] = 1.0;

  tp[5].coeffs[0][0].dCoord[X] = (r1 + r3);
  tp[5].coeffs[0][0].dCoord[Y] = 0.0;
  tp[5].coeffs[0][0].dCoord[Z] = r3;
  tp[5].coeffs[0][0].dCoord[W] = 1.0;

  tp[5].coeffs[0][1].dCoord[X] = r2*w;
  tp[5].coeffs[0][1].dCoord[Y] = 0.0;
  tp[5].coeffs[0][1].dCoord[Z] = r3*w;
  tp[5].coeffs[0][1].dCoord[W] = w;

  tp[5].coeffs[0][2].dCoord[X] = r2;
  tp[5].coeffs[0][2].dCoord[Y] = 0.0;
  tp[5].coeffs[0][2].dCoord[Z] = 0.0;
  tp[5].coeffs[0][2].dCoord[W] = 1.0;

  tp[5].coeffs[1][0].dCoord[X] = (r1 + r3)*w;
  tp[5].coeffs[1][0].dCoord[Y] = -(r1 + r3)*w;
  tp[5].coeffs[1][0].dCoord[Z] = r3*w;
  tp[5].coeffs[1][0].dCoord[W] = w;

  tp[5].coeffs[1][1].dCoord[X] = r2*ww;
  tp[5].coeffs[1][1].dCoord[Y] = -r2*ww;
  tp[5].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[5].coeffs[1][1].dCoord[W] = ww;

  tp[5].coeffs[1][2].dCoord[X] = r2*w;
  tp[5].coeffs[1][2].dCoord[Y] = -r2*w;
  tp[5].coeffs[1][2].dCoord[Z] = 0.0;
  tp[5].coeffs[1][2].dCoord[W] = w;

  tp[5].coeffs[2][0].dCoord[X] = 0.0;
  tp[5].coeffs[2][0].dCoord[Y] = -(r1 + r3);
  tp[5].coeffs[2][0].dCoord[Z] = r3;
  tp[5].coeffs[2][0].dCoord[W] = 1.0;

  tp[5].coeffs[2][1].dCoord[X] = 0.0;
  tp[5].coeffs[2][1].dCoord[Y] = -r2*w;
  tp[5].coeffs[2][1].dCoord[Z] = r3*w;
  tp[5].coeffs[2][1].dCoord[W] = w;

  tp[5].coeffs[2][2].dCoord[X] = 0.0;
  tp[5].coeffs[2][2].dCoord[Y] = -r2;
  tp[5].coeffs[2][2].dCoord[Z] = 0.0;
  tp[5].coeffs[2][2].dCoord[W] = 1.0;

  tp[6].coeffs[0][0].dCoord[X] = -r1;
  tp[6].coeffs[0][0].dCoord[Y] = 0.0;
  tp[6].coeffs[0][0].dCoord[Z] = 0.0;
  tp[6].coeffs[0][0].dCoord[W] = 1.0;

  tp[6].coeffs[1][0].dCoord[X] = -r1*w;
  tp[6].coeffs[1][0].dCoord[Y] = 0.0;
  tp[6].coeffs[1][0].dCoord[Z] = r3*w;
  tp[6].coeffs[1][0].dCoord[W] = w;

  tp[6].coeffs[2][0].dCoord[X] = -(r1 + r3);
  tp[6].coeffs[2][0].dCoord[Y] = 0.0;
  tp[6].coeffs[2][0].dCoord[Z] = r3;
  tp[6].coeffs[2][0].dCoord[W] = 1.0;

  tp[6].coeffs[0][1].dCoord[X] = -r1*w;
  tp[6].coeffs[0][1].dCoord[Y] = -r1*w;
  tp[6].coeffs[0][1].dCoord[Z] = 0.0;
  tp[6].coeffs[0][1].dCoord[W] = w;

  tp[6].coeffs[1][1].dCoord[X] = -r1*ww;
  tp[6].coeffs[1][1].dCoord[Y] = -r1*ww;
  tp[6].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[6].coeffs[1][1].dCoord[W] = ww;

  tp[6].coeffs[2][1].dCoord[X] = -(r1 + r3)*w;
  tp[6].coeffs[2][1].dCoord[Y] = -(r1 + r3)*w;
  tp[6].coeffs[2][1].dCoord[Z] = r3*w;
  tp[6].coeffs[2][1].dCoord[W] = w;

  tp[6].coeffs[0][2].dCoord[X] = 0.0;
  tp[6].coeffs[0][2].dCoord[Y] = -r1;
  tp[6].coeffs[0][2].dCoord[Z] = 0.0;
  tp[6].coeffs[0][2].dCoord[W] = 1.0;

  tp[6].coeffs[1][2].dCoord[X] = 0.0;
  tp[6].coeffs[1][2].dCoord[Y] = -r1*w;
  tp[6].coeffs[1][2].dCoord[Z] = r3*w;
  tp[6].coeffs[1][2].dCoord[W] = w;

  tp[6].coeffs[2][2].dCoord[X] = 0.0;
  tp[6].coeffs[2][2].dCoord[Y] = -(r1 + r3);
  tp[6].coeffs[2][2].dCoord[Z] = r3;
  tp[6].coeffs[2][2].dCoord[W] = 1.0;

  tp[7].coeffs[0][0].dCoord[X] = -(r1 + r3);
  tp[7].coeffs[0][0].dCoord[Y] = 0.0;
  tp[7].coeffs[0][0].dCoord[Z] = r3;
  tp[7].coeffs[0][0].dCoord[W] = 1.0;

  tp[7].coeffs[1][0].dCoord[X] = -r2*w;
  tp[7].coeffs[1][0].dCoord[Y] = 0.0;
  tp[7].coeffs[1][0].dCoord[Z] = r3*w;
  tp[7].coeffs[1][0].dCoord[W] = w;

  tp[7].coeffs[2][0].dCoord[X] = -r2;
  tp[7].coeffs[2][0].dCoord[Y] = 0.0;
  tp[7].coeffs[2][0].dCoord[Z] = 0.0;
  tp[7].coeffs[2][0].dCoord[W] = 1.0;

  tp[7].coeffs[0][1].dCoord[X] = -(r1 + r3)*w;
  tp[7].coeffs[0][1].dCoord[Y] = -(r1 + r3)*w;
  tp[7].coeffs[0][1].dCoord[Z] = r3*w;
  tp[7].coeffs[0][1].dCoord[W] = w;

  tp[7].coeffs[1][1].dCoord[X] = -r2*ww;
  tp[7].coeffs[1][1].dCoord[Y] = -r2*ww;
  tp[7].coeffs[1][1].dCoord[Z] = r3*ww;
  tp[7].coeffs[1][1].dCoord[W] = ww;

  tp[7].coeffs[2][1].dCoord[X] = -r2*w;
  tp[7].coeffs[2][1].dCoord[Y] = -r2*w;
  tp[7].coeffs[2][1].dCoord[Z] = 0.0;
  tp[7].coeffs[2][1].dCoord[W] = w;

  tp[7].coeffs[0][2].dCoord[X] = 0.0;
  tp[7].coeffs[0][2].dCoord[Y] = -(r1 + r3);
  tp[7].coeffs[0][2].dCoord[Z] = r3;
  tp[7].coeffs[0][2].dCoord[W] = 1.0;

  tp[7].coeffs[1][2].dCoord[X] = 0.0;
  tp[7].coeffs[1][2].dCoord[Y] = -r2*w;
  tp[7].coeffs[1][2].dCoord[Z] = r3*w;
  tp[7].coeffs[1][2].dCoord[W] = w;

  tp[7].coeffs[2][2].dCoord[X] = 0.0;
  tp[7].coeffs[2][2].dCoord[Y] = -r2;
  tp[7].coeffs[2][2].dCoord[Z] = 0.0;
  tp[7].coeffs[2][2].dCoord[W] = 1.0;

  tp[8].coeffs[0][0].dCoord[X] = r1;
  tp[8].coeffs[0][0].dCoord[Y] = 0.0;
  tp[8].coeffs[0][0].dCoord[Z] = 0.0;
  tp[8].coeffs[0][0].dCoord[W] = 1.0;

  tp[8].coeffs[0][1].dCoord[X] = r1*w;
  tp[8].coeffs[0][1].dCoord[Y] = 0.0;
  tp[8].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[8].coeffs[0][1].dCoord[W] = w;

  tp[8].coeffs[0][2].dCoord[X] = (r1 + r3);
  tp[8].coeffs[0][2].dCoord[Y] = 0.0;
  tp[8].coeffs[0][2].dCoord[Z] = -r3;
  tp[8].coeffs[0][2].dCoord[W] = 1.0;

  tp[8].coeffs[1][0].dCoord[X] = r1*w;
  tp[8].coeffs[1][0].dCoord[Y] = r1*w;
  tp[8].coeffs[1][0].dCoord[Z] = 0.0;
  tp[8].coeffs[1][0].dCoord[W] = w;

  tp[8].coeffs[1][1].dCoord[X] = r1*ww;
  tp[8].coeffs[1][1].dCoord[Y] = r1*ww;
  tp[8].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[8].coeffs[1][1].dCoord[W] = ww;

  tp[8].coeffs[1][2].dCoord[X] = (r1 + r3)*w;
  tp[8].coeffs[1][2].dCoord[Y] = (r1 + r3)*w;
  tp[8].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[8].coeffs[1][2].dCoord[W] = w;

  tp[8].coeffs[2][0].dCoord[X] = 0.0;
  tp[8].coeffs[2][0].dCoord[Y] = r1;
  tp[8].coeffs[2][0].dCoord[Z] = 0.0;
  tp[8].coeffs[2][0].dCoord[W] = 1.0;

  tp[8].coeffs[2][1].dCoord[X] = 0.0;
  tp[8].coeffs[2][1].dCoord[Y] = r1*w;
  tp[8].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[8].coeffs[2][1].dCoord[W] = w;

  tp[8].coeffs[2][2].dCoord[X] = 0.0;
  tp[8].coeffs[2][2].dCoord[Y] = (r1 + r3);
  tp[8].coeffs[2][2].dCoord[Z] = -r3;
  tp[8].coeffs[2][2].dCoord[W] = 1.0;

  tp[9].coeffs[0][0].dCoord[X] = (r1 + r3);
  tp[9].coeffs[0][0].dCoord[Y] = 0.0;
  tp[9].coeffs[0][0].dCoord[Z] = -r3;
  tp[9].coeffs[0][0].dCoord[W] = 1.0;

  tp[9].coeffs[0][1].dCoord[X] = r2*w;
  tp[9].coeffs[0][1].dCoord[Y] = 0.0;
  tp[9].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[9].coeffs[0][1].dCoord[W] = w;

  tp[9].coeffs[0][2].dCoord[X] = r2;
  tp[9].coeffs[0][2].dCoord[Y] = 0.0;
  tp[9].coeffs[0][2].dCoord[Z] = 0.0;
  tp[9].coeffs[0][2].dCoord[W] = 1.0;

  tp[9].coeffs[1][0].dCoord[X] = (r1 + r3)*w;
  tp[9].coeffs[1][0].dCoord[Y] = (r1 + r3)*w;
  tp[9].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[9].coeffs[1][0].dCoord[W] = w;

  tp[9].coeffs[1][1].dCoord[X] = r2*ww;
  tp[9].coeffs[1][1].dCoord[Y] = r2*ww;
  tp[9].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[9].coeffs[1][1].dCoord[W] = ww;

  tp[9].coeffs[1][2].dCoord[X] = r2*w;
  tp[9].coeffs[1][2].dCoord[Y] = r2*w;
  tp[9].coeffs[1][2].dCoord[Z] = 0.0;
  tp[9].coeffs[1][2].dCoord[W] = w;

  tp[9].coeffs[2][0].dCoord[X] = 0.0;
  tp[9].coeffs[2][0].dCoord[Y] = (r1 + r3);
  tp[9].coeffs[2][0].dCoord[Z] = -r3;
  tp[9].coeffs[2][0].dCoord[W] = 1.0;

  tp[9].coeffs[2][1].dCoord[X] = 0.0;
  tp[9].coeffs[2][1].dCoord[Y] = r2*w;
  tp[9].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[9].coeffs[2][1].dCoord[W] = w;

  tp[9].coeffs[2][2].dCoord[X] = 0.0;
  tp[9].coeffs[2][2].dCoord[Y] = r2;
  tp[9].coeffs[2][2].dCoord[Z] = 0.0;
  tp[9].coeffs[2][2].dCoord[W] = 1.0;

  tp[10].coeffs[0][0].dCoord[X] = -r1;
  tp[10].coeffs[0][0].dCoord[Y] = 0.0;
  tp[10].coeffs[0][0].dCoord[Z] = 0.0;
  tp[10].coeffs[0][0].dCoord[W] = 1.0;

  tp[10].coeffs[1][0].dCoord[X] = -r1*w;
  tp[10].coeffs[1][0].dCoord[Y] = 0.0;
  tp[10].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[10].coeffs[1][0].dCoord[W] = w;

  tp[10].coeffs[2][0].dCoord[X] = -(r1 + r3);
  tp[10].coeffs[2][0].dCoord[Y] = 0.0;
  tp[10].coeffs[2][0].dCoord[Z] = -r3;
  tp[10].coeffs[2][0].dCoord[W] = 1.0;

  tp[10].coeffs[0][1].dCoord[X] = -r1*w;
  tp[10].coeffs[0][1].dCoord[Y] = r1*w;
  tp[10].coeffs[0][1].dCoord[Z] = 0.0;
  tp[10].coeffs[0][1].dCoord[W] = w;

  tp[10].coeffs[1][1].dCoord[X] = -r1*ww;
  tp[10].coeffs[1][1].dCoord[Y] = r1*ww;
  tp[10].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[10].coeffs[1][1].dCoord[W] = ww;

  tp[10].coeffs[2][1].dCoord[X] = -(r1 + r3)*w;
  tp[10].coeffs[2][1].dCoord[Y] = (r1 + r3)*w;
  tp[10].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[10].coeffs[2][1].dCoord[W] = w;

  tp[10].coeffs[0][2].dCoord[X] = 0.0;
  tp[10].coeffs[0][2].dCoord[Y] = r1;
  tp[10].coeffs[0][2].dCoord[Z] = 0.0;
  tp[10].coeffs[0][2].dCoord[W] = 1.0;

  tp[10].coeffs[1][2].dCoord[X] = 0.0;
  tp[10].coeffs[1][2].dCoord[Y] = r1*w;
  tp[10].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[10].coeffs[1][2].dCoord[W] = w;

  tp[10].coeffs[2][2].dCoord[X] = 0.0;
  tp[10].coeffs[2][2].dCoord[Y] = (r1 + r3);
  tp[10].coeffs[2][2].dCoord[Z] = -r3;
  tp[10].coeffs[2][2].dCoord[W] = 1.0;

  tp[11].coeffs[0][0].dCoord[X] = -(r1 + r3);
  tp[11].coeffs[0][0].dCoord[Y] = 0.0;
  tp[11].coeffs[0][0].dCoord[Z] = -r3;
  tp[11].coeffs[0][0].dCoord[W] = 1.0;

  tp[11].coeffs[1][0].dCoord[X] = -r2*w;
  tp[11].coeffs[1][0].dCoord[Y] = 0.0;
  tp[11].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[11].coeffs[1][0].dCoord[W] = w;

  tp[11].coeffs[2][0].dCoord[X] = -r2;
  tp[11].coeffs[2][0].dCoord[Y] = 0.0;
  tp[11].coeffs[2][0].dCoord[Z] = 0.0;
  tp[11].coeffs[2][0].dCoord[W] = 1.0;

  tp[11].coeffs[0][1].dCoord[X] = -(r1 + r3)*w;
  tp[11].coeffs[0][1].dCoord[Y] = (r1 + r3)*w;
  tp[11].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[11].coeffs[0][1].dCoord[W] = w;

  tp[11].coeffs[1][1].dCoord[X] = -r2*ww;
  tp[11].coeffs[1][1].dCoord[Y] = r2*ww;
  tp[11].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[11].coeffs[1][1].dCoord[W] = ww;

  tp[11].coeffs[2][1].dCoord[X] = -r2*w;
  tp[11].coeffs[2][1].dCoord[Y] = r2*w;
  tp[11].coeffs[2][1].dCoord[Z] = 0.0;
  tp[11].coeffs[2][1].dCoord[W] = w;

  tp[11].coeffs[0][2].dCoord[X] = 0.0;
  tp[11].coeffs[0][2].dCoord[Y] = (r1 + r3);
  tp[11].coeffs[0][2].dCoord[Z] = -r3;
  tp[11].coeffs[0][2].dCoord[W] = 1.0;

  tp[11].coeffs[1][2].dCoord[X] = 0.0;
  tp[11].coeffs[1][2].dCoord[Y] = r2*w;
  tp[11].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[11].coeffs[1][2].dCoord[W] = w;

  tp[11].coeffs[2][2].dCoord[X] = 0.0;
  tp[11].coeffs[2][2].dCoord[Y] = r2;
  tp[11].coeffs[2][2].dCoord[Z] = 0.0;
  tp[11].coeffs[2][2].dCoord[W] = 1.0;

  tp[12].coeffs[0][0].dCoord[X] = r1;
  tp[12].coeffs[0][0].dCoord[Y] = 0.0;
  tp[12].coeffs[0][0].dCoord[Z] = 0.0;
  tp[12].coeffs[0][0].dCoord[W] = 1.0;

  tp[12].coeffs[1][0].dCoord[X] = r1*w;
  tp[12].coeffs[1][0].dCoord[Y] = 0.0;
  tp[12].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[12].coeffs[1][0].dCoord[W] = w;

  tp[12].coeffs[2][0].dCoord[X] = (r1 + r3);
  tp[12].coeffs[2][0].dCoord[Y] = 0.0;
  tp[12].coeffs[2][0].dCoord[Z] = -r3;
  tp[12].coeffs[2][0].dCoord[W] = 1.0;

  tp[12].coeffs[0][1].dCoord[X] = r1*w;
  tp[12].coeffs[0][1].dCoord[Y] = -r1*w;
  tp[12].coeffs[0][1].dCoord[Z] = 0.0;
  tp[12].coeffs[0][1].dCoord[W] = w;

  tp[12].coeffs[1][1].dCoord[X] = r1*ww;
  tp[12].coeffs[1][1].dCoord[Y] = -r1*ww;
  tp[12].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[12].coeffs[1][1].dCoord[W] = ww;

  tp[12].coeffs[2][1].dCoord[X] = (r1 + r3)*w;
  tp[12].coeffs[2][1].dCoord[Y] = -(r1 + r3)*w;
  tp[12].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[12].coeffs[2][1].dCoord[W] = w;

  tp[12].coeffs[0][2].dCoord[X] = 0.0;
  tp[12].coeffs[0][2].dCoord[Y] = -r1;
  tp[12].coeffs[0][2].dCoord[Z] = 0.0;
  tp[12].coeffs[0][2].dCoord[W] = 1.0;

  tp[12].coeffs[1][2].dCoord[X] = 0.0;
  tp[12].coeffs[1][2].dCoord[Y] = -r1*w;
  tp[12].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[12].coeffs[1][2].dCoord[W] = w;

  tp[12].coeffs[2][2].dCoord[X] = 0.0;
  tp[12].coeffs[2][2].dCoord[Y] = -(r1 + r3);
  tp[12].coeffs[2][2].dCoord[Z] = -r3;
  tp[12].coeffs[2][2].dCoord[W] = 1.0;

  tp[13].coeffs[0][0].dCoord[X] = (r1 + r3);
  tp[13].coeffs[0][0].dCoord[Y] = 0.0;
  tp[13].coeffs[0][0].dCoord[Z] = -r3;
  tp[13].coeffs[0][0].dCoord[W] = 1.0;

  tp[13].coeffs[1][0].dCoord[X] = r2*w;
  tp[13].coeffs[1][0].dCoord[Y] = 0.0;
  tp[13].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[13].coeffs[1][0].dCoord[W] = w;

  tp[13].coeffs[2][0].dCoord[X] = r2;
  tp[13].coeffs[2][0].dCoord[Y] = 0.0;
  tp[13].coeffs[2][0].dCoord[Z] = 0.0;
  tp[13].coeffs[2][0].dCoord[W] = 1.0;

  tp[13].coeffs[0][1].dCoord[X] = (r1 + r3)*w;
  tp[13].coeffs[0][1].dCoord[Y] = -(r1 + r3)*w;
  tp[13].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[13].coeffs[0][1].dCoord[W] = w;

  tp[13].coeffs[1][1].dCoord[X] = r2*ww;
  tp[13].coeffs[1][1].dCoord[Y] = -r2*ww;
  tp[13].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[13].coeffs[1][1].dCoord[W] = ww;

  tp[13].coeffs[2][1].dCoord[X] = r2*w;
  tp[13].coeffs[2][1].dCoord[Y] = -r2*w;
  tp[13].coeffs[2][1].dCoord[Z] = 0.0;
  tp[13].coeffs[2][1].dCoord[W] = w;

  tp[13].coeffs[0][2].dCoord[X] = 0.0;
  tp[13].coeffs[0][2].dCoord[Y] = -(r1 + r3);
  tp[13].coeffs[0][2].dCoord[Z] = -r3;
  tp[13].coeffs[0][2].dCoord[W] = 1.0;

  tp[13].coeffs[1][2].dCoord[X] = 0.0;
  tp[13].coeffs[1][2].dCoord[Y] = -r2*w;
  tp[13].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[13].coeffs[1][2].dCoord[W] = w;

  tp[13].coeffs[2][2].dCoord[X] = 0.0;
  tp[13].coeffs[2][2].dCoord[Y] = -r2;
  tp[13].coeffs[2][2].dCoord[Z] = 0.0;
  tp[13].coeffs[2][2].dCoord[W] = 1.0;

  tp[14].coeffs[0][0].dCoord[X] = -r1;
  tp[14].coeffs[0][0].dCoord[Y] = 0.0;
  tp[14].coeffs[0][0].dCoord[Z] = 0.0;
  tp[14].coeffs[0][0].dCoord[W] = 1.0;

  tp[14].coeffs[0][1].dCoord[X] = -r1*w;
  tp[14].coeffs[0][1].dCoord[Y] = 0.0;
  tp[14].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[14].coeffs[0][1].dCoord[W] = w;

  tp[14].coeffs[0][2].dCoord[X] = -(r1 + r3);
  tp[14].coeffs[0][2].dCoord[Y] = 0.0;
  tp[14].coeffs[0][2].dCoord[Z] = -r3;
  tp[14].coeffs[0][2].dCoord[W] = 1.0;

  tp[14].coeffs[1][0].dCoord[X] = -r1*w;
  tp[14].coeffs[1][0].dCoord[Y] = -r1*w;
  tp[14].coeffs[1][0].dCoord[Z] = 0.0;
  tp[14].coeffs[1][0].dCoord[W] = w;

  tp[14].coeffs[1][1].dCoord[X] = -r1*ww;
  tp[14].coeffs[1][1].dCoord[Y] = -r1*ww;
  tp[14].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[14].coeffs[1][1].dCoord[W] = ww;

  tp[14].coeffs[1][2].dCoord[X] = -(r1 + r3)*w;
  tp[14].coeffs[1][2].dCoord[Y] = -(r1 + r3)*w;
  tp[14].coeffs[1][2].dCoord[Z] = -r3*w;
  tp[14].coeffs[1][2].dCoord[W] = w;

  tp[14].coeffs[2][0].dCoord[X] = 0.0;
  tp[14].coeffs[2][0].dCoord[Y] = -r1;
  tp[14].coeffs[2][0].dCoord[Z] = 0.0;
  tp[14].coeffs[2][0].dCoord[W] = 1.0;

  tp[14].coeffs[2][1].dCoord[X] = 0.0;
  tp[14].coeffs[2][1].dCoord[Y] = -r1*w;
  tp[14].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[14].coeffs[2][1].dCoord[W] = w;

  tp[14].coeffs[2][2].dCoord[X] = 0.0;
  tp[14].coeffs[2][2].dCoord[Y] = -(r1 + r3);
  tp[14].coeffs[2][2].dCoord[Z] = -r3;
  tp[14].coeffs[2][2].dCoord[W] = 1.0;

  tp[15].coeffs[0][0].dCoord[X] = -(r1 + r3);
  tp[15].coeffs[0][0].dCoord[Y] = 0.0;
  tp[15].coeffs[0][0].dCoord[Z] = -r3;
  tp[15].coeffs[0][0].dCoord[W] = 1.0;

  tp[15].coeffs[0][1].dCoord[X] = -r2*w;
  tp[15].coeffs[0][1].dCoord[Y] = 0.0;
  tp[15].coeffs[0][1].dCoord[Z] = -r3*w;
  tp[15].coeffs[0][1].dCoord[W] = w;

  tp[15].coeffs[0][2].dCoord[X] = -r2;
  tp[15].coeffs[0][2].dCoord[Y] = 0.0;
  tp[15].coeffs[0][2].dCoord[Z] = 0.0;
  tp[15].coeffs[0][2].dCoord[W] = 1.0;

  tp[15].coeffs[1][0].dCoord[X] = -(r1 + r3)*w;
  tp[15].coeffs[1][0].dCoord[Y] = -(r1 + r3)*w;
  tp[15].coeffs[1][0].dCoord[Z] = -r3*w;
  tp[15].coeffs[1][0].dCoord[W] = w;

  tp[15].coeffs[1][1].dCoord[X] = -r2*ww;
  tp[15].coeffs[1][1].dCoord[Y] = -r2*ww;
  tp[15].coeffs[1][1].dCoord[Z] = -r3*ww;
  tp[15].coeffs[1][1].dCoord[W] = ww;

  tp[15].coeffs[1][2].dCoord[X] = -r2*w;
  tp[15].coeffs[1][2].dCoord[Y] = -r2*w;
  tp[15].coeffs[1][2].dCoord[Z] = 0.0;
  tp[15].coeffs[1][2].dCoord[W] = w;

  tp[15].coeffs[2][0].dCoord[X] = 0.0;
  tp[15].coeffs[2][0].dCoord[Y] = -(r1 + r3);
  tp[15].coeffs[2][0].dCoord[Z] = -r3;
  tp[15].coeffs[2][0].dCoord[W] = 1.0;

  tp[15].coeffs[2][1].dCoord[X] = 0.0;
  tp[15].coeffs[2][1].dCoord[Y] = -r2*w;
  tp[15].coeffs[2][1].dCoord[Z] = -r3*w;
  tp[15].coeffs[2][1].dCoord[W] = w;

  tp[15].coeffs[2][2].dCoord[X] = 0.0;
  tp[15].coeffs[2][2].dCoord[Y] = -r2;
  tp[15].coeffs[2][2].dCoord[Z] = 0.0;
  tp[15].coeffs[2][2].dCoord[W] = 1.0;
*/
}
#endif

int gen_torus(center, axis_vec, torus_iradius, torus_oradius, tp)
POINT4D center, axis_vec;
double torus_iradius, torus_oradius;
TENSOR_PATCH **tp;
{
  int i, j, k;
  double **XformMatTor;

  if ((torus_iradius <= 0.0) || (torus_oradius <= 0.0)) {
    printf("Torus radius is negative. Fatal Error\n");
    exit(-1);
  }
  if (torus_iradius >= torus_oradius) {
    printf("Inner radius greater than outer radius\n");
    exit(-1);
  }

  normalise(&axis_vec);
  ALLOCMAT(XformMatTor, 4, 4, double);
  getXformMatTor(center, axis_vec, XformMatTor);

  ALLOCN(*tp, TENSOR_PATCH, NUM_TOR_PATCHES);
  for (k=0; k<NUM_TOR_PATCHES; k++) {
    (*tp)[k].iDeg0 = TOR_SDEGREE;
    (*tp)[k].iDeg1 = TOR_TDEGREE;
    allocate_tensor_patch(&((*tp)[k]));
  }

  GetNormTorusControlPts(*tp, torus_iradius, torus_oradius);

/* After getting normalized cylinder's control points ie. cylinder with
   center at origin and axis corresponding to the z axis, all we have
   to do is to transform each control point using XformMatTor and then 
   writing it into a file */

  XformPatch(*tp, NUM_TOR_PATCHES, TOR_SDEGREE, TOR_TDEGREE, XformMatTor);
  return NUM_TOR_PATCHES;
}
