#ifdef __GL

#include "colortrim.h"
#include "hostgptrim.h"
#include "Beztri.h"
/* #include "trim.h" */

#define DEFINEVARS
#define TRIM_C
#include "BezVars.h"
#include <malloc.h>

#define MAX_DATA	300
#define MAX_LOOPS	MAX_TRIMCURVE+5
#define HYSTERESIS	1
#define MINSTEPS 	1

#ifdef PXPL
#define BezEnv	        dglob->fdata.environ.bezier_parameters
#else
extern BezEnvType	BezEnv;
#endif

#define OPEN		0x1
#define CLOSE		0x2
#define SPLIT		0x4

#ifdef SGINEW
#include "polytri.c"
#endif

extern int      subdiv;

#ifdef SGI
#define print if(0) printf
#define rc_refine_pass()        1
#define GP      0
#else
#define GP      9
#define print if(0) printf
#endif

#ifdef PXPL
static int nsteps = 10;
#else
extern int nsteps;
#endif

#ifdef PXPL
static VERTEX storetris[1][3];
static WTYPE fov;
#else
static VERTEX storetris[MAX_PATCH_GP][MAX_TRI][3];
#endif

typedef VERTEX	        VLINE[MAX_NO_POINTS];

static VLINE            PtsInternal[MAX_NO_POINTS];
static VERTEX           PtsBoundary[4][MAX_NO_POINTS+2];
static VERTEX           PtsCurve[2*MAX_CORDER];
static TPOINT           uvcurve[2*MAX_CORDER];

static int              cum_degrees;
static int              num_tri[MAX_PATCH_GP];
static int              vertidx;

static DlistGlobalsType *dglob;
static WTYPE            newuv[4];
static int              flat;
static int              numtris = 0;
static int              statcolor;
static int              hole, lastactive;
static unsigned char    curvadd[NUMCACH][2][2];
static byte             sinsteps[NUMCACH][2][2];
static WTYPE            lastskiplen[NUMCACH];
static WTYPE            skiplen;

static int              ncurves, udegree, vdegree, coord;
static WTYPE            (*cntrl)[MAX_ORDER][WCOORD];
static WTYPE            cntrl2[MAX_ORDER][MAX_ORDER][WCOORD];
static WTYPE            cntrl3[MAX_ORDER][MAX_ORDER][WCOORD];
static WTYPE            ustepsize, vstepsize;
static int              nusteps, nvsteps;
static WTYPE            stepsize[2][2];
static unsigned int     insteps[2][2];

typedef struct {
   TPOINT  uv;
   VERTEX  *v;
   int     next;
} ListType;
typedef struct {
   int     front;
   int     end;
   short   nextlist;
   short   prevlist;
   int     unum;
} ListHeaderType;

#define MAX_LIST	MAX_NO_POINTS
#define MAX_GLIST	MAX_NO_POINTS*4
static ListType         Glist[MAX_GLIST];
static ListHeaderType   lists[MAX_LIST]; /* Should be an array */
static int              Glistfree = 0;
static int              llfree = 0;
static int              Dlistfront = MAX_LIST;
static int              Firstlist=0;
static int              listno;

#ifdef PXPL
#define addtri(x, y, z)		render_Tris(0, y, x, z, dglob)
#else
addtri(v1, v2, v3)
VERTEX *v1, *v2, *v3;
{

TRACE(printf("In addtri\n");)

ALLDEBUG(
   printf("%g %g %g\n", v1->p[0], v1->p[1], v1->p[2]);
   printf("%g %g %g\n", v2->p[0], v2->p[1], v2->p[2]);
   printf("%g %g %g\n", v3->p[0], v3->p[1], v3->p[2]);
   printf("\n");
)

   numtris = tindex[patchno];
   if(numtris > MAX_TRI) printf("Too many triangles \n");
   else{
   storetris[patchno][numtris][0].p[0] = v1->p[0];
   storetris[patchno][numtris][0].p[1] = v1->p[1];
   storetris[patchno][numtris][0].p[2] = v1->p[2];
   storetris[patchno][numtris][0].n[0] = v1->n[0];
   storetris[patchno][numtris][0].n[1] = v1->n[1];
   storetris[patchno][numtris][0].n[2] = v1->n[2];
   storetris[patchno][numtris][1].p[0] = v2->p[0];
   storetris[patchno][numtris][1].p[1] = v2->p[1];
   storetris[patchno][numtris][1].p[2] = v2->p[2];
   storetris[patchno][numtris][1].n[0] = v2->n[0];
   storetris[patchno][numtris][1].n[1] = v2->n[1];
   storetris[patchno][numtris][1].n[2] = v2->n[2];
   storetris[patchno][numtris][2].p[0] = v3->p[0];
   storetris[patchno][numtris][2].p[1] = v3->p[1];
   storetris[patchno][numtris][2].p[2] = v3->p[2];
   storetris[patchno][numtris][2].n[0] = v3->n[0];
   storetris[patchno][numtris][2].n[1] = v3->n[1];
   storetris[patchno][numtris][2].n[2] = v3->n[2];
   tindex[patchno] ++;}

   render_Tris(0, v2, v1, v3, dglob);
}
#endif

bez_vert(cntrl, cntrlu, cntrlv, degree, t, xyz_idx, coord, uorv)
WTYPE t;
VERTEX  xyz_idx[];
WPOINT cntrl[], cntrlu[], cntrlv[];
int degree, coord, uorv;
{/* TODO: Can reduce code size here */
VERTEX   *xyz_vert;
WTYPE    s, t_i;
WPOINT   xyz_pt, xyz_ptu, xyz_ptv;
register int i, j;
int      Nci, degreeu, degreev;

if(uorv == V) {degreeu = degree-1; degreev = degree;}
else          {degreeu = degree; degreev = degree-1;}

xyz_vert = xyz_idx;

/****/
   Nci = 1;
   t_i = 1.0;
   s = 1-t;
   for(i=0; i<coord; i++)
      xyz_pt[i] = cntrl[0][i]*s;

   for(i=1; i<degree; i++)
   {
      t_i *= t;
      Nci = (Nci*(degree-i+1))/i;
      for(j=0; j<coord; j++)
         xyz_pt[j] = (xyz_pt[j] + t_i*Nci*cntrl[i][j])*s;
   }
   for(j=0; j<coord; j++)
      xyz_pt[j] += t_i*t*cntrl[degree][j];
/****/
   Nci = 1;
   t_i = 1.0;
   s = 1-t;
   for(i=0; i<coord; i++)
      xyz_ptu[i] = cntrlu[0][i]*s;

   for(i=1; i<degreeu; i++)
   {
      t_i *= t;
      Nci = (Nci*(degreeu-i+1))/i;
      for(j=0; j<coord; j++)
         xyz_ptu[j] = (xyz_ptu[j] + t_i*Nci*cntrlu[i][j])*s;
   }
   for(j=0; j<coord; j++)
      xyz_ptu[j] += t_i*t*cntrlu[degreeu][j];
/****/
   Nci = 1;
   t_i = 1.0;
   s = 1-t;
   for(i=0; i<coord; i++)
      xyz_ptv[i] = cntrlv[0][i]*s;

   for(i=1; i<degreev; i++)
   {
      t_i *= t;
      Nci = (Nci*(degreev-i+1))/i;
      for(j=0; j<coord; j++)
         xyz_ptv[j] = (xyz_ptv[j] + t_i*Nci*cntrlv[i][j])*s;
   }
   for(j=0; j<coord; j++)
      xyz_ptv[j] += t_i*t*cntrlv[degreev][j];
/*****/
          if(coord == WCOORD)
          {
             s = 1.0/xyz_pt[COORD];
             for(j=0; j<COORD; j++)
             {
                xyz_vert->p[j] = xyz_pt[j]*s;

                xyz_ptu[j] = (xyz_ptu[j] - xyz_vert->p[j]*
                xyz_ptu[COORD])*s;
  
                xyz_ptv[j] = (xyz_ptv[j] - xyz_vert->p[j]*
                xyz_ptv[COORD])*s;
             }
          }
          else
            for(j=0; j<COORD; j++)
                xyz_vert->p[j] = xyz_pt[j];
          crossp(xyz_ptu, xyz_ptv, xyz_pt);
          normalize(xyz_pt, xyz_vert->n); /* TODO Fix compatibility */
		/* TODO if coord == COORD put directly in xyz_vert */
}

bez_ptU(cntrl, col, degree, t, xyz_pt, coord)
WTYPE t, cntrl[][MAX_ORDER][WCOORD];
WPOINT xyz_pt;
int degree, coord;
{
register WTYPE s, t_i=1.0;
register int   i, j, Nci=1;

   s = 1-t;
   for(i=0; i<coord; i++)
      xyz_pt[i] = cntrl[0][col][i]*s;

   for(i=1; i<degree; i++)
   {
      t_i *= t;
      Nci = (Nci*(degree-i+1))/i;
      for(j=0; j<coord; j++)
         xyz_pt[j] = (xyz_pt[j] + t_i*Nci*cntrl[i][col][j])*s;
   }
   for(j=0; j<coord; j++)
      xyz_pt[j] += t_i*t*cntrl[degree][col][j];
}

bez_pt(cntrl, degree, t, xyz_pt, coord)
WTYPE t, cntrl[][WCOORD];
WPOINT xyz_pt;
int degree, coord;
{
register WTYPE  s, t_i=1.0;
register int    i, j, Nci=1;

   s = 1-t;
   for(i=0; i<coord; i++)
      xyz_pt[i] = cntrl[0][i]*s;

   for(i=1; i<degree; i++)
   {
      t_i *= t;
      Nci = (Nci*(degree-i+1))/i;
      for(j=0; j<coord; j++)
         xyz_pt[j] = (xyz_pt[j] + t_i*Nci*cntrl[i][j])*s;
   }
   for(j=0; j<coord; j++)
      xyz_pt[j] += t_i*t*cntrl[degree][j];
}

evallineV(fu, v, pt, numpt, ustepsize, option, guide)
WTYPE  fu, v, ustepsize;
VERTEX pt[];
int    numpt;
int    option;
byte   guide[];
{
WPOINT   newctrl[MAX_ORDER], newctrl2[MAX_ORDER], newctrl3[MAX_ORDER];
register int i;

    for(i=0; i<=udegree; i++)
       bez_pt(cntrl[i], vdegree, v, newctrl[i], coord);

    for(i=0; i<udegree; i++)
       bez_pt(cntrl2[i], vdegree, v, newctrl2[i], coord);

    for(i=0; i<=udegree; i++)
       bez_pt(cntrl3[i], vdegree-1, v, newctrl3[i], coord);

    for(i=0; i<=numpt; i++)  /* Take this loop inside the/a function */
    {
       if(!option || guide[i]) 
          bez_vert(newctrl, newctrl2, newctrl3, udegree, fu, pt+i, coord, V);
       fu += ustepsize;
    }
}

evallineU(fv, u, pt, numpt, vstepsize)
WTYPE  fv, u, vstepsize;
VERTEX pt[];
int    numpt;
{
WPOINT   newctrl[MAX_ORDER], newctrl2[MAX_ORDER], newctrl3[MAX_ORDER];
register int i;

    for(i=0; i<=vdegree; i++)
       bez_ptU(cntrl, i, udegree, u, newctrl[i], coord);

    for(i=0; i<=vdegree; i++)
       bez_ptU(cntrl2, i, udegree-1, u, newctrl2[i], coord);

    for(i=0; i<vdegree; i++)
       bez_ptU(cntrl3, i, udegree, u, newctrl3[i], coord);

    for(i=0; i<=numpt; i++)  /* Take this loop inside the/a function */
    {
       bez_vert(newctrl, newctrl2, newctrl3, vdegree, fv, pt+i, coord, U);
       fv += vstepsize;
    }
}

evaluate(u, v, pt) /* Temply, TODO: Do a vline at a time */
WTYPE u, v;
VERTEX pt[];
{
WPOINT   newctrl[MAX_ORDER], newctrl2[MAX_ORDER], newctrl3[MAX_ORDER];
register int i;

    for(i=0; i<=udegree; i++)
       bez_pt(cntrl[i], vdegree, v, newctrl[i], coord);

    for(i=0; i<udegree; i++)
       bez_pt(cntrl2[i], vdegree, v, newctrl2[i], coord);

    for(i=0; i<=udegree; i++)
       bez_pt(cntrl3[i], vdegree-1, v, newctrl3[i], coord);

    bez_vert(newctrl, newctrl2, newctrl3, udegree, u, pt, coord, V);
}

evalcurve(curves, ncurves, degree, nverts)
TPOINT *curves[];
int    ncurves;
short  degree[];
int    nverts[];
{
TPOINT   *curve;
register int i, j;
int      k, l, dir;
WTYPE    u,v, fu, fv, incu, incv;

/* u	INSTEPS
 ****************
 *     1,1	*
 *0,0        0,1*
 *     1,0	*  v
 ****************----
 */

  j = 0;
  /* while(ncurves-- > 0) */
  for(l=0; l<ncurves; l++)
  {
     k = j;
     curve = curves[l];
     u = curve[degree[l]-1][U];
     v = curve[degree[l]-1][V];
     for(i=0; i<degree[l]; i++)
     {
        if(u == 0 && curve[i][U] == 0)
        {
	   fu = 0;
           incu = 0;
	   fv = ((int) ((v-F_DELTA)*insteps[1][0])) * stepsize[1][0];
           incv = -stepsize[1][0];
           dir = 1;
        }
        else if(u == 1 && curve[i][U] == 1)
        {
	   fu = 1;
           incu = 0;
	   fv = ((int) ((v+F_DELTA)*insteps[1][1]) + 1) * stepsize[1][1];
           incv = stepsize[1][1];
           dir = -1;
        }
        else if(v == 0 && curve[i][V] == 0)
        {
	   fu = ((int) ((u+F_DELTA)*insteps[0][0]) + 1) * stepsize[0][0];
           incu = stepsize[0][0];
	   fv = 0;
           incv = 0;
           dir = -1;
        }
        else if(v == 1 && curve[i][V] == 1)
        {
	   fu = ((int) ((u-F_DELTA) * insteps[0][1])) * stepsize[0][1];
           incu = -stepsize[0][1];
	   fv = 1;
           incv = 0;
           dir = 1;
        }
        else
        {
          dir = 0;
        }
        /* At boundary it shd move in only one direction */
        /* TODO Shd really try if-else rather than mult */
        while((fu-curve[i][U])*dir > F_DELTA || (fv-curve[i][V])*dir > F_DELTA)
        {
           /* uvcurve[j] = (TPOINT *) malloc(sizeof(TPOINT)); */
	   uvcurve[j][0] = fu;
	   uvcurve[j][1] = fv;
           evaluate(fu, fv, PtsCurve+j); /* Shd be in the global place */
           fu += incu; fv += incv; j++;
        }
        ERR(
           if(j >= 2*MAX_CORDER)
              printf("Too many trim points on patch %d\n", patchno);
        )
        u = curve[i][U]; v = curve[i][V];
        /* uvcurve[j] = &curve[i]; */
        uvcurve[j][0] = curve[i][0];
        uvcurve[j][1] = curve[i][1];
        evaluate(u, v, PtsCurve+j);
        j ++;
     }
     /* if(*nverts != j) */
        /* printf("Unequal: %d %d\n", *nverts, j); */
     nverts[l] = j-k;
  }
}

prependlist(ilist, uv, vert3d)
TPOINT  uv;
VERTEX  *vert3d;
int     ilist;
{
ListHeaderType *list;

   list = lists+ilist;

ERR(
   if(Glistfree == MAX_GLIST) printf("*** SIZE ERROR: Glistfree ***\n");
)
   Glist[Glistfree].uv[U] = uv[U];
   Glist[Glistfree].uv[V] = uv[V];
   Glist[Glistfree].v = vert3d;
   Glist[Glistfree].next = list->front;
   list->front = Glistfree++;
}

appendlist(ilist, uv, vert3d)
TPOINT  uv;
VERTEX  *vert3d;
int     ilist;
{
ListHeaderType *list;

   list = lists+ilist;

ERR(
   if(Glistfree == MAX_GLIST) printf("*** SIZE ERROR: Glistfree ***\n");
)
   Glist[Glistfree].uv[U] = uv[U];
   Glist[Glistfree].uv[V] = uv[V];
   Glist[Glistfree].v = vert3d;
   Glist[Glistfree].next = 0;
   Glist[list->end].next = Glistfree;
   list->end = Glistfree++;
}

connectlist(il1, il2)
int  il1, il2;
{
ListHeaderType *l1, *l2;

   l1=lists+il1;
   l2=lists+il1;
   Glist[l1->end].next = l2->front;
}

mergelist(il1, il2)
int  il1, il2;
{
ListHeaderType *l1, *l2;
 
   l1=lists+il1;
   l2=lists+il2;

   Glist[l1->end].next = l2->front;
   l1->end = l2->end;
   /* l2->front = 0; */
   lists[il1].nextlist = lists[il2].nextlist; /* Delete the second list from LoL */
   lists[lists[il2].nextlist].prevlist = il1;
   if(il2 == Firstlist) Firstlist = lists[il2].nextlist;
}

nillist(l1)
ListHeaderType *l1;
{
   l1->front = 0;
   l1->end = 0;
}


getnewlist(last)
{
ERR(
   if(llfree == MAX_LIST) printf("*** SIZE ERROR: llfree ***\n");
)
   lists[llfree].nextlist = lists[last].nextlist;
   lists[llfree].prevlist = last;
   lists[lists[last].nextlist].prevlist = llfree;
   lists[last].nextlist = llfree;
   lists[llfree].front = 0;
   lists[llfree].end = 0;
   llfree++;
}

closelist(int l1)
{
int tmp;
   if(l1 == Firstlist)  Firstlist = lists[l1].nextlist;
   tmp = lists[l1].prevlist;
   lists[tmp].nextlist = lists[l1].nextlist;
   lists[lists[l1].nextlist].prevlist = tmp;
   lists[l1].nextlist = Dlistfront;
   Dlistfront = l1;
}

refreshlists()
{
   llfree = 0;
   Glistfree = 0;
   Dlistfront = MAX_LIST;
}


stair(vnum, low, high, flag, tofill, tofilr)
int vnum, low, high, flag;
byte tofill[], tofilr[];
{ /* Do I need to run multiple chains together? Keep chain # ? */
register int     i;
int      prevchain, thischain;
int      list1, list2, list3, prevlow, prevhigh;
int      openchain, closechain;
int      hinc, linc;
TPOINT   uv;
WTYPE    u, lv, luinc, huinc;
VERTEX   *ptl, *ptr;
VLINE    *vline;
VERTEX   *vlinel, *vliner;

   vline = PtsInternal; /* TODO Will be PtsInternal[patchno] */
   vlinel = (VERTEX *) (vline+vnum);
   vliner = (VERTEX *) (vline+vnum+1);
   lv = vstepsize*vnum;

   list1 = listno;
   list2 = lists[listno].nextlist;
   prevlow = lists[list1].unum;
   prevhigh = lists[list2].unum;

   prevchain = (prevhigh > prevlow);
   thischain = (high > low);

   openchain =  ((flag&OPEN) || !prevchain) && thischain;
   closechain = ((flag&CLOSE) || !thischain) && prevchain ;

   if(low > prevhigh || high < prevlow)
   { /* Close off this chain. Start a new one */
     if(prevchain) closechain = 1;
     if(thischain) openchain = 1;
   }

   if((openchain || closechain)) /* Optimize your logic */
   {
      if(closechain)
      {
         uv[U] = ustepsize*prevhigh;
         uv[V] = lv;
         ptl =  (vlinel + prevhigh);
         if(flag & SPLIT)
         {
            list3 = list1;
            list1 = list2;
            list2 = list3;
         }
         while(prevhigh >= prevlow)
         {
            prependlist(list2, uv, ptl--);
	    prevhigh--;
            uv[U] -= ustepsize;
         }
         mergelist(list1, list2);
         /* if(Glist[lists[list2].end].next == lists[list1].front) */
         if(lists[list2].end == lists[list1].front)
            closelist(list1);
         else
            if(flag & SPLIT)
               mergelist(list1, lists[list1].prevlist);
            else
               mergelist(list1, lists[list1].nextlist);
      }

      if(openchain)
      {
         /* Inc chaincount */
         ptl =  (vlinel + low);
         getnewlist(listno);
         list1 = lists[listno].nextlist;
         getnewlist(list1);
         list2 = lists[list1].nextlist;
         if(flag & SPLIT)
         {
            list3 = list1;
            connectlist(list1, list2);
         }
         else
         {
            list3 = list2;
            connectlist(list2, list1);
         }
         uv[V] = lv;
         uv[U] = ustepsize*low;
         for(prevhigh=low; prevhigh <= high; prevhigh++)
         {
            /* evaluate(uv[U], uv[V], ptl); */
            tofill[prevhigh] = 1;
            prependlist(list3, uv, ptl++);
            uv[U] += ustepsize;
         }
      }
   }
   else
   {
      if(prevhigh < high)
      {
         hinc = 1;
         huinc = ustepsize;
      } else
      {
         hinc = -1;
         huinc = -ustepsize;
      }
      if(prevlow < low)
      {
         linc = 1;
         luinc = ustepsize;
      } else
      {
         linc = -1;
         luinc = -ustepsize;
      }

      uv[U] = ustepsize*prevhigh;
      uv[V] = lv;
      ptl = vlinel+prevhigh;
      while(prevhigh != high)
      {
         /* evaluate(uv[U], uv[V], ptl); */
         tofill[prevhigh] = 1;
         prependlist(list2, uv, ptl);
         prevhigh += hinc;
         ptl += hinc;
         uv[U] += huinc;
      }
      /* evaluate(uv[U], uv[V], ptl); */
      tofill[prevhigh] = 1;
      prependlist(list2, uv, ptl);
      ptl += hinc;

      uv[U] = ustepsize*prevlow;
      ptl = vlinel+prevlow; /* TODO -- Eliminate duplicate evals */
      while(prevlow != low)
      {
         /* evaluate(uv[U], uv[V], ptl); */
         tofill[prevlow] = 1;
         appendlist(list1, uv, ptl);
         prevlow += linc;
         ptl += linc;
         uv[U] += luinc;
      }
      /* evaluate(uv[U], uv[V], ptl); */
      tofill[prevlow] = 1;
      appendlist(list1, uv, ptl);
      ptl += linc;
   }

   u = low*ustepsize; lv = lv+vstepsize;
   ptl =  (vlinel+low);
   ptr =  (vliner+low);
   /* evaluate((low)*ustepsize, vnum*vstepsize, ptl+low); */

   if(low < high)
   {
     /* evaluate(u, lv, ptr); */
     tofilr[low] = 1;
   }
   for(i=low+1; i<=high; i++)
   { /* ptl must be filled by now */
      u += ustepsize;
      ptr++;
      /* evaluate(u, lv, ptr); */
      tofilr[i] = 1;
      addtri(ptl+1, ptr, ptl);
      addtri(ptr-1, ptl, ptr);
      ptl++;
   }

   lists[list1].unum = low;
   lists[list2].unum = high;
   listno = lists[list2].nextlist;
}

triangulate_withcurve(curves, ncurves, degree)
TPOINT *curves[];
int     ncurves;
short  degree[];
{
int      nverts[MAX_TRIMCURVE];
VERTEX   *vert3d[MAX_DATA];
VERTEX   *tPt;
double   data[MAX_DATA][2];
int      tris[MAX_DATA][3];
int      k, nloops;
register int i,j;

   evalcurve(curves, ncurves, degree, nverts);
   i = 1; k = 0; nloops = 0;
   tPt = PtsCurve-1;
   while(ncurves-- > 0)
   {
      for(j=0; j<nverts[ncurves]; j++,i++)
      {
         data[i][0] = uvcurve[k][0];
         data[i][1] = uvcurve[k][1];
         /* vert3d[i] = PtsCurve+j; */
	 k = i;
      }
      nloops++;
   }

ALLDEBUG(
   if(i > MAX_DATA)
      printf("MAX_DATA exceeded: %d > %d\n", i, MAX_DATA);
   printf("%d loops (%d %d %d %d) = %d\n", nloops,
               nverts[0], nverts[1], nverts[2], nverts[3], i);
   for(j=1; j<i; j++)
      printf("%g %g\n", data[j][0], data[j][1]);

   /* printf("\t\tCalling triangulate_polygon.\n"); */
)

   i += (nloops<<1) - 4 - 1;
   data[0][0] = data[nverts[0]][0];
   data[0][1] = data[nverts[0]][1];
   if((j = triangulate_polygon(nverts[0], data, tris, 0)) < 0)
   {
      printf("Patch %d: Non Simple Polygon. Steps: %d %d %d %d\n", patchno,
              insteps[0][0], insteps[0][1], insteps[1][0], insteps[1][1]);
      return;
   }
ALLDEBUG(
   printf("\t\t %d Polygons.\n", i);
)

   while(i-- > 0)
   {
ALLDEBUG(
      printf("Tri: %d %d %d\n", tris[j][0], tris[j][1], tris[j][2]);
)
      addtri(tPt+tris[i][0],tPt+tris[i][1],tPt+tris[i][2]);
   }
}

triangulate_cells(curves, ncurves, degree)
TPOINT *curves[];
int    ncurves;
short  degree[];
{
ListHeaderType *list;
byte     *filledu, *filledunext, filled0[MAX_NO_POINTS], filled1[MAX_NO_POINTS];
byte     *cptmp;
int      nloops, nverts[MAX_TRIMCURVE];
int      flag, low, high;
int      list1, unum, vnum, vnumr, jl, jr, split;
int      ndata[MAX_LOOPS], pos, fpos;
VERTEX   *vert3d[MAX_DATA];
VERTEX   *vline;
double   data[MAX_DATA][2];
int      tris[MAX_DATA][3];
WTYPE    v;
register int i;


   filledunext = filled0; filledu = filled1;
   refreshlists();

   for(unum=0; unum <= nusteps; unum++) /* We are talking strip now */
      filledu[unum] = 0;
   vertidx = 0;
   v = minvnum*vstepsize;

   for(vnum=minvnum,vnumr=minvnum+1; vnum <= maxvnum; vnumr++)
   {
      for(unum=0; unum <= nusteps; unum++) /* We are talking strip now ? */
         filledunext[unum] = 0; 

      listno = Firstlist;

      jl = 0; jr = 0;
      flag = 0;
      while(cross[vnum][jl] != nusteps)
      {

         if(cross[vnum][jl] == CONTAINED)
         {  /* Come back and debug later. Is wrong */
	    printf("*** Curve is contained between vnum %d and %d (u %d %d) \n",
			vnum, vnum+1, cross[vnum][jl+1], cross[vnum][jl+3]);
            low = cross[vnum][jl];
            high = cross[vnum][jl+2];
               stair(vnum, low, high, 0, filledu, filledunext);
            /* -- split */
            low = cross[vnum][jl+4];
            high = cross[vnum+1][jr+1];
            stair(vnum, low, high, 0);
            jl += 6; jr += 2;
	    continue;
         }

         if(cross[vnum][jl] < 0 && cross[vnumr][jr] < 0)
            printf("*** Unimplemented: Both turn back **** \n");
#if 1
         if(cross[vnum][jl] == STOREDR)
         { /* Right Turn. Irrelevant split, if at all */
            if(cross[vnum][jl+1] == STORED)
               flag = OPEN;
            jl += 2; continue;
         }

         if(cross[vnum][jl] == STOREDL && cross[vnum][jl+1] == STORED)
         { /* Left Turn. No split */
               stair(vnum,0,0, CLOSE, filledu, filledunext);
	       jl += 2; continue;
         }
#else
         if(cross[vnum][jl] == STOREDR || cross[vnum][jl+1] == STORED)
         { /* Either the turn was for strip vnum-1 or a non-split turn */
            printf("vnum %d has a turn on its right\n", vnum);
            if(cross[vnum][jl] == STOREDL && cross[vnum][jl+1] == STORED)
            { /* Bookkeeping: Close chain */
              stair(vnum,0,0, TURNL, filledu, filledunext);
            }
	    jl += 2; continue;
         }
#endif
         if(cross[vnumr][jr] == STOREDL || cross[vnumr][jr+1] == STORED)
         { /* Either the turn is for strip vnumr or a non-split turn */
	       jr += 2;
               continue;
         }
         if(cross[vnum][jl+2] == STOREDL && cross[vnum][jl+3] != STORED)
         { /* SPLIT the right guy */
            low = cross[vnum][jl];
            high = cross[vnum][jl+3];
            jl += 4;
            split = 1;
         } else
            split = 0;
         if(cross[vnum][jl] == STOREDL && cross[vnum][jl+1] != STORED)
         {/* Merge two new lists */
            list1 = listno;
            listno = lists[listno].prevlist;
            stair(vnumr, cross[vnum][jl+1], cross[vnum][jl+2], CLOSE|SPLIT,
                                                     filledu, filledunext);
            listno = list1;
           
         }

         if(cross[vnumr][jr+2] == STOREDR && cross[vnumr][jr+3] != STORED)
         {/* Create two new lists */
            list1 = listno;/* Leave the current snake undisturbed */
            listno = lists[listno].nextlist;
            stair(vnum, cross[vnumr][jr+1], cross[vnumr][jr+3], OPEN|SPLIT,
                                                     filledu, filledunext);
            listno = list1;
         }
         if(cross[vnumr][jr] == STOREDR)
         { /* SPLIT the left guy, Spl case if need to split left and right */
            if(split)
               printf("*** Unimplemented: Both turn back **** \n");
            low = cross[vnumr][jr+1];
            high = cross[vnumr][jr+3];
            jr += 4;
         } else if(!split) /* Have a pair */
         {
            low = cross[vnum][jl];
            high = cross[vnumr][jr+1];
            jl += 2; jr += 2;
         }

         stair(vnum, low, high, flag, filledu, filledunext);
         flag = 0;

      }

      vline = (VERTEX *) (PtsInternal+vnum); /* TODO: Be PtsInternal[patchno] */
      evallineV(ustepsize, v, vline, nusteps-2, ustepsize, 1, filledu+1);

      cptmp = filledu;
      filledu = filledunext;
      filledunext = cptmp;
      vnum = vnumr;
      v += vstepsize;
   }

   /* Get stuff ready for calling triangulation routine */

   nloops = 0;
   ndata[0] = 0;
   fpos = pos = 1; 
   list = lists+Dlistfront; /* TODO: Do for all Dlists */
   /* if(list->front != list->end) */
   if(Glistfree > 0)
   {
      do {
         list->front = Glist[list->front].next;
         data[pos][0] = Glist[list->front].uv[0];
         data[pos][1] = Glist[list->front].uv[1];
         vert3d[pos++] = Glist[list->front].v;
      } while(list->front != list->end);
      ndata[nloops] = pos-fpos;
      nloops ++;
   }
   
   fpos = pos;

   evalcurve(curves, ncurves, degree, nverts);
   i = 0;
   while(ncurves-- > 0)
   {
      for(jr=0; jr<nverts[ncurves]; jr++,i++)
      {
         data[pos][0] = uvcurve[i][0];
         data[pos][1] = uvcurve[i][1];
         vert3d[pos++] = PtsCurve+i;
      }
      ndata[nloops++] = nverts[ncurves];
   }

   if(pos > MAX_DATA)
      printf("MAX_DATA exceeded: %d > %d\n", ndata, MAX_DATA);
   i = pos + (nloops<<1) - 4 - 1;
   data[0][0] = data[ndata[0]][0];
   data[0][1] = data[ndata[0]][1];
   if((pos = triangulate_polygon(ndata[0], data, tris, 0)) < 0)
   {
      printf("Patch %d: Non Simple Polygon. Steps: %d %d %d %d\n", patchno,
              insteps[0][0], insteps[0][1], insteps[1][0], insteps[1][1]);
      return;
   }
ALLDEBUG(
   printf("\t\t%d Trianges\n", pos);
)
   while(i-- > 0)
   {
      addtri(vert3d[tris[i][0]],vert3d[tris[i][1]],vert3d[tris[i][2]]);
   }
}

bez_surface1(icntrl, iudegree, ivdegree, idglob,
             curve, incurves, degree, skiplen, endpoints)
WTYPE  skiplen;
WTYPE  icntrl[][MAX_ORDER][WCOORD];
byte   endpoints[][MAX_TRIMBREAKS];
byte   iudegree, ivdegree;
DlistGlobalsType *idglob;
byte   incurves;
short  degree[];
TPOINT *curve[];
{
static   int Totmem=0;
static   byte   rsinsteps[NUMCACH][2][2];

int      i;
int      calc, j, k;

dglob = idglob;

/****************** DEBUGGING SETTING *********************/
/* IN */
#define PRIMITIVE

#ifndef PRIMITIVE
FEATURE( 
   if(iudegree > 1 || ivdegree > 1)
      if(BezEnv2->freeze > 0) {
         insteps[0][0] = BezEnv2->freeze;
         insteps[0][1] = BezEnv2->freeze;
         insteps[1][0] = BezEnv2->freeze;
         insteps[1][1] = BezEnv2->freeze;
      }
)
#endif

#ifdef SGI
 if((iudegree > 1 || ivdegree > 1) && donew)
 {
    insteps[0][0] = newin[0];
    insteps[0][1] = newin[1];
    insteps[1][0] = newin[2];
    insteps[1][1] = newin[3];
 }
#endif

/****************** DEBUGGING SETTING *********************/

    calc = 0;
#ifndef PRIMITIVE
FEATURE(
    if(BezEnv2->freeze < 0)
    {
       {CPrintf("Frozen\n");}
       insteps[0][0] = sinsteps[patchno][0][0];
       insteps[0][1] = sinsteps[patchno][0][1];
       insteps[1][0] = sinsteps[patchno][1][0];
       insteps[1][1] = sinsteps[patchno][1][1];
    } else
)
#endif

FEATURE(
    if(patchno < NUMCACH)
) /* FEATURE */
    {
       if(!patchinit[patchno])
       {
FEATURE(
	  {Printf("Init Patch %d\n", patchno);}
)
          sinsteps[patchno][0][0] = sinsteps[patchno][0][1] =
          sinsteps[patchno][1][0] = sinsteps[patchno][1][1] = -1;
          lastskiplen[patchno] = -1;
          patchinit[patchno] = 1;
       }

       /* if(flat) */
       {
          if(lastskiplen[patchno] != skiplen)
          {
              calc = 1;
              lastskiplen[patchno] = skiplen;
          }
          else calc = 0;
          /* insteps[0][0] = insteps[0][1] = insteps[1][0] = */
          		/* insteps[1][1] = 1; */
       }
       if(! flat) 
       {
       if(	/*!patchinit[patchno] ||*/
          insteps[0][0] > sinsteps[patchno][0][0]+HYSTERESIS ||
          insteps[0][0] < sinsteps[patchno][0][0]-HYSTERESIS)
       {

          sinsteps[patchno][0][0]=insteps[0][0];
          calc = 1;
       }
       else
          insteps[0][0] = sinsteps[patchno][0][0];

       if(/*!patchinit[patchno] ||*/
          insteps[0][1] > sinsteps[patchno][0][1]+HYSTERESIS ||
          insteps[0][1] < sinsteps[patchno][0][1]-HYSTERESIS)
       {
          sinsteps[patchno][0][1]=insteps[0][1];
          calc = 1;
       }
       else
          insteps[0][1] = sinsteps[patchno][0][1];

       if(/*!patchinit[patchno] ||*/
          insteps[1][0] > sinsteps[patchno][1][0]+HYSTERESIS ||
          insteps[1][0] < sinsteps[patchno][1][0]-HYSTERESIS)
       {
          sinsteps[patchno][1][0]=insteps[1][0];
          calc = 1;
       }
       else
          insteps[1][0] = sinsteps[patchno][1][0];

       if(/*!patchinit[patchno] ||*/
          insteps[1][1] > sinsteps[patchno][1][1]+HYSTERESIS ||
          insteps[1][1] < sinsteps[patchno][1][1]-HYSTERESIS)
       {
          sinsteps[patchno][1][1]=insteps[1][1];
          calc = 1;
       }
       else
          insteps[1][1] = sinsteps[patchno][1][1];
       }
    }
    else {
       printf("Patch %d not in cache\n", patchno); exit(1);
    }

ALLDEBUG(
   {CPrintf("in = %d: insteps = %d %d %d %d\n",in[patchno],insteps[0][0],
                         insteps[0][1], insteps[1][0], insteps[1][1]);}
)

    if(!in[patchno]) return;

/* WAS    if(!calc && patchno < NUMCACH && */
    if (rsinsteps[patchno][0][0] != sinsteps[patchno][0][0] ||
        rsinsteps[patchno][0][1] != sinsteps[patchno][0][1] ||
        rsinsteps[patchno][1][0] != sinsteps[patchno][1][0] ||
        rsinsteps[patchno][1][1] != sinsteps[patchno][1][1] )
    {
       calc = 1;
       rsinsteps[patchno][0][0] = sinsteps[patchno][0][0];
       rsinsteps[patchno][0][1] = sinsteps[patchno][0][1];
       rsinsteps[patchno][1][0] = sinsteps[patchno][1][0];
       rsinsteps[patchno][1][1] = sinsteps[patchno][1][1];
    }

   FEATURE(if(changed_patch) {calc = 1;})
   FEATURE(if(arbit == -1) calc = 1;)

/* calc = 1; */

ALLDEBUG(
    if(calc)
    {
        printf("tindex[%d] = %d --- ", patchno, tindex[patchno]);
        printf("New insteps = %d %d %d %d, Skiplen = %g\n",
               insteps[0][0], insteps[0][1], insteps[1][0], insteps[1][1],
               skiplen);
    }
    if(calc && rc_refine_pass() == 1 && ros_gpnum == 1)
      ros_printf("calc = %d, changed_patch = %d, arbit = %d\n",
                                        calc,changed_patch,arbit);
)
/****************** NEW  SETTING *********************/
#ifdef SGI
if(Compute) {/* stored = 0;*/  numtris = 0;}
#endif

#ifdef PXPL
   if(calc)
   {
      tindex[patchno] = 0;
   }
   else
   {
      if(in[patchno])
         render_Tris(1, 0, 0, 0, dglob);
      return;
   }
#else
 if(calc) {tindex[patchno] = 0;}
 else
 {
 for(i=0; i<tindex[patchno]; i++)
 render_Tris(0, &storetris[patchno][i][0],
            &storetris[patchno][i][1], &storetris[patchno][i][2],dglob);
 return;
 }
#endif

#ifdef SGI
/* Compute = 0; */
#endif

/* stored[patchno] = 1; */
   cntrl = icntrl;
   udegree = iudegree;
   vdegree = ivdegree;
   ncurves = incurves;
   coord = WCOORD;
   stepsize[0][0] = 1.0/insteps[0][0];
   stepsize[0][1] = 1.0/insteps[0][1];
   stepsize[1][0] = 1.0/insteps[1][0];
   stepsize[1][1] = 1.0/insteps[1][1];
   nusteps = (insteps[0][0]>insteps[0][1])?insteps[0][0]:insteps[0][1];
   nvsteps = (insteps[1][0]>insteps[1][1])?insteps[1][0]:insteps[1][1];
   ustepsize = 1.0/nusteps;
   vstepsize = 1.0/nvsteps;

#ifndef STATICMEM
#ifdef PXPL

      cum_degrees = 0;
      for(i=0; i<incurves; i++)
         cum_degrees += (degree[i]+1);
      max_tri = (nusteps+1)*(nvsteps+1)*2+cum_degrees;

      if(max_tri > num_tri[patchno] || max_tri < num_tri[patchno]-10)
      {
         if((P[patchno]) != NULL)
         {
            free(P[patchno]);
         }
         P[patchno] = (TriangleRecord *)
                    malloc(max_tri * sizeof(TriangleRecord));
         if(P[patchno] == NULL)
         {
            printf("Error in malloc\n");
            printf("\t Maximum memory used: %d, Current usage %d\n",
                    Maxmem, Totmem);
         }
FEATURE(
         Totmem +=  max_tri-num_tri[patchno];     /* Just for Stat */
         if(Totmem > Maxmem) Maxmem = Totmem; /* All this for Stat */
         num_tri[patchno] = max_tri;
)
      } else
         max_tri = num_tri[patchno];
#endif
#else /* IS Static Mem */
      max_tri = MAX_TRI;
#endif

ALLDEBUG(
 {Printf("Degree: %d\n", degree[0]);}
)

   for(i=0; i<udegree; i++)
     for(j=0; j<=vdegree; j++)
      {
         for(k=0; k<WCOORD; k++)
            cntrl2[i][j][k] = cntrl[i+1][j][k]-cntrl[i][j][k];
      }
   for(i=0; i<=udegree; i++)
      for(j=0; j<vdegree; j++)
      {
         for(k=0; k<WCOORD; k++)
            cntrl3[i][j][k] = cntrl[i][j+1][k]-cntrl[i][j][k];
      }

   if(ncurves)
      if(nusteps > 2 && nvsteps > 2 /* and TEMPly */ && ncurves == 1)
      {
         if(ncurves > 1) {
            printf("Code going into unchartered territory -- Have fun ..\n");
            ncurves = 1; /* Tmp Hack */}
         /* trim(curve, ncurves, degree, nusteps, nvsteps, skiplen, endpoints); */
         trim(curve, ncurves, degree, nusteps, nvsteps, -1, endpoints);
         triangulate_cells(curve, incurves, degree);
      } else
      {
         triangulate_withcurve(curve, ncurves, degree);
      }
   else
      SimplePatch();

   render_Tris(1, 0, 0, 0, idglob); /* Now go and render all triangles */
}


estimate1(idx, idx2, degree, uorv, dglob) /* TODO, currently set at min */
int idx, idx2, degree, uorv;
DlistGlobalsType *dglob;
{
int i, k;
WTYPE tmp1, tmp2;
WTYPE cntrlp[MAX_ORDER][WCOORD];
WTYPE cntrlp1[2][WCOORD];
WTYPE cntrlp2[2][WCOORD];

   if(degree == 1)
   {
      curvadd[patchno][uorv][idx] = MINSTEPS;
      return;
   }
   for(i=0; i<degree; i++)
   {
      for(k=0; k<coord; k++)
      { /* Smaller code rather than efficiency */
            cntrlp1[i][k] = uorv?
                (cntrl[idx2][i+1][k]-cntrl[idx2][i][k]):
                (cntrl[i+1][idx2][k]-cntrl[i][idx2][k]);
      }
   }

   bez_curve(cntrlp1, degree-1, 1, cntrlp, 0.0, TOLERANCE, coord);
   if(coord == WCOORD)
   {
      for(i=0; i<=degree; i++)
         for(k=0; k<coord; k++)
            if(uorv)
               cntrlp1[i][k] = cntrl[idx2][i][k];
            else
               cntrlp1[i][k] = cntrl[i][idx2][k];
      bez_curve(cntrlp1, degree, 1, cntrlp2, 0.0, TOLERANCE, coord);
      for(i=0; i<2; i++)
      {
         tmp1 = 1.0/cntrlp2[i][COORD];
         for(k=0; k<COORD; k++)
         {
            cntrlp2[i][k] *= tmp1;
            cntrlp[i][k] = tmp1 * (cntrlp[i][k] -
                                cntrlp2[i][k]*cntrlp[i][COORD]);
         }
      }
   }
   tmp1 = (cntrlp[1][0]-cntrlp[0][0]); tmp2 = tmp1*tmp1;
   tmp1 = (cntrlp[1][1]-cntrlp[0][1]); tmp2 += tmp1*tmp1;
	   tmp1 = (cntrlp[1][2]-cntrlp[0][2]); tmp2 += tmp1*tmp1;

   /* curvadd[patchno][uorv][idx] = SQRT(DOUBLE tmp2)*BezEnv.curvparam + 1; */
   curvadd[patchno][uorv][idx] = 1;

   ERR(
	      if(curvadd[patchno][uorv][idx] < 1)
	      {
		 curvadd[patchno][uorv][idx] = 1;
		 printf("Negative Curvature addition Patch %d[%d][%d]\n",
			  patchno, uorv, idx);
	      }
   )
   if(curvadd[patchno][uorv][idx] > MAX_CURVATUR)
      curvadd[patchno][uorv][idx] = MAX_CURVATUR;
}

curvature_estimate(dglob)
DlistGlobalsType *dglob;
{

   estimate1(0, 0, udegree,  0, dglob);
   estimate1(1, vdegree, udegree, 0, dglob);
   estimate1(0, 0, vdegree,  1, dglob);
   estimate1(1, udegree, vdegree,  1, dglob);
}

bez_surface(cntrl, udegree, vdegree,
	    dglob, curve, ncurves, degree,
	    endpoints)
WTYPE cntrl[][MAX_ORDER][WCOORD]; /* Temporarily */
/* WTYPE 		 *cntrl; */
byte              udegree, vdegree;
DlistGlobalsType *dglob;
TPOINT           *curve[];
byte              ncurves;
short             degree[];
byte              endpoints[][MAX_TRIMBREAKS];
{
WTYPE cntrlp[MAX_ORDER*MAX_ORDER][WCOORD], pt1[WCOORD];
WTYPE tmp2;
int   div;
WTYPE maxx, minx, maxy, miny;
int               scale = 0;
WTYPE tmp, invfovx, invfovy;
WTYPE minwu[MAX_ORDER], minwv[MAX_ORDER], maxu[MAX_ORDER], maxv[MAX_ORDER];
int   far, i, j, k, l;
int   nusteps, nvsteps;
int   coord;
#define  TMPHACKFORSKIPPING
#ifdef TMPHACKFORSKIPPING
TPOINT tcurve[MAX_CORDER];
TPOINT *tcurvep[1];
WTYPE  wi;
int    endcnt;
short  tdegree;
/* byte   tendpoints[MAX_TRIMBREAKS]; */
#endif

TRACE( printf("In bez_surface: Pass = %d\n", rc_refine_pass());)

ALLDEBUG(
   printf("Patch %d:\n", patchno);
   printf("%d %d\n", (int) udegree, (int) vdegree);
   for(i=0; i<=udegree; i++)
      for(j=0; j<=vdegree; j++)
	  printf("%g %g %g %g\n", cntrl[i][j][0], cntrl[i][j][1],
				cntrl[i][j][2], cntrl[i][j][3]);
   printf("%d\n", (int) ncurves);
   for(i=0; i<ncurves; i++)
   {
      printf("%d\n", (int) degree[i]);
      for(j=0; j<=degree[i]; j++)
	 printf("%g %g\n", curve[i][j][0], curve[i][j][1]);
   }
   printf("PATCH %d DONE.\n", patchno);
)
ALLDEBUG(
    for(i=0; i<=degree[0]; i++)
      ros_printf("%f %f\n", curve[0][i][0], curve[0][i][1]);
)

   /* if(rc_refine_pass() == 1) */
   {
#if 0
/* 			Old skip trials ...
 * skiplen = 1.0 + (WTYPE) BezEnv->newskiplen/
 *  ((insteps[0][0]+insteps[0][1]+1)*(insteps[1][0]+insteps[1][1]+1));
 * skiplen = (WTYPE) (degree[0])/
 *  ((insteps[0][0]+insteps[0][1]+2)+(insteps[1][0]+insteps[1][1]+2));
 * if(BezEnv->newskiplen > 1.0)
 *    skiplen *= BezEnv->newskiplen;
 * else if(BezEnv->newskiplen < 0.0)
 *    skiplen = -BezEnv->newskiplen;
 * if(skiplen < 1.0) skiplen = 1;
 * if(skiplen > 10) skiplen = 10;
 */
#endif

   skiplen = BezEnv.newskiplen;

#ifdef SGI
      invfovy = tanxy;
      invfovx = tanxy;
#else
      invfovx = 1280; invfovy = 1024; fov = 1;
#endif

#ifdef JUNKMAYBENEEDED
      if(!Computebounds)
      {
	 upath = vpath = udepth = vdepth = 0; coord = scoord[patchno];
	 insteps[0][0] = sinsteps[patchno][0][0];
	 insteps[0][1] = sinsteps[patchno][0][1];
	 insteps[1][0] = sinsteps[patchno][1][0];
	 insteps[1][1] = sinsteps[patchno][1][1];
#ifdef PXPL
	 render_Tris(1, 0, 0, 0, dglob);
	 return;
#endif
	 Bez_surface(cntrl, udegree, vdegree, nusteps, nvsteps, insteps,
	       dglob, coord);
	 return;
      }
#endif

      for(j = 0; j <= udegree; j++)
      {
	 minwv[j] = INFINITY;
	 maxv[j] = -INFINITY;
      }
      for(j = 0; j <= vdegree; j++)
      {
	 minwu[j] = INFINITY;
	 maxu[j] = -INFINITY;
      }
/*
FEATURE(
      if(BezEnv->Flags&F_EACHFRAMETEST)
	 in[patchno] = 0;
      else
)
	 in[patchno] = 1;
*/


      in[patchno] = 0; /* Do view volume Visibility */
/*    in[patchno] = 1; /* Do not do view volume Visibility */

      flat = ((udegree == 1) && (vdegree == 1));

      coord = gcoord;

      if(!patchinit[patchno])
      {

	 curvature_estimate(dglob); /* Fills curvadd[patchno] */
ALLDEBUG(
	  printf("curvparam = %g: add = %d %d %d %d\n", BezEnv.curvparam,
		curvadd[patchno][0][0], curvadd[patchno][0][1],
		curvadd[patchno][1][0], curvadd[patchno][1][1]);
)
      }

   if(scale)
   {
      insteps[0][0] = insteps[0][1] = insteps[1][0] = insteps[1][1] = scale;
      in[patchno] = 1;
#ifdef TMPHACKFORSKIPPING
      if(ncurves == 1) /* Must have <= one trim curve. That's the hack */
      {
         skiplen = (WTYPE) degree[0]/(scale*2*3);
      printf("Scale is %d, skiplen is %g\n", scale, skiplen);
         if(skiplen < 1) skiplen = 1;
         /* if(skiplen < 2) printf("Skip what, %g?\n", skiplen); */
      if(skiplen > 1.3) /* Not worth it, otherwise */
      {
         endcnt = 0;
         tcurvep[0] = &tcurve[0];
         tcurve[0][U] = curve[0][0][U];
         tcurve[0][V] = curve[0][0][V];
         i = j = 0; wi = 0;
         while(i < degree[0])
         {
ALLDEBUG(
            printf("endpoints[0][%d]: %d; skiplen = %g, %d <- %d\n",
                    endcnt, 0+endpoints[0][endcnt], skiplen, j, i);
)
            if(endpoints[0][endcnt] == 0)
               endpoints[0][endcnt] = degree[0];
            i = wi += skiplen; j++;
            if(i ==  endpoints[0][endcnt])
               {endcnt ++;}
            else if(endpoints[0][endcnt] && i > endpoints[0][endcnt])
               {i = endpoints[0][endcnt]; endcnt ++;}
            ERR(
            if(endcnt > MAX_TRIMBREAKS)
            {
               printf("GP%d: Patch %d: Many trim breaks: %d\n",
                 ros_gpnum, patchno, endcnt);
            }
            )
            tcurve[j][U] = curve[0][i][U];
            tcurve[j][V] = curve[0][i][V];
         } endpoints[0][endcnt-1] = 0;
         if(i != degree[0])
         {
            j++;
            tcurve[j][U] = curve[0][degree[0]][U];
            tcurve[j][V] = curve[0][degree[0]][V];
         }
         tdegree = j;
      } else
      {
         tdegree = degree[0];
         tcurvep[0] = &curve[0][0];
      }
        
      }
#endif
   } else
   {
      for(l= 0,j = 0; j <= udegree; j++)
	 for(k = 0; k <= vdegree; k++,l++)
	 {
	    /* FEATURE(if(cntrl[j][k][COORD] != 1.0) coord = WCOORD;) */
#ifdef SGI
	    XFORMP(cntrl[j][k], pt1);
	    far = 1;
	    /* pt1[2] < -hither; ?  OR /* far = pt1[2] > hither;  */
#else
	    XFORMP(pt1, dglob->fdata.environ.screen_mat, cntrl[j][k], coord);
	    far = pt1[Z] >= dglob->zresinv;
	    /* far = 1; */
#endif
	    tmp = 1.0/pt1[Z];
	    cntrlp[l][X] =  pt1[X]*tmp;
	    cntrlp[l][Y] =  pt1[Y]*tmp;
	      /* if(maxy < cntrlp[l][Y]) maxy = cntrlp[l][Y]; */
	      /* if(miny > cntrlp[l][Y]) miny = cntrlp[l][Y]; */
	      /* if(maxx < cntrlp[l][X]) maxx = cntrlp[l][X]; */
	      /* if(minx > cntrlp[l][X]) minx = cntrlp[l][X]; */
/*
FEATURE(
	   if(BezEnv->Flags&F_EACHFRAMETEST)
)
*/
	   {
#ifdef SGI
	    if(!in[patchno] && far &&
		 cntrlp[l][0] < invfovx && cntrlp[l][0] > -invfovx &&
		 cntrlp[l][1] < invfovy && cntrlp[l][1] > -invfovx)
	       in[patchno] = 1;
#else
	    if(!in[patchno] && far &&
		 cntrlp[l][0] < invfovx && cntrlp[l][0] > 0 &&
		 cntrlp[l][1] < invfovy && cntrlp[l][1] > 0)
	       in[patchno] = 1;
#endif
	    }

	    /* if(flat) continue; */
	    /* Rockwood's tests */
	    if(cntrl[j][k][COORD] < minwu[k]) minwu[k]=cntrl[j][k][COORD];
	    if(cntrl[j][k][COORD] < minwv[j]) minwv[j]=cntrl[j][k][COORD];
	    if(j > 0)
	    {
	      if((tmp=diffnorm(cntrlp[l],cntrlp[l-vdegree-1])) > maxu[k])
		 maxu[k] = tmp;
	    }
	    if(k > 0)
	    {
	       if((tmp = diffnorm(cntrlp[l], cntrlp[l-1])) > maxv[j])
		 maxv[j] = tmp;
	    }

ALLDEBUG (
     Printf("Point %d: %g %g %g\n",
		  l,cntrl[j][k][0],cntrl[j][k][1],cntrl[j][k][2]);
     Printf("Result: %g %g %g\n", cntrlp[l][0],cntrlp[l][1],cntrlp[l][2]);
)
	 }
	 FEATURE(   if(coord != gcoord)
	       printf("COORD WRONG: Using the correct one\n");)

	 /* if(maxx-minx < 10 || maxy-miny < 10) */
	       /* return; */

#ifndef PRIMITIVE
FEATURE(
      if(BezEnv->Flags&F_BIGCRACKS)
	 if(!in[patchno]) return;
)
#endif


/* eg Find max of lengths of v=0 and v=1 -- u marches along that dir */

   div = 0;

#define HIGHDEG

   /* if(!insteps[0][0]) */
   {
      insteps[0][0] = curvadd[patchno][0][0] +
		(udegree*SQRT2*maxu[0])/(BezEnv.tolerance*minwu[0]);
   }
   /* if(!insteps[0][1]) */
   {
      insteps[0][1] = curvadd[patchno][0][1] +
      (udegree*SQRT2*maxu[vdegree])/ (BezEnv.tolerance*minwu[vdegree]);
   }

   /* if(!insteps[1][0]) */
   {
       insteps[1][0] = curvadd[patchno][1][0] +
       (vdegree*SQRT2*maxv[0])/(BezEnv.tolerance*minwv[0]);
   }
   /* if(!insteps[1][1]) */
   {
      insteps[1][1] = curvadd[patchno][1][1] +
      (vdegree*SQRT2*maxv[udegree])/ (BezEnv.tolerance*minwv[udegree]);
   }

#ifdef HIGHDEG
      if(udegree > 3 || vdegree > 3)
      {
	  insteps[0][0] = SQRT(DOUBLE insteps[0][0])+1;
	  insteps[0][1] = SQRT(DOUBLE insteps[0][1])+1;
	  insteps[1][0] = SQRT(DOUBLE insteps[1][0])+1;
	  insteps[1][1] = SQRT(DOUBLE insteps[1][1])+1; 
      }
#endif

   }
   }

ALLDEBUG(
      printf("D %d %d %f %f %f %f %f %f\n", 
      udegree,vdegree,SQRT2,maxv[udegree],fov,BezEnv.tolerance,minwv[udegree],
      (vdegree*SQRT2*maxv[udegree]*fov)/(BezEnv.tolerance*minwv[udegree]));
)

FEATURE(
   CPrintf("skiplen: %f, degree %d\n", skiplen, degree[0]);
   CPrintf("%d %d %d %d -- ",
       insteps[0][0],insteps[0][1],insteps[1][0],insteps[1][1]);
   CPrintf("%d\n",
       (insteps[0][0]+insteps[0][1]+2)+(insteps[1][0]+insteps[1][1]+2));
)

#if 0
   if(flat && (skiplen > 0))
      skiplen = skiplen * (WTYPE) (degree[0])/
       ((insteps[0][0]+insteps[0][1]+2)+(insteps[1][0]+insteps[1][1]+2));
   ALLDEBUG( printf("skiplen: %f\n", skiplen);)
#endif

   if(udegree == 1)
      insteps[0][0] = insteps[0][1] = MINSTEPS;
   if(vdegree == 1)
      insteps[1][0] = insteps[1][1] = MINSTEPS;

   {

ALLDEBUG(
  {CPrintf("insteps = %d %d %d %d -- ", insteps[0][0], insteps[0][1],
		insteps[1][0], insteps[1][1]);}
  {CPrintf("add = %d %d %d %d\n",
		curvadd[patchno][0][0], curvadd[patchno][0][1],
		curvadd[patchno][1][0], curvadd[patchno][1][1]);}
)

#ifdef THERESABUG
      if(insteps[0][0] < minsteps) insteps[0][0] = minsteps;
      if(insteps[0][1] < minsteps) insteps[0][1] = minsteps;
      if(insteps[1][0] < minsteps) insteps[1][0] = minsteps;
      if(insteps[1][1] < minsteps) insteps[1][1] = minsteps;
#endif
      if(insteps[0][0] > MAX_NO_POINTS+1) insteps[0][0] = MAX_NO_POINTS+1;
      if(insteps[0][1] > MAX_NO_POINTS+1) insteps[0][1] = MAX_NO_POINTS+1;
      if(insteps[1][0] > MAX_NO_POINTS+1) insteps[1][0] = MAX_NO_POINTS+1;
      if(insteps[1][1] > MAX_NO_POINTS+1) insteps[1][1] = MAX_NO_POINTS+1;
ALLDEBUG(
      CPrintf("\t\tINSTEPS: %d %d %d %d. SKIP %f\n", insteps[0][0],
	      insteps[0][1], insteps[1][0], insteps[1][1], skiplen);
)
#ifdef TMPHACKFORSKIPPING
      if(scale)
      {
      bez_surface1(cntrl, udegree, vdegree, dglob,
	  tcurvep, ncurves, &tdegree, skiplen, endpoints);
      }
      else
#endif
      bez_surface1(cntrl, udegree, vdegree, dglob,
	  curve, ncurves, degree, skiplen, endpoints);
   }
}

/* Take these things into bez_util.c */
bez_curve(cntrl, degree, nsteps, ptlist, luv, ruv, coord)
WTYPE cntrl[][WCOORD];
WTYPE ptlist[][WCOORD];
WTYPE luv, ruv;
int degree, nsteps, coord;
{
register int i;
WTYPE    step, u;

   step = (ruv-luv)/(WTYPE)nsteps;
   u = luv;
   for(i=0; i<=nsteps; i++)
   {

      bez_pt(cntrl, degree, u, ptlist[i], coord);
      u += step;

   }
}

Triline(numboundary, numinside, ptsboundary, ptsinside)
int numboundary, numinside;
VERTEX ptsboundary[], ptsinside[];
{
register int   idx0, idx1;
register WTYPE    ratio, r2;

   if(numinside < 0 || numboundary < 0)
      return;
   if(numinside == 0)
      r2 = numboundary;
   else
   {
      ratio = (WTYPE) (numboundary) / (numinside) ;
      r2 = 0.0;
   }
   idx0 = 0; idx1 = 0;
   /* while(idx0 <= numboundary || idx1 <= numinside) */
   while(1)
   {
      if(r2 > idx0)
      {
         if(idx0 == numboundary) break;
         addtri(ptsboundary+idx0, ptsboundary+idx0+1, ptsinside+idx1);
         idx0++;
      } else
      {
         if(idx1 == numinside) break;
         addtri(ptsboundary+idx0, ptsinside+idx1+1, ptsinside+idx1);
         r2 += ratio;
         idx1++;
      }
   }
}

Trihline(numboundary, numinside, ptsboundary, ptsinside, rev)
int numboundary, numinside;
VERTEX ptsboundary[], *ptsinside[];
int rev;
{
register int   idx0, idx1;
register WTYPE ratio, r2;

   if(numinside < 0 || numboundary < 0)
      return;
   if(numinside == 0)
      r2 = numboundary;
   else
   {
      ratio = (WTYPE) (numboundary) / (numinside) ;
      r2 = 0.0;
   }
   
   idx0 = 0; idx1 = 0;
   while(1)
   {
      if(r2 > idx0)
      {
         if(idx0 == numboundary) break;
         if(rev)
            addtri(ptsboundary+idx0+1, ptsboundary+idx0, ptsinside[idx1]);
         else
            addtri(ptsboundary+idx0, ptsboundary+idx0+1, ptsinside[idx1]);
         idx0++;
      } else
      {
         if(idx1 == numinside) break;
         if(rev)
            addtri(ptsboundary+idx0, ptsinside[idx1], ptsinside[idx1+1]);
         else
            addtri(ptsboundary+idx0, ptsinside[idx1+1], ptsinside[idx1]);
         r2 += ratio;
         idx1++;
      }
   }
}

SimplePatch()
{
VERTEX *hline[MAX_NO_POINTS+2], *PtL, *PtR, *Pt;
register int i, j;
WTYPE v;


   evallineV(0.0, 0.0, PtsBoundary[0], insteps[0][0], stepsize[0][0], 0, 0);
   evallineV(0.0, 1.0, PtsBoundary[1], insteps[0][1], stepsize[0][1], 0, 0);
   if(nvsteps == 1)
   {
      Triline(insteps[0][0], insteps[0][1], PtsBoundary[0], PtsBoundary[1]);
      return;
   }
   evallineU(stepsize[1][0], 0.0,PtsBoundary[2],insteps[1][0]-2,stepsize[1][0]);
   evallineU(stepsize[1][1], 1.0,PtsBoundary[3],insteps[1][1]-2,stepsize[1][1]);

   if(nusteps == 1)
   {
      Triline(insteps[1][1]-2,insteps[1][0]-2,PtsBoundary[3],PtsBoundary[2]);
      i = 1;
      if(insteps[1][0]>1)
      {
         hline[0] = PtsBoundary[2];
         hline[2] = PtsBoundary[2]+insteps[1][0]-2 ;
         j = 3;
      }
      else
      {
         hline[0] = PtsBoundary[1]+0;
         j = 2;
	 i--;
      }
      if(insteps[1][1]>1)
      {
         hline[1] = PtsBoundary[3];
         hline[j] = PtsBoundary[3]+insteps[1][1]-2 ;
      }
      else
      {
         hline[1] = PtsBoundary[1]+1;
         hline[j] = PtsBoundary[1]+0; /* start 2nd Trihline at j (2 or 3) */
	 i--; /* i-- can happens only once */
      }
      Trihline(1, 1, PtsBoundary[0], hline, 0);
      Trihline(i, 1, PtsBoundary[1], hline+2, 1);
#if 0
      addtri(PtsBoundary[0]+0,  PtsBoundary[0]+1,  PtsBoundary[3]+0);
      addtri(PtsBoundary[3]+0,  PtsBoundary[2]+0,  PtsBoundary[0]+0);
      addtri(PtsBoundary[2]+insteps[1][0]-2,
             PtsBoundary[3]+insteps[1][1]-2,  PtsBoundary[1]+1);
      addtri(PtsBoundary[1]+1,  PtsBoundary[1]+0,
             PtsBoundary[2]+insteps[1][0]-2);
#endif
      return;
   }

   v = vstepsize;
   evallineV(ustepsize, v, PtsInternal[0], nusteps-2, ustepsize, 0, 0);
   Pt = PtR = (VERTEX *) PtsInternal;
   for(i=1; i<nvsteps-1; i++)
   {
      v += vstepsize;
      evallineV(ustepsize, v, PtsInternal[i], nusteps-2, ustepsize, 0, 0);
      PtL = Pt;
      Pt = PtR = (VERTEX *) PtsInternal[i];
      for(j=2; j<nusteps; j++)
      {
         PtR++;
         addtri(PtL+1, PtR, PtL);
         addtri(PtR-1, PtL, PtR);
         PtL++;
      }
   }

   Triline(insteps[0][0], nusteps-2, PtsBoundary[0], PtsInternal[0]);
   Triline(nusteps-2, insteps[0][1], PtsInternal[nvsteps-2], PtsBoundary[1]);
   for(i = 0, j=1; j<nvsteps; j++)
   {
      hline[j] = (VERTEX *) PtsInternal[i];
      i = j;
   }
   hline[0] = &PtsBoundary[0][0];
   hline[nvsteps] = &PtsBoundary[1][0];
   if(insteps[1][0] == 1)
   Trihline(0, nvsteps-1, PtsBoundary[1], hline, 1); /* TODO HACK? chk later. */
   else Trihline(insteps[1][0]-2, nvsteps, PtsBoundary[2], hline, 1);
   for(i = 0, j=1; j<nvsteps; j++)
   {
      hline[j] = ((VERTEX *) PtsInternal[i]) + nusteps - 2;
      i = j;
   }
   hline[0] = &PtsBoundary[0][insteps[0][0]];
   hline[nvsteps] = &PtsBoundary[1][insteps[0][1]];
   if(insteps[1][1] == 1)
   Trihline(0, nvsteps-1, PtsBoundary[1]+insteps[0][1], hline, 0);
   else Trihline(insteps[1][1]-2, nvsteps, PtsBoundary[3], hline, 0);
}

#endif
