#ifdef __GL

#include "colortrim.h"

#define TRIM_C
#include "BezVars.h"

#define MIN		0x0
#define MAX		0x1
#define TURNL		0x2
#define TURNR		0x4
#define TURN		0x6
#define SPLIT		0x8
#define RETAIN		0
#define HOLE		1
#define LEFT		0x1
#define RIGHT		0x10

/* char   cross[MAX_NO_POINTS][MAX_CROSS]; */
/* int    minvnum, maxvnum; */

trim(tcurve, ncurves, degree, nusteps, nvsteps)
TPOINT *tcurve[];
int     ncurves, nusteps, nvsteps;
short   degree[];
{
WTYPE  fcross[MAX_NO_POINTS][MAX_CROSS];
int    dir, gdir, cdir, c,i,j,p,xchg, tmp;
int    firstmin, firstmax, firstcount, firstcross;
int    nocross, lastmax, prevcross;
TPOINT *curve;
int    unum, vnum, prevvnum;
WTYPE  gmin, minu, ustepsize, vstepsize, v, prevv, prevu, firstu, u, pu;
WTYPE  min, max, ftmp;
char   count[MAX_NO_POINTS]; /* MAX_NO_POINTS always < 256 */
char   type[MAX_NO_POINTS][MAX_CROSS];

   ustepsize = 1.0/nusteps;
   vstepsize = 1.0/nvsteps;
   gmin = 1.0; minvnum = 1; maxvnum = 0;

   for(c=0; c<ncurves; c++)
   {
      curve = tcurve[c];

      for(vnum=0; vnum<=nvsteps; vnum++)
         count[vnum] = 1;
      prevv = curve[(p = degree[c]-1)][V];
      min = max = minu = pu = curve[p][U];
      while(curve[--p][V] == prevv);
      if(prevv < curve[p][V])    
	dir = LEFT;
      else
	dir = RIGHT;
      if(dir & LEFT)
         prevvnum = (prevv+F_DELTA)*nvsteps;
      else
         prevvnum = (prevv-F_DELTA)*nvsteps;
      nocross = 1; prevcross = -1;
     
      for(p=0; p<degree[c]; p++) /* start at the first point */
      {
		/* OR (curve[p][V]+F_DELTA)*nvsteps); */
         v = curve[p][V];
         if(v < prevv)
            dir = LEFT;
         else if(v > prevv)
            dir = RIGHT;
         if(dir & LEFT) /* Say CROSS only if it goes PAST */
            vnum = (v+F_DELTA)*nvsteps;
         else
            vnum = (v-F_DELTA)*nvsteps;
/*       if(vnum != prevvnum || v==0) /* Crossed a v-line, Find min or max u */
         if(vnum != prevvnum) 	      /* Crossed a v-line, Find min or max u */
         { /* Keep vnum, not the real cross-line as left most active
	    * v-line is left to the real cross line, or rather it is
	    * that v-line that has the info about the turn to its right.
            */
            u = (curve[p][U]-pu)*(vnum*vstepsize-prevv)/(v-prevv)+pu;
            if(nocross)
            {
               firstmin = min;
               firstmax = max;
               firstcross = prevvnum;
               firstcount = count[prevvnum];
               firstu = u;
            }
            if(dir & LEFT)			     /* Moving Left: Is a min */
            {
               if(curve[p][U] < minu)
               {
		  minu = curve[p][U];
		  cdir = RETAIN;
               }
               if(prevcross == prevvnum) /* Turn back to left */
               { /* Keep this info at the turn */
                  type[prevvnum][count[prevvnum]] = TURNL;
	          if(u > prevu)
		  {
                     type[prevvnum][count[prevvnum]] |= SPLIT;
                     fcross[prevvnum][count[prevvnum]] = prevu+F_DELTA;
		  }
		  else
                     fcross[prevvnum][count[prevvnum]] = u+F_DELTA;
                  cross[prevvnum][count[prevvnum]++] = (min-F_DELTA)*nusteps;
			/* cross will be discarded if !SPLIT */
               }
               while(prevvnum > vnum)
               {
                  type[prevvnum][count[prevvnum]] = MIN;
                  fcross[prevvnum][count[prevvnum]] = u;
                  cross[prevvnum][count[prevvnum]++]= (max+F_DELTA)*nusteps + 1;
                  max = u;
                  u = (curve[p][U]-pu)*(prevvnum*vstepsize-prevv)/(v-prevv)+pu;
		  /* TODO A part of this u is already there. Use it */
                  prevvnum--;
               }
               prevcross = vnum+1;
            } else          			    /* Moving Right: Is a MAX */
            {
               if(curve[p][U] < minu)
               {
		  minu = curve[p][U];
		  cdir = HOLE;
               }
               prevvnum ++;
               if(prevcross == prevvnum) /* Turn back to right */
               { /* Keep this info at the turn */
                  type[prevvnum][count[prevvnum]] = TURNR;
	          if(u < prevu)
		  {
                     type[prevvnum][count[prevvnum]] |= SPLIT;
                     fcross[prevvnum][count[prevvnum]] = u+F_DELTA;
		  }
                  else
                     fcross[prevvnum][count[prevvnum]] = prevu+F_DELTA;
                  cross[prevvnum][count[prevvnum]++]= (max+F_DELTA)*nusteps + 1;
			/* cross will be discarded if !SPLIT */
               }
               while(prevvnum <= vnum)
               {
                  type[prevvnum][count[prevvnum]] = MAX;
                  fcross[prevvnum][count[prevvnum]] = u;
                  cross[prevvnum][count[prevvnum]++] = (min-F_DELTA)*nusteps;
                  min = u;
                  u = (curve[p][U]-pu)*(prevvnum*vstepsize-prevv)/(v-prevv)+pu;
		  /* TODO A part of this u is already there. Use it */
                  prevvnum ++;
               }
               prevcross = vnum;
	       if(nocross)
		  firstcross++; /* TODO: Can be neater than this */
            }
            if(prevcross < minvnum ) minvnum = prevcross;
            if(prevcross > maxvnum ) maxvnum = prevcross;
            nocross = 0;
         } else /* vnum == prevvnum => Inside a strip -- just update min,max */
         {
             if(curve[p][U] < min)
                min = curve[p][U];
             if(curve[p][U] > max)
                max = curve[p][U];
         }
 
         prevvnum = vnum;
         prevv = v; prevu = u; pu = curve[p][U];
      }
 
      max = (max > firstmax)? max : firstmax;
      min = (min < firstmin)? min : firstmin;
      if(nocross)
      { /* Hole in a strip? Or just a little piece? */
         if(cdir == HOLE)
         {
	    type[vnum][count[vnum]] = CONTAINED;
	    cross[vnum][count[vnum]++] = min;
	    type[vnum][count[vnum]] = CONTAINED;
	    cross[vnum][count[vnum]++] = max;
         }
      } else
      if(type[firstcross][firstcount] == MIN)
      {
         cross[firstcross][firstcount] = (max+F_DELTA)*nusteps + 1;
         if(firstcross == prevcross) /* Turn back to left */
         {
            type[firstcross][count[firstcross]] = TURNL;
	    if(firstu > prevu)
	    {
               type[firstcross][count[firstcross]] |= SPLIT;
	       fcross[firstcross][count[firstcross]] = prevu+F_DELTA;
	    }
	    else
	       fcross[firstcross][count[firstcross]] = firstu+F_DELTA;
            cross[firstcross][count[firstcross]++] = (min-F_DELTA)*nusteps;
         }
      } else
      {
         cross[firstcross][firstcount] = (min-F_DELTA)*nusteps;
         if(firstcross == prevcross) /* Turn back to right */
         {
            type[firstcross][count[firstcross]] = TURNR;
	    if(firstu < prevu)
	    {
               type[firstcross][count[firstcross]] |= SPLIT;
               fcross[firstcross][count[firstcross]] = firstu+F_DELTA;;
	    }
            else
               fcross[firstcross][count[firstcross]] = prevu+F_DELTA;;
            cross[firstcross][count[firstcross]++] = (max+F_DELTA)*nusteps + 1;
         }
      }

      if(gmin < minu)
      {
         gmin = minu;
         gdir = cdir;
      }
   }

   if(gdir == HOLE)
   {
      minvnum = 0;
      maxvnum = nvsteps;
   }
   
   for(vnum=minvnum; vnum<=maxvnum; vnum++)	  /* Sort and arrange MIN/MAX */
   {
      for(i=1; i<count[vnum]; i++) 			 /* Values start at 1 */
      {
         for(j=count[vnum]-1; j>i; j--)
            if(fcross[vnum][j] < fcross[vnum][j-1])
            {
               xchg = 1;
               ftmp = fcross[vnum][j-1];
               fcross[vnum][j-1] = fcross[vnum][j];
               fcross[vnum][j] = ftmp;
               tmp = cross[vnum][j-1];
               cross[vnum][j-1] = cross[vnum][j];
               cross[vnum][j] = tmp;
               tmp = type[vnum][j-1];
               type[vnum][j-1] = type[vnum][j];
               type[vnum][j] = tmp;
            }
            if(!xchg) break;
      }
						       /* Sorted. Now arrange */
      tmp = 0; j = 0; lastmax = 0;
      for(i=1; i<count[vnum]; i++)
      {
         if(type[vnum][i] & TURNL)
         {
            cross[vnum][j++] = STOREDL;
            cross[vnum][j++] = (type[vnum][i] & SPLIT)? cross[vnum][i] : STORED;
         }
         else if(type[vnum][i] & TURNR)
         {
            cross[vnum][j++] = STOREDR;
            cross[vnum][j++] = (type[vnum][i] & SPLIT)? cross[vnum][i] : STORED;
         }
         else if(type[vnum][i] == CONTAINED)
         {
            cross[vnum][j++] = CONTAINED; /* Bad Hack; fix after tri is coded */
            cross[vnum][j++] = cross[vnum][i];
         }
         else if(type[vnum][i] == MAX)
         {
            if(!lastmax)
            {
               cross[vnum][j++] = tmp;
               cross[vnum][j++] = cross[vnum][i];
            }
            lastmax = 1;
         } else
         {
            lastmax = 0;
            tmp = cross[vnum][i];
         }
      }
      if(!lastmax)
      {
         cross[vnum][j++] = tmp;
         cross[vnum][j++] = nusteps;
      }
      cross[vnum][j] = nusteps; /* ENDMARKER */
   }
}

#endif
