#ifdef __GL

#define SGIDEF2
/* #include "fmclient.h" */
#include "colortrim.h"

extern left;
extern int bezdebug;

extern Matrix M1;
extern WTYPE vx, vy, vz, hx, hy, hz, ex, ey, ez, r, rx, ry, rz, tanxy, hither,
             yon, fov;

negate(a,b)
VECTOR a,b;
{
b[0] = -b[0];
b[1] = a[2]*b[0]-a[0]*b[2];
b[2] = a[0]*b[1]-a[1]*b[0];
}

add(a,b,c)
POINT a,c;
VECTOR b;
{
c[0] = a[0] + b[0];
c[1] = a[1] + b[1];
c[2] = a[2] + b[2];
}

dotp(a,b,c)
VECTOR a,b,c;
{
c[0] = a[0] * b[0];
c[1] = a[1] * b[1];
c[2] = a[2] * b[2];
}

mod(a)
VECTOR a;
{
return SQRT(DOUBLE a[0]*a[0] + a[1]*a[1] + a[2]*a[2]);
}

/*
crossp(a,b,c)
VECTOR a,b,c;
{
c[0] = a[1]*b[2]-a[2]*b[1];
c[1] = a[2]*b[0]-a[0]*b[2];
c[2] = a[0]*b[1]-a[1]*b[0];
}
*/

normalize(a,b)
VECTOR a,b;
{
WTYPE tmp;

tmp = SQRT(DOUBLE a[0]*a[0]+a[1]*a[1]+a[2]*a[2]);
b[0] = a[0]/tmp;
b[1] = a[1]/tmp;
b[2] = a[2]/tmp;
}

big_point(pt)
POINT pt;
{
POINT pt1, pt2;

	pt1[0] = pt[0]+.02; pt1[1] = pt[1]; pt1[2] = pt[2];
	pt2[0] = pt[0]; pt2[1] = pt[1]+.02; pt2[2] = pt[2];
   bgnpolygon();
	v3t(pt);
	v3t(pt1);
	v3t(pt2);
	pt1[0] = pt[0]; pt1[2] = pt[2]+.02;
	v3t(pt1);
   endpolygon();
}

#ifdef DOTPUNDEFINED
#define DOTPROD4I(R, S1, S2, c)		R[c] = \
					S1[X]*S2[X][c] + S1[Y]*S2[Y][c]+ \
					S1[Z]*S2[Z][c] + S1[W]*S2[W][c];
#define DOTPROD4(R, S1, S2)		R = \
					S1[X]*S2[X] + S1[Y]*S2[Y] + \
					S1[Z]*S2[Z] + S1[W]*S2[W];
#define DOTPROD3I(R, S1, S2)		R[c] = \
  					S1[X]*S2[X][c] + S1[Y]*S2[Y][c]+ \
            				S1[Z]*S2[Z][c] + S1[W]*S2[W][c];
#define DOTPROD3(R, S1, S2)		R = \
    					S1[X]*S2[X] + S1[Y]*S2[Y] + \
            				S1[Z]*S2[Z] + S1[W]*S2[W];
#define mymult(pt1, pt2)	 { \
				   DOTPROD4I(pt2, pt1, M1, X); \
				   DOTPROD4I(pt2, pt1, M1, Y); \
				   DOTPROD4I(pt2, pt1, M1, Z); \
				   DOTPROD4I(pt2, pt1, M1, W); \
				}
#endif

myview(pt1, pt2)
POINT pt1, pt2;
{
WTYPE tmp;

 pt2[0] = pt1[0]-ex; pt2[1] = pt1[1]-ey; pt2[2] = pt1[2]-ez;
 tmp = pt2[0]*rx + pt2[1]*ry + pt2[2]*rz; 
 pt2[0] *= r/tmp; pt2[1] *= r/tmp; pt2[2] *= r/tmp;
 pt2[0] += ex; pt2[1] += ey; pt2[2] += ez;
}

WTYPE realarea(pts, no)
POINT *pts;
int no;
{
WTYPE sarea, area;
int i;

area = 0;
for(i=1; i<no; i++)
   {
   sarea = (pts[i-1][0]*(pts[i][1]-pts[i-1][1])
	   -pts[i-1][1]*(pts[i][0]-pts[i-1][0]))/2;
   if(sarea < 0) area -= sarea;
   else area += sarea;
   }
sarea = (pts[no-1][0]*(pts[0][1]-pts[no-1][1])
        -pts[no-1][1]*(pts[0][0]-pts[no-1][0]))/2;
if(sarea < 0) area -= sarea;
else area += sarea;
/* return area; */
return SQRT(area);
}

/*
myarea(pts, no, center)
{
WTYPE area;

area = 0;
for(i=0; i<no; i++)
   {
   area += SQRT((center[1]-pts[i][1])*(center[1]-pts[i][1])
              + (center[0]-pts[i][0])*(center[0]-pts[i][0]));
   }
return area;
}
*/

#if 0
init_gl()
{
POINT tmp1, tmp2;
    long xorig, yorig, xsize, ysize;
    int i;

    /* set up graphics environment */
    if(left == 2)
       prefposition(0, 1265, 0, 985);
    else if(left == 1)
       prefposition(0, 635, 0, 985);
    else
       prefposition(635, 1275, 0, 985);

    /* prefposition(0, 1265, 0, 985); */
    /* prefposition(20, 970, 20, 970); */
    FOREGROUND;
    winopen("BEZIER");
    getorigin(&xorig, &yorig);
    getsize(&xsize, &ysize);
    if(bezdebug) singlebuffer();
    else doublebuffer();
    RGBmode();
    gconfig();
    lsetdepth(0, 0x7FFFFF);
    zbuffer(TRUE);
    /* Use mmode() to set up projection & viewing matrices for lighting */
    mmode(MPROJECTION);		
    hither = 0.01; yon = 1000.0;
    perspective(900, xsize/(float)ysize, hither, yon);
    tanxy = 1.0;
    fov = 1.0; /* arccot(fov) */
    /* getmatrix(Mp); */
    mmode(MVIEWING);
    def_light_calc(); 
    use_light_calc(); 
    shademodel(GOURAUD);
    c3f(navyvec);	/* clear the frame */
    clear();
    zclear();
    lmbind(MATERIAL, 1);
    /* lmbind(BACKMATERIAL, 17); */
    /* --------------
    ex = 5.0; ey = 5.0; ez = 5.0; rx = 0.1; ry = 0.1; rz = 2.5;
    ex = 51.0; ey = 51.0; ez = 51.0; rx = 0.1; ry = 0.1; rz = 0.1;
    /* Pencil // ex = -25.0; ey = 40.0; ez = 17.0;
                  rx = 25.5; ry = 0.0; rz = 1.5; /**/
    /* General // ex = 8.0; ey = 8.0; ez = 8.0;
                  rx = 0.5; ry = 0.5; rz = 1.5; /**/
    /* Carold // ex = 3500.0; ey = 1500.0; ez = 700.0;
                 rx = 3300.0; ry = 1410.0; rz = 570.0; /**/
    /* Car // ex = 3000.; ey =1500.; ez = 580.;
              rx = 3000; ry = 1400; rz = 500; /* */

    /* Big sub // ex = 1017.; ey = 0.; ez = 379.;
              rx = 832.53; ry =  13.40; rz =  335.43;
   /* */
   /* ---------------  */

    /* only for bt.523 rx = 4.8; ry = -3.71; rz = -0.975; */
    /* lookat(eye[X], eye[Y], eye[Z], ref[X], ref[Y], ref[Z], 0);   */
printf("Lookat: Ref = %g %g %g; Eye = %g %g %g\n", rx,ry,rz, ex,ey,ez);

    lookat(ex, ey, ez, rx, ry, rz, 0);  
    getmatrix(M1);
    rx = rx-ex; ry = ry-ey; rz = rz - ez;
    r = SQRT(DOUBLE rx*rx + ry*ry + rz*rz);
    vx = -rx*ry; vy = rz*rz+rx*rx; vz = -ry*rz;
    hx = rz; hz = -rx;
}
#endif

long init_gl(x0,y0,x1,y1,bkgrnd,win_name)
int x0, x1, y0, y1;
Colorindex bkgrnd;
char *win_name;
{
POINT tmp1, tmp2;
    long xorig, yorig, xsize, ysize;
    long gid;
    int i;

    /* set up graphics environment */
    prefposition(x0, x1, y0, y1);
/*    prefposition(635, 1275, 0, 985); */
    FOREGROUND;

/* To write strings on window  */
    fminit();
    usefont("Times-Italic",30.0);

    gid = winopen(win_name);
    color(bkgrnd);
    getorigin(&xorig, &yorig);
    getsize(&xsize, &ysize);
     /* singlebuffer(); */
    if(bezdebug) singlebuffer();
    else doublebuffer();
    RGBmode();
    gconfig();
    lsetdepth(0, 0x7FFFFF);
    zbuffer(TRUE);
    /* Use mmode() to set up projection & viewing matrices for lighting */
    mmode(MPROJECTION);		
    hither = 0.01; yon = 1000.0;
    perspective(900, xsize/(float)ysize, hither, yon);
    tanxy = 1.0;
    fov = 1.0; /* arccot(fov) */
    /* getmatrix(Mp); */
    mmode(MVIEWING);
    def_light_calc(); 
    use_light_calc(); 
    shademodel(GOURAUD);
    c3f(navyvec);	/* clear the frame */
    clear();
    zclear();
    lmbind(MATERIAL, 1);
/*
    lmbind(LIGHT0, 27);
    lmbind(LIGHT1, 28);
    lmbind(LIGHT2, 29);
    lmbind(LMODEL, 14);
*/

    /* lmbind(BACKMATERIAL, 17); */

    /* ex = 5.0; ey = 5.0; ez = 5.0; rx = 0.1; ry = 0.1; rz = 2.5; */
    ex = 0.0; ey = 0.0; ez = -2.0; rx = 0.5; ry = 0.5; rz = 0.5;
     /* ex = 0.0; ey = 0.0; ez = -1.0; rx = 0.5; ry = 0.5; rz = 0.5; */
     /* */
/*
    rx = 0.0; ry = 0.0; rz = 0.0;
    ex = 9.05228; ey = 9.05234; ez = 9.05235; 
    lookat(ex, ey, ez, rx, ry, rz, 0);  
    getmatrix(M1);
*/

    rx = rx-ex; ry = ry-ey; rz = rz - ez;
    r = SQRT(DOUBLE rx*rx + ry*ry + rz*rz);
    vx = -rx*ry; vy = rz*rz+rx*rx; vz = -ry*rz;
    hx = rz; hz = -rx;
    return gid;
}

/*
** def_light_calc()
** Tell the Graphics Library to DEFINE a simple
** lighting calculation that accounts for diffuse
** and ambient reflection.  This simple
** lighting calculation happens to use the default
** lighting parameters in the Graphics Library.
*/

def_light_calc() {
    lmdef(DEFMATERIAL, 1, 0, red);
    lmdef(DEFMATERIAL, 2, 15, blue);
    lmdef(DEFMATERIAL, 3, 5, yellow);
    lmdef(DEFMATERIAL, 4, 0, lavender);
    lmdef(DEFMATERIAL, 5, 0, purple);
    lmdef(DEFMATERIAL, 6, 0, pink);
    lmdef(DEFMATERIAL, 7, 0, orange);
    lmdef(DEFMATERIAL, 8, 0, darkred);
    lmdef(DEFMATERIAL, 9, 0, white);
    lmdef(DEFMATERIAL, 10, 0, cyan);
    lmdef(DEFMATERIAL, 11, 0, black);
    lmdef(DEFMATERIAL, 12, 0, gray);
    lmdef(DEFMATERIAL, 13, 0, green);
    lmdef(DEFMATERIAL, 14, 0, navy);
    lmdef(DEFMATERIAL, 15, 0, blueg);
    lmdef(DEFMATERIAL, 16, 0, greenb);
    lmdef(DEFMATERIAL, 17, 0, shiny_material);
    lmdef(DEFLIGHT, 1, 0, light);
    lmdef(DEFLIGHT, 2, 10, white_light);
    lmdef(DEFLIGHT, 3, 0, light2);
    lmdef(DEFLIGHT, 4, 0, light3);
    lmdef(DEFLIGHT, 5, 0, light4);
    lmdef(DEFLIGHT, 6, 0, light_one);
    /* lmdef(DEFLMODEL, 1, 0, NULL); */
    lmdef(DEFLMODEL, 1, 0, lighting_model);
}

/*
** use_light_calc()
** Tell the Graphics Library to USE the
** simple lighting calculation that we
** defined earlier.
*/
use_light_calc()
{
    lmbind(LIGHT0, 1);
    lmbind(LIGHT1, 2);
    lmbind(LIGHT2, 6);
    lmbind(LIGHT0, 3);
    lmbind(LIGHT3, 4);
    lmbind(LIGHT4, 5);
    lmbind(LMODEL, 1);
}


WTYPE diffnorm(p1, p2)
POINT p1, p2;
{
WTYPE tmp1, tmp2;

tmp1 = p1[0] - p2[0]; tmp2 = tmp1*tmp1;
tmp1 = p1[1] - p2[1]; tmp2 += tmp1*tmp1;
return SQRT(DOUBLE tmp2);
}

WTYPE diffnorm3(p1, p2)
POINT p1, p2;
{
WTYPE tmp1, tmp2;

tmp1 = p1[0] - p2[0]; tmp2 = tmp1*tmp1;
tmp1 = p1[1] - p2[1]; tmp2 += tmp1*tmp1;
tmp1 = p1[2] - p2[2]; tmp2 += tmp1*tmp1;
return SQRT(DOUBLE tmp2);
}


bez_t(cntrl, udegree, vdegree, u, v, coord, res)
WTYPE cntrl[MAX_ORDER][MAX_ORDER][WCOORD], u, v;
int udegree, vdegree;
POINT res;
{
int i, j, k;
WTYPE u1[MAX_ORDER], v1[MAX_ORDER], tmp;
WTYPE u2[MAX_ORDER], v2[MAX_ORDER];
int mc[MAX_ORDER], nc[MAX_ORDER];

u2[udegree] = v2[vdegree] = u1[0] = v1[0] = 1.0;
mc[0] = nc[0] = 1;
tmp = 1-u;
for(i=udegree-1; i>=0; i--)
   u2[i] = u2[i+1]*tmp;
for(i=1; i<=udegree; i++)
   {
   u1[i] = u1[i-1]*u;
   mc[i] = (mc[i-1]*(udegree-i+1))/i;
   }
tmp = 1-v;
for(i=vdegree-1; i>=0; i--)
   v2[i] = v2[i+1]*tmp;
for(i=1; i<=vdegree; i++)
   {
   v1[i] = v1[i-1]*v;
   nc[i] = (nc[i-1]*(vdegree-i+1))/i;
   }

for(i=0; i<coord; i++)
   res[i] = 0.0; /* cntrl[i][j]*B(m,i,u)*B(n,j,v); */

for(i=0; i<=udegree; i++)
   for(j=0; j<=vdegree; j++)
      for(k=0; k<coord; k++)
         res[k] += cntrl[i][j][k]*(mc[i]*u1[i]*u2[i])*(nc[j]*v1[j]*v2[j]);
}

bez_test(cntrl, udegree, vdegree, u, v, coord)
WTYPE cntrl[MAX_ORDER][MAX_ORDER][WCOORD], u, v;
int udegree, vdegree;
{
int k;
POINT res;

bez_t(cntrl, udegree, vdegree, u, v, coord, res);
if(coord == WCOORD)
   {
   printf("Rational ");
   for(k=0; k<COORD; k++)
      res[k] /= res[COORD];
   }
printf("TEST(%g,%g) = ", u,v);
for(k=0; k<COORD; k++)
   printf("%g ", res[k]);
printf("\n");
}

bez_alltest(cntrl, udegree, vdegree, u, v, coord)
WTYPE cntrl[MAX_ORDER][MAX_ORDER][WCOORD], u, v;
int udegree, vdegree;
{
int i, j, k;
POINT res, n1, n2, n;
WTYPE cntrl2[MAX_ORDER][MAX_ORDER][WCOORD];
WTYPE cntrl3[MAX_ORDER][MAX_ORDER][WCOORD];

bez_t(cntrl, udegree, vdegree, u, v, coord, res);

for(i=0; i<= udegree; i++)
   for(j=0; j< vdegree; j++)
      for(k=0; k< coord; k++)
         cntrl2[i][j][k] = cntrl[i][j+1][k] - cntrl[i][j][k];
bez_t(cntrl, udegree, vdegree, u, v, coord, n1);

for(i=0; i< udegree; i++)
   for(j=0; j<= vdegree; j++)
      for(k=0; k< coord; k++)
         cntrl3[i][j][k] = cntrl[i+1][j][k] - cntrl[i][j][k];
bez_t(cntrl, udegree, vdegree, u, v, coord, n2);

if(coord == WCOORD)
   {
   printf("Rational ");

   for(k=0; k<COORD; k++)
      n1[k]  = (res[COORD]*n1[k] - res[k]*n1[COORD])/(res[COORD]*res[COORD]);

   for(k=0; k<COORD; k++)
      n2[k]  = (res[COORD]*n2[k] - res[k]*n2[COORD])/(res[COORD]*res[COORD]);

   for(k=0; k<COORD; k++)
      res[k] /= res[COORD];
   }

crossp(n1, n2, n);
normalize(n, n);

printf("TEST(%g,%g) = ", u,v);
for(k=0; k<COORD; k++)
   printf("%g ", res[k]);
printf("\n");

printf("-- Normal = ");
for(k=0; k<COORD; k++)
   printf("%g ", n[k]);
printf("\n");
}

WTYPE l2norm(mat)
float mat[][WCOORD];
{
float t = 0;
int i,j;

   for(i=0; i<WCOORD; i++)
      for(j=0; j<WCOORD; j++)
         t += mat[i][j]*mat[i][j];
   return t;
}


usefont(fontname,fontsize)
char fontname[];
float fontsize;
/*
 * GET READY TO USE A FONT
 * Dinesh Manocha  2-20-89
 */
{
long  *font1pt,*fsized;
/*-----------------------------------------------------------------
font1pt = (long *)fmfindfont(fontname);
if(!font1pt) 
  { printf("Can't Find Font '%s'; Substituting Times-Roman\n",fontname);
    font1pt = (long *)fmfindfont("Times-Roman");
    if(!font1pt) 
      { printf("Can't Find Times-Roman Font. System Problem.\n");
        exit(-1);
      }
  }
fsized = (long *)fmscalefont(font1pt,fontsize);
fmsetfont(fsized);
-----------------------------------------------------------------*/
}

#endif
