#include <math.h>
#include <stdlib.h>
 /* #include "types.h" */

#define  DIM1          54
#define  DIM           18
#define  DOUBLEREAL     2
#define  REAL           1
#define  IMAG           0

#define CONV_ITER 15

#define EPS 0.1
#define EPS1 5.0e-2 /* For the Complex Pair */
#define EPS2 1.0e-3
#define EPSILON 1.0e-9

extern double drand48();
static double low[40],high[40],mean, wr[DIM1],wi[DIM1],
              C[DIM1][DIM1], CD[DIM1][DIM1];
static double re,ce,eig,eigback,shift,mag;
extern double SOLUTION[DIM1][3];
static int ITERATIONS = 22;
static double A1,A2,A3,A4,A11,A41;
static double Uback,Vback,U,V;
static double Box1[4], Box2[4]; /* Min/Max X,Y values of 2 curves */

/*

Performs Power iterations on A s - B, to compute all its +ve real eigenvalues.

*/

algebraic_prune(A,B,m_ind,order,degree,solindex,base_pt)

double **A, **B;
int order,degree,m_ind;
int *solindex;
int base_pt;
{
    int i,j,k,k1;
    double beta[DIM1],EIG[DIM1][DIM1],EIG1[DIM1][DIM1],zz[DIM1][DIM1];
    int matz,ierr,dim;
    double Z[DIM1],BACK[DIM1][DIM1],eig1, BA[DIM1][DIM1], BB[DIM1][DIM1];
    int lda;
    double rcond, vec[DIM1], vec1[DIM1],sum,Q[DIM1];
    int index,base;
    int seed, flag;
    int t1,t2,t3;
    
/*
 Do the transformation so that we only need to compute the eigenvalue in the
 range [0,1] only.
*/

    srand48(200*order);
    ITERATIONS = 40 + order/5;
    base = order - degree;

    A1 = 1;
    A2 = 0.0;
    A3 = 0.0;
    A4 = 1.0;

/*
    for (i = 0; i < order; i++)
       for (j = 0; j < order; j++)
       {
           A[i][j] = (A[i][j] + B[i][j]);
           eig = A1 * A[i][j] - A3 * B[i][j];
           eig1 = -A2 * A[i][j] + A4 * B[i][j];
           A[i][j] = eig;
           B[i][j] = eig1;
           BA[i][j] = EIG[j][i] = A[i][j];
           BB[i][j] = EIG1[j][i] = B[i][j];
       }
    dim = order;
    lda = DIM1;
*/

 /* Use Initial Guesses */ 
  
    *solindex = 0;
    index = 1;

    low[index] = 0;
    high[index] = 1.0;
          
  while(index)
  {
    if ((high[index] - low[index]) > EPS/2.0)
    {
        
/* transforms into [0,1] */
       shift = .4* low[index] + .6 * high[index];
       eig = shift;
       for (i = 0; i < order; i++)
           Q[i] = 20.0 * drand48() - 10.0;
       k = Iterate(index,order,m_ind,solindex,base_pt,EPS,Q,A,B,&flag,degree);
       if (k == 1)
       {
         i = 0;
         while ( i < (*solindex))
           if ((fabs(eig - SOLUTION[i][0]) < EPS/1.5) && 
               (fabs(U - SOLUTION[i][1]) < EPS/1.5) && 
               (fabs(V - SOLUTION[i][2]) < EPS/1.5))  
                 /* Already computed */
           {
             eig = SOLUTION[i][0];
             i = (*solindex) + 1;
           }
           else
             i++;
 
         if ((flag != IMAG) && (i == (*solindex)))
           k = Iterate(index,order,m_ind,solindex,base_pt,EPS2,Q,A,B,&flag,degree);
       }

       if (!k)
       {
         mean = (low[index] + high[index])/2.0;
         high[index+1] = high[index];
         high[index] = mean;
         index++;
         low[index] = mean;
       }
       else
       {
            /* Compute the distance to the complex eigenvalue from shift */
            if (flag == IMAG) 
            {
                sum = sqrt( (re - shift) * (re - shift) + ce * ce);
                eig = shift + sum;
            }
            mean = shift;
            /* No Eig. in the Domain */
            if ((eig < low[index]) || (eig > high[index])) 
                index--;
            else
            {
                high[index+1] = high[index];
                if (eig < mean)
                {
                    high[index] = eig - 2 * EPS2;
                    index++;
                    low[index] = 2.0 * mean - eig;
                }
                else
                {
                    high[index] = 2.0 * mean - eig;
                    index++;
                    low[index] = eig + 2* EPS2;
                }
            }
         }
      }
      else
          index--;
  }
}

/* Performs a series of power iterations */

int Iterate(index,order,m_ind,solindex,base_pt,eps,Q,A,B,pflag,degree) 
int index,order,m_ind;
int *solindex;
double eps;
double *Q, **A, **B;
int *pflag;
int degree, base_pt;
{
    int i,j,k,l, dim, base;
    double p,q,pback,qback,K,K1,K2;
    double Vec1[DIM1],Vec2[DIM1], Vec[DIM1];
    double m1,m2,m3,m4,r1,r2;
    double rcond, vec[DIM1],Pec[DIM1], Pec1[DIM1], vec1[DIM1],sum, sum1, eig1,tol;
    int lda,ipvt[DIM1],ipvt1[DIM1],job;
    double alpha1,alpha2, alpha3, alpha4;
    double LM[DIM][DIM],UM[DIM][DIM]; /* Used for LU decomposition */

    Uback = -2.0;
    Vback = -2.0;
    eigback = eig;

#ifdef PRINT
    printf("LOW = %lf, HIGH = %lf, GUESS = %lf \n",low[index],high[index],eig);
    for (i = 0; i < order; i++)
    {
           mag = sqrt(((A1 * wr[i] + A2)/(A3 * wr[i] + A4) - eig) * ( (A1 * wr[i] + A2)/(A3 * wr[i] + A4) - eig) + (wi[i] * wi[i]));
           if (mag < 1.0)
               printf( "MAG: %lf,     EIG: %lf  %lf \n",mag,(A1 * wr[i] + A2)/(A3 * wr[i] + A4),wi[i]);
    }
#endif

/*
   We change this stuff to perform fewer operations for computing the 
C(i,j)'s as opposed to order * order.
*/
    base = order - degree;
    dim = order/degree;
    for (j = 0; j < dim; j++)
    {
        l = j*degree;
        for ( i = 0; i < degree; i++)
            for ( k = 0; k < degree; k++)
        {
            C[base + k][l + i] = C[base + i][l + k] = A[base + i][l+k]* eig  - B[base + i][l + k];
        }
    }

    alpha1 = A[0][0]* eig - B[0][0];
    alpha2 = A[0][degree] * eig + - B[0][degree];

/*
  Decomposes uses the structure of the matrix to perform LU decomposition.
*/
    Decomp(order,degree,alpha1,alpha2,LM,UM);

    alpha3 = A[0][0];
    alpha4 = B[0][degree];
    for (i = 0; i < base; i++)
        vec[i] = (alpha3 * Q[i] + alpha4 * Q[i+degree]);

    for (k = 0; k < ITERATIONS; k++) /* Power Iterations */
        {
            Sol(order,degree,alpha1,alpha2,LM,UM,vec);

        /*
           Normalize the Vector: vec.
        */
            sum = 0.0;
            sum1 = 0.0;
            for (i = 0; i < order; i++)
            {
                if (fabs(vec[i]) > sum)
                    sum = vec[i];
            }

            K2 = K1;
            K1 = K;
            K = sum;
            eig = sum;

            for (i = 0; i < order; i++)
            {
                Q[i] = vec[i]/sum;
                Vec2[i] = Vec1[i];
                Vec1[i] = Vec[i];
                Vec[i] = Q[i];
            }
            for (i = 0; i < base; i++)
                {
                    vec[i] = (alpha3 * Q[i] + alpha4 * Q[i+degree]);
                    vec1[i] = alpha4 * Q[i+degree];
                }


            for (i = base; i < order; i++)
            {
                vec[i] = 0.0;
                vec1[i] = 0.0;
                for (j = 0; j < order; j++)
                {
                    vec[i] += (A[i][j]) * Q[j];
                    vec1[i] += (B[i][j]) * Q[j];
                }
            }


    /*
       Estimate the Eigenvalue
    */
            eig = 0.0;
            eig1 = 0.0;
            for ( i = 0; i < order; i++)
            {
                eig += Q[i] * vec[i];
                eig1 += Q[i] * vec1[i];
            }
            eig = eig1/eig;
	    if (base_pt != 0) {
	      Uback = U = -2.0;
	      Vback = V = -2.0;
	    }
	    else {
              U = Q[1]/Q[0];
              U = U/(1 + U);
              V = Q[m_ind]/Q[0];
              V = V/(1 + V);
	    }
#ifdef PRINT
            printf("k = %d     ITERATE: %lf %lf %lf \n",k,eig,eigback,U);
#endif
            if ((fabs((eigback - eig)) <= eps) && (fabs(Uback - U) <= eps) &&
                (fabs(Vback - V)) <= eps)
            {
               if (eps == EPS2)
               {
                   *pflag = REAL;
		   i = 0;
		   while (i < (*solindex))
		     if (fabs(eig - SOLUTION[i][0]) < EPS2) {
		       eig = SOLUTION[i][0];
		       U = SOLUTION[i][1];
		       V = SOLUTION[i][2];
		       *pflag = REAL;
		       return 2;
		     }
		     else i++;
		       
                   SOLUTION[(*solindex)][0] = (A1 * eig + A2) / (A3 * eig + A4);
                   SOLUTION[(*solindex)][1] = U;
                   SOLUTION[(*solindex)][2] = V;
		   if ((eig >= -EPSILON) && (eig <= 1+EPSILON)) {
		     if (base_pt == 1) {
		       *solindex = (*solindex) + 1;
		     }
		     else {
		       if ((U >= -EPSILON) && (U <= 1+EPSILON) &&
		           (V >= -EPSILON) && (V <= 1+EPSILON))
		         *solindex = (*solindex) + 1;
		     }
		   }
                   return 2;
               }
               else
                   if (k < CONV_ITER) /* Good Chances of Converging Well. */
                   {
                       i = 0;
                       while ( i < (*solindex))
                           if (fabs(eig - SOLUTION[i][0]) < EPS/1.5) 
/*
                              (fabs(U - SOLUTION[i][1]) < EPS/1.5) &&
                              (fabs(V - SOLUTION[i][2]) < EPS/1.5))
*/
                                             /* Already computed */
                           {
                               eig = SOLUTION[i][0];
                               U = SOLUTION[i][1];
                               V = SOLUTION[i][2];
			       *pflag = REAL;
                               return 2;
                           }
                           else
                               i++;
                       eps = EPS2;
                       eigback = eig;
                       Uback = U;
                       Vback = V;
                   }
                   else
                   {
                       k = ITERATIONS + 1;
                       *pflag = REAL;
                       return 1;
                   }
            }
            else
            {
               eigback = eig;
               Uback = U;
               Vback = V;
            }

/*
   The solution is given in Wilkinson's book on Algebraic Eigenvalue Problem
on pages 579-581.
     In our case the vectors, Vec, Vec1 and Vec2 correspond to the u_i's in
Wilkinson's book. Moreover, the k_i's are denoted by K, K1, K2.

    We will formulate a 2*2 system:

        m1 * X + m2 * Y = r1
        m3 * X + m4 * Y = r2
and solve for X and Y (which are p and q in Wilkinson's book).
*/
            if ((k > CONV_ITER) && (*pflag != DOUBLEREAL) && (eps != EPS2))   /* Possibility of Complex Eigenvalues */
            {
                r1 = 0;
                r2 = 0;
                for (i = 0; i < order; i++)
                {
                    r1 += Vec1[i] * Vec[i];
                    r2 += Vec2[i] * Vec[i];
                }
                r1 *= K * K1;
                r2 *= K * K1;
                m1 = 0;
                m2 = 0;
                m3 = 0;
                m4 = 0;

                for (i = 0; i < order; i++)
                {
                    m1 += Vec1[i] * Vec1[i];
                    m2 += Vec1[i] * Vec2[i];
                    m3 += Vec2[i] * Vec1[i];
                    m4 += Vec2[i] * Vec2[i];
                }

                pback = p;
                qback = q;
                p = (r1 * m4 - m2 * r2) / ( m1 * m4 - m2 * m3);
                q = (m1 * r2 - m3 * r1) / ( m1 * m4 - m2 * m3);
                p /= K1;
#ifdef PRINT
                printf("P = %lf Pback = %lf Q = %lf Qback = %lf\n\n",p,pback,q,qback);
#endif 
                sum = p*p + 4*q;
                if ( sum > 0.0)
                    tol = 1.0e-7;
                else
                    tol = EPS1;
                if (((fabs(p) < 1) && (fabs((p - pback)/p) < tol) && (fabs((q - qback)/q) < tol)) || ((fabs((p - pback)) < tol) && (fabs((q - qback)/q) < tol)))
                { /* Compute the Eigenvalues */
                    if (sum >= 0.0)  /* The closest Eigenvalues are real*/
                    {
                        re = (p+ sqrt(sum))/2.0;
                        ce = (p - sqrt(sum))/2.0;
                        re = shift -  1/re;
                        ce =  shift - 1/ce;
#ifdef PRINT
                        printf("REAL EIGENVALUES: %lf %lf \n",re,ce);
#endif
                        *pflag = DOUBLEREAL;
                        if ((fabs(re) - fabs(shift)) < (fabs(ce) - fabs(shift)))
                            eig = re;
                        else
                            eig = ce;
                        k = ITERATIONS;
                        return 0;
                    }
                    else
                    { 
                        re = p/2.0;
                        sum = sum * -1.0;
                        ce = 0.5 * sqrt(sum);
                        sum = re*re + ce * ce;
                        re = re/sum;
                        ce = ce/sum;
                        re = shift - re;
/*
                        printf("IMAG EIG: %lf %lf \n",re,ce);
*/
                        *pflag = IMAG;
                        k = ITERATIONS + 1;
                    }
                }
            }

        }

        if (k == ITERATIONS) /* DID NOT CONVERGE: HALF THE INTERVAL AND DO AGAIN */
            return 0;
        else
            return 1;
}
         
/*
  Uses the structure of Block Companion Matrices to perform LU decomposition

  The matrix has been defined in the global variable C[DIM1][DIM1].
*/
  Decomp(order,degree,alpha1,alpha2,L,U)

    int order,degree;
    double alpha1,alpha2;
    double L[DIM][DIM], U[DIM][DIM];


{
    register int i,j,k,dim,base;
    double A[DIM][DIM], B[DIM][DIM];
    register double factor;
    
    dim = order/degree; /* dim corresponds to the degree of the matrix polynomial */

    base = order - degree;
    factor = alpha2/alpha1;
    for (i = 1; i < dim; i++)
    { 
         for (j = 0; j < degree; j++)
            for (k = j; k < degree; k++)
            {
                C[base+j][i*degree + k] -= factor * C[base+j][(i-1)*degree + k];
                C[base + k][i*degree + j] = C[base+j][i*degree+k];
            }
    }

    for (j = 0; j < degree; j++)
       for (k = 0; k < degree; k++)
       {
            A[j][k] = C[base + j][base + k];
            L[j][k] = A[j][k];
            U[j][k] = 0.0;
       }
/* 
   Now we perform LU decomposition on A
*/

    for (i = 0; i < degree; i++)
    {
        U[i][i] = 1.0;
    }

    for (i = 1; i < degree; i++)  /* On the Columns of A */
    {
        for (j = i; j < degree; j++)
            if (L[i-1][j] != 0.0)
            {
                factor = L[i-1][j] / L[i-1][i-1];
                U[i-1][j] = factor;
                for (k = i - 1; k < degree; k++)
                    L[k][j] -= factor * L[k][i-1];
            }
    }

/* 
   CHECK the results 

    LU Decomposition
*/
  
/*
    for ( i = 0; i < degree; i++)
       for (j = 0; j < degree; j++)
       {
           B[i][j] = 0.0;
           for (k = 0; k < degree; k++)
               B[i][j] += L[i][k] * U[k][j];
           printf("DIFF: %d %d  %lf \n",i,j,A[i][j] - B[i][j]);
       }
*/

/*
    factor = alpha2/alpha1;
     for ( i = 1; i < dim; i++)
     {
          for (j = 0; j < degree; j++)
              for (k = 0; k < degree; k++)
                  printf("DIFF: %d   %d  %lf \n", base + j, i * degree + k,
CD[base+j][i*degree + k] - (C[base+j][(i-1)*degree +k] * factor + C[base + j][i*degree + k]));
     }
*/
}

/*  Given the LU decomposition, solve for the variables. The RHS vector is in 
    vec[]
*/

Sol(order,degree,alpha1,alpha2,L,U,vec)
    int order,degree;
    double alpha1,alpha2;
    double L[DIM][DIM], U[DIM][DIM];
    double *vec;

{
    register int i,j,k,dim,base;
    double factor,tt, Temp[DIM1], VV[DIM1];


    dim = order/degree; /* dim corresponds to the degree of the matrix polynomial */

    base = order - degree;
    factor = alpha2/alpha1;

/*
    for (i = 0; i < order; i++)
        VV[i] = vec[i];
*/

/*
   Solve for LX = vec[];
*/
   for (i = 0; i < base; i++)
   {
        Temp[i] = vec[i] / alpha1;
   }


   for (i = base; i < order; i++)
   {
       for (j = 0; j < base; j++)
           vec[i] -= C[i][j] * Temp[j];
   }
/*
  Now solve for  L Temp[] = vec[];
*/
   
   for (i = 0; i < degree; i++)
   {
       Temp[base + i] = vec[base + i];
       for (j = 0; j < i; j++) 
          Temp[base+i] -= L[i][j] * Temp[base+j]; 
       Temp[base+i] /= L[i][i];
   }

/*
   CHECK 
*/
/*
   for (i = 0; i < base; i++)
       printf("DIFF: %d %lf \n",i,alpha1*Temp[i] - VV[i]);

   for (i = base; i < order; i++)
   {
       tt = VV[i];
       for (j = 0; j < base; j++)
           tt = tt - C[i][j] * Temp[j];
       for (j = 0; j < degree; j++)
           tt = tt - L[i-base][j] * Temp[base + j];
       printf("DIFF: %d %lf \n",i,tt);
   }

*/
/*
   Solve for U vec[] = Temp[]
*/

   for (i = degree - 1; i >=0; i--)
   {
       vec[base + i] = Temp[base+i];
       for (j = i + 1; j < degree; j++)
           vec[base + i] -= U[i][j] * vec[base + j];
/*
   No need as U[i][i] = 1.0
*/
/*
       vec[base+i] = vec[base+i]/U[i][i];
*/
   }
       
   for (i = base - 1; i >=0; i--)
   {
       vec[i] = Temp[i] -  factor * vec[i+degree];
   }

/*  CHECK */

/*
   for (i = 0; i < base; i++)
       printf("DIFF : %d %lf \n", i, vec[i] - (Temp[i] + factor*Temp[i+degree]));

   for (i = 0; i < degree; i++)
   {
       tt = vec[base + i];
       for (j = i; j < degree; j++)
           tt = tt - U[i][j] * Temp[base + j];
       printf("DIFF: %d %lf \n",base + i, tt);
   }
*/
/*
  Solve for the Lower Triangular System:   C Y = Temp[];

  Part of the entries are in the global matrix: C
*/

/* 
   CHECK THE RESULT
   for (i = 0; i < order; i++)
   {
       for (j = 0; j < order; j++)
           VV[i] = VV[i] - CD[i][j] * vec[j];
       printf("DIFF: %d  %lf \n",i,VV[i]);
   }
*/
}
       
