#include "defs.h"

/*
#define  intervals_overlap(i1,i2) (!(((i2).low-(i1).high>0.0)||((i1).low-(i2).high>0.0)))

#define  boxes_overlap(box1,box2)                           \
  (intervals_overlap((box1).i3Dbox[0], (box2).i3Dbox[0]) && \
   intervals_overlap((box1).i3Dbox[1],(box2).i3Dbox[1]) &&  \
   intervals_overlap((box1).i3Dbox[2], (box2).i3Dbox[2]))
*/

compute_bounding_box(tp, box)
TENSOR_PATCH tp;
BOUNDINGBOX *box;
{
  int m, n;
  int i, j, k;
  double minx, maxx, miny, maxy, minz, maxz;
  double wval;

  m = tp.iDeg0;
  n = tp.iDeg1;

  minx = maxx = tp.coeffs[0][0].dCoord[0] / tp.coeffs[0][0].dCoord[3];
  miny = maxy = tp.coeffs[0][0].dCoord[1] / tp.coeffs[0][0].dCoord[3]; 
  minz = maxz = tp.coeffs[0][0].dCoord[2] / tp.coeffs[0][0].dCoord[3];

  for (i=0; i<=m; i++)
  for (j=0; j<=n; j++)
  {
    wval = tp.coeffs[i][j].dCoord[3];
    if ((tp.coeffs[i][j].dCoord[0]/wval) < minx) 
      minx = tp.coeffs[i][j].dCoord[0] / wval;
    if ((tp.coeffs[i][j].dCoord[0]/wval) > maxx) 
      maxx = tp.coeffs[i][j].dCoord[0] / wval;
    if ((tp.coeffs[i][j].dCoord[1]/wval) < miny) 
      miny = tp.coeffs[i][j].dCoord[1] / wval;
    if ((tp.coeffs[i][j].dCoord[1]/wval) > maxy) 
      maxy = tp.coeffs[i][j].dCoord[1] / wval;
    if ((tp.coeffs[i][j].dCoord[2]/wval) < minz) 
      minz = tp.coeffs[i][j].dCoord[2] / wval;
    if ((tp.coeffs[i][j].dCoord[2]/wval) > maxz) 
      maxz = tp.coeffs[i][j].dCoord[2] / wval;
  }

  (box->i3Dbox[0]).low = minx;
  (box->i3Dbox[0]).high = maxx;
  (box->i3Dbox[1]).low = miny;
  (box->i3Dbox[1]).high = maxy;
  (box->i3Dbox[2]).low = minz;
  (box->i3Dbox[2]).high = maxz;
}

calc_curv_bbox(tp, box)
TENSOR_PATCH tp;
BOUNDINGBOX *box;
{
  int m,n;
  int i, j, k, fl;
  double minx, maxx, miny, maxy, minz, maxz;
  double wval;

  m = tp.iDeg0;
  n = tp.iDeg1;

  for (i=0; i<4; i++) {
    fl = i / 2;
    if (fl == 0) {
      switch (i % 2) {
	case 0: 
	   minx = maxx = tp.coeffs[0][0].dCoord[0] / tp.coeffs[0][0].dCoord[3];
	   miny = maxy = tp.coeffs[0][0].dCoord[1] / tp.coeffs[0][0].dCoord[3];
	   minz = maxz = tp.coeffs[0][0].dCoord[2] / tp.coeffs[0][0].dCoord[3];

	   for (j=0; j<=n; j++) {
	     wval = tp.coeffs[0][j].dCoord[3];
             if ((tp.coeffs[0][j].dCoord[0]/wval) < minx) 
               minx = tp.coeffs[0][j].dCoord[0] / wval;
             if ((tp.coeffs[0][j].dCoord[0]/wval) > maxx) 
               maxx = tp.coeffs[0][j].dCoord[0] / wval;
             if ((tp.coeffs[0][j].dCoord[1]/wval) < miny) 
               miny = tp.coeffs[0][j].dCoord[1] / wval;
             if ((tp.coeffs[0][j].dCoord[1]/wval) > maxy) 
               maxy = tp.coeffs[0][j].dCoord[1] / wval;
             if ((tp.coeffs[0][j].dCoord[2]/wval) < minz) 
               minz = tp.coeffs[0][j].dCoord[2] / wval;
             if ((tp.coeffs[0][j].dCoord[2]/wval) > maxz) 
               maxz = tp.coeffs[0][j].dCoord[2] / wval;
	   }

           (box[i].i3Dbox[0]).low = minx;
           (box[i].i3Dbox[0]).high = maxx;
           (box[i].i3Dbox[1]).low = miny;
           (box[i].i3Dbox[1]).high = maxy;
           (box[i].i3Dbox[2]).low = minz;
           (box[i].i3Dbox[2]).high = maxz;
	   break;

	case 1:
	   minx = maxx = tp.coeffs[m][0].dCoord[0] / tp.coeffs[m][0].dCoord[3];
	   miny = maxy = tp.coeffs[m][0].dCoord[1] / tp.coeffs[m][0].dCoord[3];
	   minz = maxz = tp.coeffs[m][0].dCoord[2] / tp.coeffs[m][0].dCoord[3];

	   for (j=0; j<=n; j++) {
	     wval = tp.coeffs[m][j].dCoord[3];
             if ((tp.coeffs[m][j].dCoord[0]/wval) < minx) 
               minx = tp.coeffs[m][j].dCoord[0] / wval;
             if ((tp.coeffs[m][j].dCoord[0]/wval) > maxx) 
               maxx = tp.coeffs[m][j].dCoord[0] / wval;
             if ((tp.coeffs[m][j].dCoord[1]/wval) < miny) 
               miny = tp.coeffs[m][j].dCoord[1] / wval;
             if ((tp.coeffs[m][j].dCoord[1]/wval) > maxy) 
               maxy = tp.coeffs[m][j].dCoord[1] / wval;
             if ((tp.coeffs[m][j].dCoord[2]/wval) < minz) 
               minz = tp.coeffs[m][j].dCoord[2] / wval;
             if ((tp.coeffs[m][j].dCoord[2]/wval) > maxz) 
               maxz = tp.coeffs[m][j].dCoord[2] / wval;
	   }

           (box[i].i3Dbox[0]).low = minx;
           (box[i].i3Dbox[0]).high = maxx;
           (box[i].i3Dbox[1]).low = miny;
           (box[i].i3Dbox[1]).high = maxy;
           (box[i].i3Dbox[2]).low = minz;
           (box[i].i3Dbox[2]).high = maxz;
	   break;

	default:
	   printf("It simply cannot come here\n");
	   break;
      }
    }
    else {
      switch (i % 2) {
	case 0: 
	   minx = maxx = tp.coeffs[0][0].dCoord[0] / tp.coeffs[0][0].dCoord[3];
	   miny = maxy = tp.coeffs[0][0].dCoord[1] / tp.coeffs[0][0].dCoord[3];
	   minz = maxz = tp.coeffs[0][0].dCoord[2] / tp.coeffs[0][0].dCoord[3];

	   for (j=0; j<=m; j++) {
	     wval = tp.coeffs[j][0].dCoord[3];
             if ((tp.coeffs[j][0].dCoord[0]/wval) < minx) 
               minx = tp.coeffs[j][0].dCoord[0] / wval;
             if ((tp.coeffs[j][0].dCoord[0]/wval) > maxx) 
               maxx = tp.coeffs[j][0].dCoord[0] / wval;
             if ((tp.coeffs[j][0].dCoord[1]/wval) < miny) 
               miny = tp.coeffs[j][0].dCoord[1] / wval;
             if ((tp.coeffs[j][0].dCoord[1]/wval) > maxy) 
               maxy = tp.coeffs[j][0].dCoord[1] / wval;
             if ((tp.coeffs[j][0].dCoord[2]/wval) < minz) 
               minz = tp.coeffs[j][0].dCoord[2] / wval;
             if ((tp.coeffs[j][0].dCoord[2]/wval) > maxz) 
               maxz = tp.coeffs[j][0].dCoord[2] / wval;
	   }

           (box[i].i3Dbox[0]).low = minx;
           (box[i].i3Dbox[0]).high = maxx;
           (box[i].i3Dbox[1]).low = miny;
           (box[i].i3Dbox[1]).high = maxy;
           (box[i].i3Dbox[2]).low = minz;
           (box[i].i3Dbox[2]).high = maxz;
	   break;

	case 1:
	   minx = maxx = tp.coeffs[0][n].dCoord[0] / tp.coeffs[0][n].dCoord[3];
	   miny = maxy = tp.coeffs[0][n].dCoord[1] / tp.coeffs[0][n].dCoord[3];
	   minz = maxz = tp.coeffs[0][n].dCoord[2] / tp.coeffs[0][n].dCoord[3];

	   for (j=0; j<=m; j++) {
	     wval = tp.coeffs[j][n].dCoord[3];
             if ((tp.coeffs[j][n].dCoord[0]/wval) < minx) 
               minx = tp.coeffs[j][n].dCoord[0] / wval;
             if ((tp.coeffs[j][n].dCoord[0]/wval) > maxx) 
               maxx = tp.coeffs[j][n].dCoord[0] / wval;
             if ((tp.coeffs[j][n].dCoord[1]/wval) < miny) 
               miny = tp.coeffs[j][n].dCoord[1] / wval;
             if ((tp.coeffs[j][n].dCoord[1]/wval) > maxy) 
               maxy = tp.coeffs[j][n].dCoord[1] / wval;
             if ((tp.coeffs[j][n].dCoord[2]/wval) < minz) 
               minz = tp.coeffs[j][n].dCoord[2] / wval;
             if ((tp.coeffs[j][n].dCoord[2]/wval) > maxz) 
               maxz = tp.coeffs[j][n].dCoord[2] / wval;
	   }

           (box[i].i3Dbox[0]).low = minx;
           (box[i].i3Dbox[0]).high = maxx;
           (box[i].i3Dbox[1]).low = miny;
           (box[i].i3Dbox[1]).high = maxy;
           (box[i].i3Dbox[2]).low = minz;
           (box[i].i3Dbox[2]).high = maxz;
	   break;

	default:
	   printf("It simply cannot come here\n");
	   break;
      }
    }
  }
}

int intervals_overlap(i1, i2)
INTERVAL i1, i2;
{
  if ((i2.low > (i1.high+1e-3)) || (i1.low > (i2.high+1e-3)))
    return 0;

  return 1;
}

int open_intervals_overlap(i1, i2)
INTERVAL i1, i2;
{
  /* if ((i2.low > (i1.high-1e-2)) || (i1.low > (i2.high-1e-2)))
    return 0; */
  /* Changed 7/3 tdc */
  if ((i2.low >= (i1.high)) || (i1.low > (i2.high)))
    return 0;

  return 1;
}

int common_interval_overlap(i1, i2, ret)
INTERVAL i1, i2, *ret;
{
  if (!open_intervals_overlap(i1, i2)) {
    printf("common_interval_overlap: non intersecting intervals\n");
    exit(-1);
  }

  ret->low = (i1.low > i2.low) ? i1.low : i2.low;
  ret->high = (i1.high < i2.high) ? i1.high : i2.high;

  if (FP_EQ_EPS(i1.high, i2.high, 1e-3)) return 3;
  if (i1.high < i2.high) return 1;
  return 2;
}

int boxes_overlap(box1, box2)
BOUNDINGBOX box1, box2;
{
  if ( intervals_overlap(box1.i3Dbox[0], box2.i3Dbox[0]) &&
       intervals_overlap(box1.i3Dbox[1], box2.i3Dbox[1]) &&
       intervals_overlap(box1.i3Dbox[2], box2.i3Dbox[2]) )
    return 1;

  return 0;
}
