#include <stdio.h>
#include <math.h>
#include "defs.h"
#include "linalg.h"

extern rg_();

/* this assumes that the arrays wr, wi, and dEVectors are pre-allocated */
call_rg(mat, m, n, wr, wi, dEVectors, matzval)
double	 **mat;
int	 m, n, matzval;
double   *wr, *wi;
double   **dEVectors;
{ 
  int	 i, j, k, ierr;
  int	 nm, matz;
  double  *a, *z, *if1;
  int	  *iv1;
  LINALGINIT

  /* allocate/initialize the matrices */
  ALLOCN(a, double, m*n);
  for(j = k = 0; j < n; j++)
    for(i = 0; i < m; i++)
      a[k++] = mat[i][j];	

  /* PRINT_MAT(mat, m, n, "Eigenvalue matrix"); */

  ALLOCN(z, double, m*n);
  ALLOCN(iv1, int, n);
  ALLOCN(if1, double, n);

  matz = matzval;

#ifdef __SGI
  rg_(&m, &n, a, wr, wi, &matz, z, iv1, if1, &ierr);
#else
  rg(&m, &n, a, wr, wi, &matz, z, iv1, if1, &ierr);
#endif

  if (ierr != 0)
  { printf("Error computing eigenvalues\n"); 
    exit(-1);
  }
/**
  else
  { for(i = 0; i < m ; i++)
      printf("Eigenvalue[%d] (%lf + i %lf)\n", i, wr[i], wi[i]);
  }
**/

  for(i = 0; i < m; i++)
  { k = i;
    for(j = 0; j < n; j++)
    { dEVectors[i][j] = z[k];
      k += m;
    }
  }

  /* free up the allocated space */
  myfree(a); myfree(z); myfree(iv1); myfree(if1);
}

call_rgg(mat1, mat2, m, n, wr, wi, beta, dEVectors, matzval)
double	 **mat2, **mat1;
int	 m, n;
double   *wr, *wi, *beta;
double   **dEVectors;
int	 matzval;
{ 
  int	 i, j, k, ierr;
  int	 nm, matz;
  double  *a_p_b, *b, *z;
  double *tmp;
  LINALGINIT

  /* allocate/initialize the matrices */
  ALLOCN(a_p_b, double, m*n);
  ALLOCN(b, double, m*n);
  for(j = k = 0; j < n; j++)
    for(i = 0; i < m; i++) {
      b[k] = mat1[i][j];	
      a_p_b[k++] = mat2[i][j];	
    }

  /* PRINT_MAT(mat, m, n, "Eigenvalue matrix"); */

  ALLOCN(z, double, m*n);

  matz = matzval;

#ifdef __SGI
  rgg_(&m, &n, b, a_p_b, wr, wi, beta, &matz, z, &ierr);
#else
  rgg(&m, &n, b, a_p_b, wr, wi, beta, &matz, z, &ierr);
#endif

  if (ierr != 0)
  { printf("Error computing eigenvalues\n"); 
    exit(-1);
  }

  for(i = 0; i < m; i++)
  { k = i;
    for(j = 0; j < n; j++)
    { dEVectors[i][j] = z[k];
      k += m;
    }
  }

  /* free up the allocated space */
  if (m && n) {
    myfree(a_p_b); myfree(b); myfree(z); 
  }
}
