#include "defs.h"

extern dgesvd_();

/*
main()
{ 
  double	**mat;
  double	**rgrgU, **rgrgV, *rgsigma;

  ALLOCMAT(mat, 2, 3, double);
  ALLOCMAT(rgrgU, 2, 2, double);
  ALLOCMAT(rgrgV, 3, 3, double);
  ALLOCN(rgsigma, double, 2);

  mat[0][0] = 0.96;
  mat[0][1] = 1.72;
  mat[0][2] = 4.72;
  mat[1][0] = 2.28;
  mat[1][1] = 0.96;
  mat[1][2] = 2.72;

  call_svd(mat, 2, 3, rgrgU, rgsigma, rgrgV);

  PRINT_MAT(rgrgU, 2, 2, "2D U");
  PRINT_VEC(rgsigma, 2, "1D Sigma");
  PRINT_MAT(rgrgV, 3, 3, "2D V");

  FREEMAT(rgrgU, 2, 2);
  FREEMAT(rgrgV, 3, 3);
  FREEMAT(mat, 2, 3);
  myfree(rgsigma);
}
*/

/* compute the singular value decomposition of a real m x n matrix mat */
/* this assumes u2, sigma, v2 have been allocated before calling this routine */
/* mat is unchanged at the end of the call */
call_svd(mat, m, n, rgrgu, rgsigma, rgrgv)
double   **rgrgu, **rgrgv, *rgsigma;
double	 **mat;
int	 m, n;
{ 
  int	 i, j, k, ierr;
  int	 min_mn, lda, ldu, lwork, ldvt;
  DOUBLE  *a, *u, *vt, *s, *e, *work;
  char	 jobu, jobvt;
  int    job;
  LINALGINIT

  /* allocate/initialize the matrices */
  ALLOCN(a, DOUBLE, m*n);
  for(j = k = 0; j < n; j++)
    for(i = 0; i < m; i++)
      a[k++] = mat[i][j];	

  min_mn = (m > n)? n: m;

/*
  jobu = 'A';
  jobvt = 'A';
*/
  job = 11;
  lda = ldu = m;
  ldvt = n;

  lwork = (m > n)? 5*m : 5*n;
  ALLOCN(u, DOUBLE, m*m);
  ALLOCN(vt, DOUBLE, n*n);
  ALLOCN(work, DOUBLE, lwork);
  ALLOCN(s, DOUBLE, min_mn);
  ALLOCN(e, DOUBLE, n);

  /* call the svd subroutine */
/*
  dgesvd_(&jobu, &jobvt, &m, &n, a, &lda, s, u, &ldu, vt, &ldvt, work, 
	 &lwork, &ierr);
*/

#ifdef __SGI
  dsvdc_(a, &lda, &m, &n, s, e, u, &ldu, vt, &ldvt, work, &job, &ierr);
#else
  dsvdc(a, &lda, &m, &n, s, e, u, &ldu, vt, &ldvt, work, &job, &ierr);
#endif

  if (ierr != 0)
  { printf("Error computing SVD\n"); 
    exit(-1);
  }
  /*
  else
  { printf("A After\n"); print_fort_mat(a, m, n);
    printf("U\n"); print_fort_mat(u, m, m);
    printf("Sigma\n"); print_fort_mat(s, min_mn, 1);
    printf("V-transpose\n"); print_fort_mat(vt, n, n);
  }
  */

  /* form the 2-dim arrays u, v, and the 1-dim array sigma*/
  for(k=j=0; j < m; j++)
    for(i=0;  i < m; i++)
      rgrgu[i][j] = u[k++];

  for(k=j=0; j < n; j++)
    for(i=0;  i < n; i++)
      rgrgv[i][j] = vt[k++]; /* This was changed from [j][i] to [i][j]
			 	when I changed from dgesvd to dsvdc */

  VEC_ASN_OP(rgsigma, =, s, min_mn);

  /* free up the allocated space */
  myfree(a); myfree(u); myfree(vt); myfree(work); myfree(s);
}

print_fort_mat(mat, m, n)
DOUBLE		*mat;
int		m, n;
{ 
  int		i, j, k; 

  for(i = 0; i < m; i++)
  { k = i; 
    for(j = 0; j < n; j++)
    { printf("%f ", mat[k]);
      k += m;
    }
    printf("\n");
  }
}
