#define SGI

#ifndef _defcolor_h
#define _defcolor_h


#ifdef PXPL
#include <pphigs.h>
#include <pg_sys.h>
#include <pg_dlist.h>
#include <pg_dglob.h>
#include <ros.h>
#include <math.h>
#include <stdio.h>
#include <sys/time.h>
#define MAX_PATCH_GP	25     /* Patches per GP that can be cached */
#else
#include <gl.h>
#include <gl/gl.h>
#include <math.h>
#include <stdio.h>
#include <sys/time.h>
#define DlistGlobalsType int
#define rc_refine_pass()        1
#define MAX_PATCH_GP	1200     /* Patches per GP(1) that can be cached */
#ifdef SGI
#define FOREGROUND	 foreground()
#else
#define FOREGROUND	

#define SGI
#endif
#endif

#define Printf		if(debug && rc_refine_pass() == 1) printf
#define CPrintf		if(cdebug && rc_refine_pass() == 1) printf
#define SQRT		(WTYPE) sqrt 
#define DOUBLE		(double)
#define MAXGP		40
#define MINF            0x000
#define MAXF            0x001
#define FRIGHT          0x010
#define FTURN           0x100
#define INFINITY	HUGE_VAL
#define CORRECT		0.5773502692 /* 1/sqrt(3) */
#define DEL		0.0001  /* Has Joy input changed ? */
#define FDELTA		0.0001  /* More than a stepsize -- float delta */
#define FDELTA_1	0.9999  /* More than a stepsize -- float delta */
#define COORD		3
#define WCOORD		4
#define UVCOORD		2
#define UVWCOORD	3
#define MAX_DEGREE	4     /* 1+Maximum degree of a patch (>1) */
/* #define MAX_CDEGREE	10     /* 1+Maximum degree of a trim-curve (>1) */
#define MAX_PATCH	1200   /* Maximum number of patches */
/* #define MAX_CURVE	600   /* Maximum number of trim-curves per patch */
#define MAX_CURVEPATCH	6   /* Maximum number of trim-curves per patch */
#define MAX_NO_POINTS	32    /* divisions on a patch */
#define MAX_CURVATUR	5    /* curvature estimate */
#define MAX_NO_POINTS2	MAX_NO_POINTS+2
/*#define MAX_CACH_POINTS	30    /* tmp const to ease cache handling */
/* #define CACH_MEM	200000 /* # words per gp */
#define MAX_PATCH_GP	1200     /* Patches per GP that can be cached */
#define ULTI_POINTS	MAX_NO_POINTS /* Too many points */
#define NSTEPS		0  /* 20 */
#define LSTEPS		1   /* 5 */
#define DIVPARAM	4
#define CURVPARAM	5
#define SCREENTOL	0.02  /* ??? 50 (*1024/2) pixels approx */
#define TOLERANCE	0.1
#define MAX_CURV_PATCH	20	/* (# curve divisions) / (# patch divisions) */
#define SQRT2		1.414213562
#define X		0
#define Y		1
#define Z		2
#define DIM2		2
#define LARGE_END_DIFF	15
#define LARGE_ADJ_DIFF	10
#define DIV_POINT	0.5000
#define DIV_POINT_1	0.5000	/* 1 - DIV_POINT */
#define U		1
#define V		2
#define UV00		1
#define UV01		2
#define UV10		4
#define UV11		8
#define EXTRAPTS	2
#define AUXSIZE		MAX_DEGREE*MAX_DEGREE*WCOORD
#define WIREFLAG	1 /* 0x001 */
#define MULTIFLAG1	6 /* 0x010 */
#define MULTIFLAG	6 /* 0x110 */
#define MAX_CROSS	6 /* Maximum # of curves crossing a v/u isoline */
#define BEZIER		0
#define PIECEWISE	1

#define FTAN(x)         ((float)tan ((double)(x)))


#define v3t		v3f
#define n3t		n3f
#define F		f

typedef float		WTYPE;
typedef WTYPE           CACHTYPE1[MAX_NO_POINTS2][MAX_NO_POINTS2][WCOORD];
typedef WTYPE           CACHTYPE2[2][MAX_NO_POINTS2][WCOORD];
typedef WTYPE		POINT[WCOORD];
typedef WTYPE		TPOINT[UVWCOORD];
typedef WTYPE		VECTOR[WCOORD];
typedef WTYPE		ELIST[MAX_NO_POINTS][WCOORD];
typedef WTYPE		PLIST[MAX_DEGREE][WCOORD];


struct  vcrosstype
{
WTYPE point[MAX_CROSS];
WTYPE critu[MAX_CROSS];
WTYPE critv[MAX_CROSS];
char  type[MAX_CROSS]; /* MIN/MAX*/
char  count; /* Initialize to 0 */
char  curve[MAX_CROSS];
};

/* MAX_GON is the maximun number of polygon per patch for a torus */
#define EPS 0.007
/* #define MAX_GON 121 */
/* #define MAX_PATCH 32 */
/* #define MAX_FACET 126 */
/* #define MAX_PT 257 */
#define RES  5

/*
float  whitevec[3] = {1.0, 1.0, 1.0};	
float  blackvec[3] = {0, 0, 0};
float  grayvec[3] = {0.8, 0.8, 0.8};
float  cyanvec[3] = {.3, .9, .7};
float  yelvec[3] = {1, 1, 0};
float  purplevec[3] = {0.4, 0.2, 0.6};
float  navyvec[3] = {0.0, 0.0, 1.0};
*/

/*Matrix idmat = {1.0,0.0,0.0,0.0,
                0.0,1.0,0.0,0.0,
		0.0,0.0,1.0,0.0,
		0.0,0.0,0.0,1.0};
*/

#ifdef PXPL
TimerValue timep1, timep2;
#define STARTTIME  if(rc_refine_pass() == 1) read_timer(&timep1);
#define ENDTIME(x) if(rc_refine_pass() == 1){			 	\
		   read_timer(&timep2);					\
		   if(cdebug) {printf("%s:", x);                        \
	           printf("Time at gp(patch)-pass %d(%d)-%d = %g\n",	\
                   ros_gpnum, patchno, rc_refine_pass(),		\
                   timer_to_double(&timep2)-timer_to_double(&timep1));}}
#else
#ifdef SGIDEF1
struct timeval timep1, timep2;
struct timezone TimeZone;
#define STARTTIME if(patchno == 0) gettimeofday(&timep1, &TimeZone);
#define ENDTIME(x) if(patchno == 0){					\
		   gettimeofday(&timep2, &TimeZone);			\
		   CPrintf("%s: Time for gp(patch)-pass %d(%d)-%d = ",   \
		   x, ros_gpnum, patchno, 1);				       \
   		   if (timep1.tv_usec > timep2.tv_usec)			       \
		   {							       \
		    CPrint("%d\n", (timep2.tv_sec-timep1.tv_sec-1)*1000000 +   \
                    (timep2.tv_usec-timep1.tv_usec+1000000)); 	               \
		   }							       \
		   else							       \
		   {							       \
		    CPrint("%d\n", (timep2.tv_sec-timep1.tv_sec)*1000000 +     \
                              (timep2.tv_usec-timep1.tv_usec));       	       \
		   }}
#else
#define	STARTTIME
#define	ENDTIME(x)
#endif
#endif

#ifdef SGI

/* define white RGB color */
extern float  whitevec[];
extern float  blackvec[];
extern float  grayvec[];
extern float  cyanvec[];
extern float  yelvec[];
extern float  purplevec[];
extern float  navyvec[];

#ifdef SGIDEF2

float  whitevec[3] = {1.0, 1.0, 1.0};	
float  blackvec[3] = {0, 0, 0};
float  grayvec[3] = {0.8, 0.8, 0.8};
float  cyanvec[3] = {.3, .9, .7};
float  yelvec[3] = {1, 1, 0};
float  purplevec[3] = {0.2, 0.1, 0.15};
float  navyvec[3] = {0.0, 0.0, 1.0};



Matrix idmat = {1.0,0.0,0.0,0.0, /* identity matrix */
                0.0,1.0,0.0,0.0,
		0.0,0.0,1.0,0.0,
		0.0,0.0,0.0,1.0};

/*define a polygon with some structures
 * -- for code readability*/
typedef struct { /* structure for a 3-D vertex */
    WTYPE x;
    WTYPE y;
    WTYPE z;
} POINTXYZ;

typedef struct { /* 4 vertex lighted polygon struct */
    POINTXYZ vertex[4];
    POINTXYZ normal[4];
} POLYGON;


/* define property arrays */
float darkred[] =
    {SPECULAR,  0.45, 0.05, 0.2, /* darkred reflectance */
     DIFFUSE,   0.45, 0.05, 0.2, /* reflectance */
     SHININESS, 10.0,           /* unfocused highlight */
     AMBIENT,   0.45, 0.0, 0.2,   /* reflectance */
     LMNULL};

float orange[] =
    {SPECULAR,  0.7, 0.2, 0.0, /* orange reflectance */
     DIFFUSE,   0.7, 0.2, 0.0, /* orange reflectance */
     SHININESS, 10.0,           /* unfocused highlight */
     AMBIENT,   0.8, 0.2, 0.0,   /* orange reflectance */
     LMNULL};

float pink[] =
    {SPECULAR,  0.0, 1.0, 1.0, /* pink reflectance */
     DIFFUSE,   0.0, 1.0, 1.0, /* pink reflectance */
     SHININESS, 10.0,           /* unfocused highlight */
     AMBIENT,   0.0, 1.0, 1.0,   /* pink reflectance */
     LMNULL};

float lavender[] =
    {SPECULAR,  0.30, 0.35, 0.25, 
     DIFFUSE,   0.98, 0.35, 0.35, 
     SHININESS, 20.0,          
     AMBIENT,   0.4, 0.45, 0.35, 
     LMNULL};


float cyan[] =
    {SPECULAR,  0.0, 0.7, 0.8, 
     DIFFUSE,   0.0, 0.7, 0.8, 
     SHININESS, 15.0,           
     AMBIENT,   0.0, 0.7, 0.8,   
     LMNULL}; 

float purple[] =
    {SPECULAR,  0.6, 0.4, 0.0, /* purple reflectance */
     DIFFUSE,   0.6, 0.4, 0.0, /* purple reflectance */
     SHININESS, 20.0,          /* unfocused highlight */
     AMBIENT,   0.6, 0.4, 0.0,   /* purple reflectance */
     LMNULL};


float red[] =
    {SPECULAR,  0.5, 0.2, 0.2, /* light red reflectance */
     DIFFUSE,   0.80, 0.0, 0.1, /* red reflectance */
     SHININESS, 12.0,          /* focused highlight */
     AMBIENT,   0.5, 0.0, 0.0,   /* red reflectance */
     LMNULL};

float blue[] =
    {SPECULAR,  0.2, 0.2, 0.5, /* blue reflectance */
     DIFFUSE,   0.1, 0.0, 0.8, /* blue reflectance */
     SHININESS, 10.0,           /* unfocused highlight */
     AMBIENT,   0.0,0.0,0.5,   /* blue reflectance */
     LMNULL};


float yellow[] =
    {SPECULAR,  0.80, 0.10, 0.0, /* yellow reflectance */
     DIFFUSE,   0.8, 0.15, 0.0, /* yellow reflectance */
     SHININESS, 10.0,           /* focused highlight */
     AMBIENT,   0.9,0.0,0.0,   /* yellow reflectance */
     LMNULL};

float white[] =
    {SPECULAR,  1.0, 1.0, 1.0, /* white reflectance */
     DIFFUSE,   1.0, 1.0, 1.0, /* whitereflectance */
     SHININESS, 30.0,           /* focused highlight */
     AMBIENT,   0.9, 0.9, 0.9,   /* white reflectance */
     LMNULL};

float black[] =
    {SPECULAR,  0.03, 0.03, 0.03, /* blackreflectance */
     DIFFUSE,   0.03, 0.031, 0.031, /* blackreflectance*/
     SHININESS, 3.0,           /* focused highlight */
     AMBIENT,   0.031, 0.031, 0.031,   /* black reflectance */
     LMNULL};

float gray[] =
    {ALPHA,	0.0,
     SPECULAR,  0.2, 0.2, 0.2, /* gray  reflectance */
     DIFFUSE,   0.2, 0.2, 0.2, /* gray reflectance */
     SHININESS, 10.0,           /* focused highlight */
     AMBIENT,   0.4, 0.4, 0.4,   /* gray reflectance */
     LMNULL};

float green[] =
    {SPECULAR,  0.0, 0.9, 0.0, /* green  reflectance */
     DIFFUSE,   0.0, 0.9, 0.0, /* green  reflectance */
     SHININESS, 10.0,           /* focused highlight */
     AMBIENT,   0.0, 0.9, 0.0,   /* green  reflectance */
     LMNULL};

float blueg[] =
    {SPECULAR,  0.0, 0.5, 0.9,
     DIFFUSE,   0.0, 0.5, 0.9, 
     SHININESS, 10.0,           
     AMBIENT,   0.0, 0.5, 0.9,   
     LMNULL};

float greenb[] =
    {SPECULAR,  0.5, 0.9, 0.7,
     DIFFUSE,   0.5, 0.9, 0.7, 
     SHININESS, 10.0,           
     AMBIENT,   0.5, 0.9, 0.7,   
     LMNULL};

float navy[] =
    {SPECULAR,  0.7, 0.2, 0.95,
     DIFFUSE,   0.2, 0.5, 0.95, 
     SHININESS, 10.0,           
     AMBIENT,   0.2, 0.5, 0.95,   
     LMNULL};

float light2[] =
    {AMBIENT,    1.0, 1.0, 1.0,
     LCOLOR,    1.0, 1.0, 1.0,   /* white light */
     POSITION,  -5.0,-5.0,-2.5,0.0,  /* Z axis at infinity */
     LMNULL};

float light3[] =
    {AMBIENT,    1.0, 1.0, 1.0,
     LCOLOR,    1.0, 1.0, 1.0,   /* white light */
     POSITION,  5.0,5.0,2.5,0.0,  /* Z axis at infinity */
     LMNULL};

float light4[] =
    {AMBIENT,    1.0, 1.0, 1.0,
     LCOLOR,    1.0, 1.0, 1.0,   /* white light */
     POSITION,  0.1,0.1,2.5,0.0,  /* Z axis at infinity */
     LMNULL};

float light[] =
    {AMBIENT,    1.0, 1.0, 1.0,
     LCOLOR,    1.0, 1.0, 1.0,   /* white light */
    		/* {LCOLOR,    0.9, 0.9, 0.9, */
     		/* POSITION,  10.0,10.0,10.0,1.0, */
     POSITION,  5.0,5.0,5.0,0.0,  /* Z axis at infinity */
     LMNULL};

float white_light[] =
    {AMBIENT,    1.0, 1.0, 1.0,
     LCOLOR,    0.9, 0.9, 0.9,   /* white light */
     POSITION,  0.0,0.0,1.0,0.0,  /* Z axis at infinity */
     LMNULL};

float light_one[] =
  { AMBIENT,    0.0, 0.0, 0.0,
    LCOLOR,     1.0, 1.0, 1.0,
    POSITION,   0.25, 0.25, 1.0, 0.0,  /* screen coordinates */
    LMNULL };

float shiny_material[] =
  { EMISSION,   0.0, 0.0, 0.0,
    AMBIENT,    0.20, 0.01, 0.01,
    DIFFUSE,    0.80, 0.10, 0.10,
    SPECULAR,   0.3, 0.5, 0.5,
    SHININESS,  10.0,
    ALPHA,      0.10,
    LMNULL };

float shiny_material1[] =
  { EMISSION,   0.0, 0.0, 0.0,
    AMBIENT,    0.01, 0.01, 0.21,
    DIFFUSE,    0.10, 0.10, 0.80,
    SPECULAR,   0.5, 0.3, 0.3,
    SHININESS,  10.0,
    ALPHA,      0.10,
    LMNULL };
float lighting_model[] =
  { AMBIENT,     1.0, 1.0, 1.0,
    LOCALVIEWER, 0.0,
    ATTENUATION, 0.0, 0.0,
    /* TWOSIDE,    1.0, */
    LMNULL };
#endif
#else
        extern int rc_refine_pass();
        extern int *rc_database;
        extern int ros_gpnum;
        extern int ros_num_gp;
        /*
        extern bez_surface(WTYPE[][MAX_DEGREE][WCOORD],
                           int, int, int, int *, int *, int, WTYPE, WTYPE,
                           WTYPE, DlistGlobalsType *);
        extern bez_surface(WTYPE[][MAX_DEGREE][WCOORD], int, int, int,
                           WTYPE[2][2], int, int, int, int, WTYPE, WTYPE,
                           WTYPE, int, int, DlistGlobalsType *);

        */
extern mymult(WTYPE[WCOORD], WTYPE[COORD][WCOORD], WTYPE[WCOORD], int);
extern crossp(VECTOR, VECTOR, VECTOR);
extern normalize(VECTOR, VECTOR);
extern render_tri(int, VECTOR, POINT, VECTOR, POINT, VECTOR, POINT,
                  DlistGlobalsType *);
extern WTYPE curvlength(WTYPE [][WCOORD], int);
#endif
extern WTYPE realarea(POINT *, int);
extern WTYPE diffnorm(POINT, POINT);
extern struct vcrosstype vcross[MAX_NO_POINTS2];

#endif
