/* #define PROFILE */

#ifndef __defcolorh__
#define __defcolorh__

#include "pg_bezier.h"

/* #include "/unc/kumar/Src/time.h" */
/* #include "/unc/kumar/Src/print.h" */

/* #conditional defines  */
#ifdef SGI
#define FOREGROUND   foreground()
#else  /* IBM, PXPL */		   
#define FOREGROUND             
#endif

#ifndef  PXPL
#define DlistGlobalsType int
#define rc_refine_pass() 1
#endif

#define DiffuseLen2	(DiffuseLen+DiffuseLen)
#define DiffuseLen3	(DiffuseLen2+DiffuseLen)
#define SQRT		(WTYPE) sqrt 
#define DOUBLE		(double)
#define VERT		2
#define UP		1
#define DOWN		2
#define IN		1
#define LOUT		2
#define ROUT		4
#define ONE		1
#define ZERO		0 /* To keep track of where end-points are hardcoded */
#define NIL		-1
#define LEFT            -1
#define RIGHT           1
#define FDELTA_1	0.9999  /* > a stepsize - float delta (?) */
#define DIM2		2
#define LARGE_END_DIFF	15
#define LARGE_ADJ_DIFF	10
#define DIV_POINT	0.5000
#define DIV_POINT_1	0.5000	/* 1 - DIV_POINT */
#define UV00		1
#define UV01		2
#define UV10		4
#define UV11		8
#define EXTRAPTS	1
/* #define AUXSIZE		MAX_ORDER*MAX_ORDER*WCOORD */
/* #define FACEFLAG0       0x00000000 */
/* #define FACEFLAG1       0x00000010 */
/* #define FACEFLAG2       0x00000020 */
/* #define COLFLAG         0xFFFFFFF8 */
/* #define WIREFLAG	0x1  */
/* #define MULTIFLAG1	0x1  */
/* #define MULTIFLAG	0x6  */
#define CORRECT         0.5773502692 /* 1/sqrt(3) */


#define FTAN(x)         ((float)tan ((double)(x)))


#define v3t		v3f
#define n3t		n3f
#define F		f

typedef struct {
   WTYPE p[COORD];
   WTYPE n[COORD];
} VERTEX;
typedef WTYPE		ELIST[MAX_NO_POINTS][WCOORD];
typedef VERTEX          CACHTYPE[MAX_NO_POINTS2*MAX_NO_POINTS2];
typedef WTYPE           CACHTYPE1[MAX_NO_POINTS2][MAX_NO_POINTS2][WCOORD];
typedef WTYPE           CACHTYPE2[2][MAX_NO_POINTS2][WCOORD];
typedef WTYPE		WPOINT[WCOORD];
typedef WTYPE		VECTOR[WCOORD];
typedef WTYPE		VERTEX0[VERT][COORD]; /* 2,3 */
typedef WTYPE		PLIST[MAX_ORDER][WCOORD];

#define EPS 0.007
#define RES  5

#ifdef SGITYPE

/* define white RGB color */
extern float  whitevec[];
extern float  blackvec[];
extern float  grayvec[];
extern float  cyanvec[];
extern float  yelvec[];
extern float  purplevec[];
extern float  navyvec[];

#ifdef SGIDEF2

float  whitevec[3] = {1.0, 1.0, 1.0};	
float  blackvec[3] = {0, 0, 0};
float  grayvec[3] = {0.8, 0.8, 0.8};
float  cyanvec[3] = {.3, .9, .7};
float  yelvec[3] = {1, 1, 0};
float  purplevec[3] = {0.2, 0.1, 0.3};
float  navyvec[3] = {0.0, 0.0, 1.0};



Matrix idmat = {1.0,0.0,0.0,0.0, /* identity matrix */
                0.0,1.0,0.0,0.0,
		0.0,0.0,1.0,0.0,
		0.0,0.0,0.0,1.0};

/*define a polygon with some structures
 * -- for code readability*/
typedef struct { /* structure for a 3-D vertex */
    WTYPE x;
    WTYPE y;
    WTYPE z;
} POINTXYZ;

typedef struct { /* 4 vertex lighted polygon struct */
    POINTXYZ vertex[4];
    POINTXYZ normal[4];
} POLYGON;


/* define property arrays */
float darkred[] =
    {SPECULAR,  0.45, 0.05, 0.2, /* darkred reflectance */
     DIFFUSE,   0.45, 0.05, 0.2, /* reflectance */
     SHININESS, 10.0,           /* unfocused highlight */
     AMBIENT,   0.45, 0.0, 0.2,   /* reflectance */
     LMNULL};

float orange[] =
    {SPECULAR,  0.7, 0.2, 0.0, /* orange reflectance */
     DIFFUSE,   0.7, 0.2, 0.0, /* orange reflectance */
     SHININESS, 10.0,           /* unfocused highlight */
     AMBIENT,   0.8, 0.2, 0.0,   /* orange reflectance */
     LMNULL};

float pink[] =
    {SPECULAR,  0.0, 1.0, 1.0, /* pink reflectance */
     DIFFUSE,   0.0, 1.0, 1.0, /* pink reflectance */
     SHININESS, 10.0,           /* unfocused highlight */
     AMBIENT,   0.0, 1.0, 1.0,   /* pink reflectance */
     LMNULL};

float lavender[] =
    {SPECULAR,  0.30, 0.35, 0.25, 
     DIFFUSE,   0.98, 0.35, 0.35, 
     SHININESS, 60,          
     AMBIENT,   0.4, 0.45, 0.35, 
     LMNULL};


float cyan[] =
    {SPECULAR,  0.1, 0.5, 0.8, 
     DIFFUSE,   0.1, 0.5, 0.8, 
     SHININESS, 5.0,           
     AMBIENT,   0.1, 0.5, 0.8,   
     LMNULL}; 

float purple[] =
    {SPECULAR,  0.6, 0.3, 0.8, /* purple reflectance */
     DIFFUSE,   0.6, 0.3, 0.8, /* purple reflectance */
     SHININESS, 20.0,          /* unfocused highlight */
     AMBIENT,   0.6, 0.3, 0.8,   /* purple reflectance */
     LMNULL};


float red[] =
    {SPECULAR,  0.85, 1.0, 1.0, /* light red reflectance */
     DIFFUSE,   0.80, 0.1, 0.1, /* red reflectance */
     SHININESS, 60.0,          /* focused highlight */
     AMBIENT,   0.8, 0.1, 0.1,   /* red reflectance */
     LMNULL};

float blue[] =
    {SPECULAR,  0.1, 0.0, 0.8, /* blue reflectance */
     DIFFUSE,   0.1, 0.0, 0.8, /* blue reflectance */
     SHININESS, 8.0,           /* unfocused highlight */
     AMBIENT,   0.0,0.0,0.8,   /* blue reflectance */
     LMNULL};

float yellow[] =
    {SPECULAR,  0.8, 0.10, 0.0, /* yellow reflectance */
     DIFFUSE,   0.8, 0.15, 0.0, /* yellow reflectance */
     SHININESS, 9.0,           /* focused highlight */
     AMBIENT,   0.9, 0.7, 0.5,   /* yellow reflectance */
     LMNULL};

float white[] =
    {SPECULAR,  1.0, 1.0, 1.0, /* white reflectance */
     DIFFUSE,   1.0, 1.0, 1.0, /* whitereflectance */
     SHININESS, 30.0,           /* focused highlight */
     AMBIENT,   0.9, 0.9, 0.9,   /* white reflectance */
     LMNULL};

float black[] =
    {SPECULAR,  0.03, 0.03, 0.03, /* blackreflectance */
     DIFFUSE,   0.03, 0.031, 0.031, /* blackreflectance*/
     SHININESS, 3.0,           /* focused highlight */
     AMBIENT,   0.031, 0.031, 0.031,   /* black reflectance */
     LMNULL};

float gray[] =
    {SPECULAR,  0.2, 0.2, 0.2, /* gray  reflectance */
     DIFFUSE,   0.2, 0.2, 0.2, /* gray reflectance */
     SHININESS, 10.0,           /* focused highlight */
     AMBIENT,   0.4, 0.4, 0.4,   /* gray reflectance */
     LMNULL};

float green[] =
    {SPECULAR,  0.0, 0.9, 0.0, /* green  reflectance */
     DIFFUSE,   0.0, 0.9, 0.0, /* green  reflectance */
     SHININESS, 10.0,           /* focused highlight */
     AMBIENT,   0.0, 0.9, 0.0,   /* green  reflectance */
     LMNULL};

float blueg[] =
    {SPECULAR,  0.0, 0.5, 0.9,
     DIFFUSE,   0.0, 0.5, 0.9, 
     SHININESS, 10.0,           
     AMBIENT,   0.0, 0.5, 0.9,   
     LMNULL};

float greenb[] =
    {SPECULAR,  0.5, 0.9, 0.7,
     DIFFUSE,   0.5, 0.9, 0.7, 
     SHININESS, 10.0,           
     AMBIENT,   0.5, 0.9, 0.7,   
     LMNULL};

float navy[] =
    {SPECULAR,  0.7, 0.2, 0.95,
     DIFFUSE,   0.2, 0.5, 0.95, 
     SHININESS, 10.0,           
     AMBIENT,   0.2, 0.5, 0.95,   
     LMNULL};

float light2[] =
    {AMBIENT,    0.0, 0.0, 0.0,
     LCOLOR,    1.0, 1.0, 1.0,   /* white light */
     POSITION,  -5.0,-5.0,-2.5,0.0,  /* Z axis at infinity */
     LMNULL};

float light3[] =
    {AMBIENT,    0.0, 0.0, 0.0,
     LCOLOR,    1.0, 1.0, 1.0,   /* white light */
     POSITION,  5.0,5.0,2.5,0.0,  /* Z axis at infinity */
     LMNULL};

float light4[] =
    {AMBIENT,    0.0, 0.0, 0.0,
     LCOLOR,    1.0, 1.0, 1.0,   /* white light */
     POSITION,  0.1,0.1,2.5,0.0,  /* Z axis at infinity */
     LMNULL};

float light[] =
    {AMBIENT,    0.0, 0.0, 0.0,
     LCOLOR,    1.0, 1.0, 1.0,   /* white light */
    		/* {LCOLOR,    0.9, 0.9, 0.9, */
     		/* POSITION,  10.0,10.0,10.0,1.0, */
     POSITION,  5.0,5.0,5.0,0.0,  /* Z axis at infinity */
     LMNULL};

float white_light[] =
    {LCOLOR,    0.9, 0.9, 0.9,   /* white light */
     POSITION,  0.0,0.0,1.0,0.0,  /* Z axis at infinity */
     LMNULL};

float light_one[] =
  { AMBIENT,    0.0, 0.0, 0.0,
    LCOLOR,     1.0, 1.0, 1.0,
    POSITION,   0.25, 0.25, 1.0, 0.0,  /* screen coordinates */
    LMNULL };

float shiny_material[] =
  { EMISSION,   0.0, 0.0, 0.0,
    AMBIENT,    0.20, 0.01, 0.01,
    DIFFUSE,    0.80, 0.10, 0.10,
    SPECULAR,   0.5, 0.9, 0.9,
    SHININESS,  60.0,
    ALPHA,      0.10,
    LMNULL };

float lighting_model[] =
  { AMBIENT,     0.0, 0.0, 0.0,
    LOCALVIEWER, 0.0,
    ATTENUATION, 0.0, 0.0,
    /* TWOSIDE,    1.0, */
    LMNULL };
#endif
#else

 extern int rc_refine_pass();
 extern int *rc_database;
 extern int ros_gpnum;
 extern int ros_num_gp;

 /* extern crossp(VECTOR, VECTOR, VECTOR); */
 extern normalize(VECTOR, VECTOR);
 extern render_tri(int, VERTEX*, VERTEX*, VERTEX*, DlistGlobalsType*);
 extern WTYPE curvlength(WTYPE [][WCOORD], int);
#endif

extern WTYPE realarea(POINT *, int);
extern WTYPE diffnorm(POINT, POINT);
extern struct vcrosstype vcross[MAX_NO_POINTS2];
#ifdef PXPL
extern bez_surface(WTYPE[][MAX_ORDER][WCOORD], byte, byte,
                   DlistGlobalsType*, TPOINT*[], byte, short[],
	           byte[][MAX_TRIMBREAKS], int);
#endif
/* 		PRINT FUNCTIONS */
#define Printf		if(bezdebug && rc_refine_pass() == 1) printf
#define CPrintf		if(bezdebug && rc_refine_pass() == 1) printf
#ifdef PXPL
#define printf1		if(rc_refine_pass() == 1) printf
#define pprintf         printf1("GP%d: ", ros_gpnum); printf1
#else
#define printf1         printf
#define pprintf         printf
#endif
/* 		PRINT FUNCTIONS */

/* TIMER		*/
#ifdef PXPL
#ifndef DONTDEFINE
TimerValue timep1, timep2;
#endif
#define STARTTIME  if(rc_refine_pass() == 1) read_timer(&timep1);
#define ENDTIME(x) if(rc_refine_pass() == 1){			 	\
		   read_timer(&timep2);					\
		   if(bezdebug) {printf("%s:", x);                        \
	           printf("Time at gp(patch)-pass %d(%d)-%d = %g\n",	\
                   ros_gpnum, patchno, rc_refine_pass(),		\
                   timer_to_double(&timep2)-timer_to_double(&timep1));}}
#else
#ifdef SGIDEF1
struct timeval timep1, timep2;
struct timezone TimeZone;
#define STARTTIME if(patchno == 0) gettimeofday(&timep1, &TimeZone);
#define ENDTIME(x) if(patchno == 0){					\
		   gettimeofday(&timep2, &TimeZone);			\
		   CPrintf("%s: Time for gp(patch)-pass %d(%d)-%d = ",   \
		   x, ros_gpnum, patchno, 1);				\
   		   if (timep1.tv_usec > timep2.tv_usec)			\
		   {							\
		   CPrint("%d\n",(timep2.tv_sec-timep1.tv_sec-1)*1000000+\
                    (timep2.tv_usec-timep1.tv_usec+1000000)); 	        \
		   }							\
		   else							\
		   {							\
		   CPrint("%d\n",(timep2.tv_sec-timep1.tv_sec)*1000000 + \
                              (timep2.tv_usec-timep1.tv_usec));       	\
		   }}
#else
#define	STARTTIME
#define	ENDTIME(x)
#endif
#endif
/* 		TIMER		*/

#ifdef SUBDIVIDE
#define SUB(x,y)	x
#else
#define SUB(x,y)	y
#endif

#define DOTPROD4I(R, S1, S2, c)     R[c] = 			     \
                                    S1[X]*S2[X][c] + S1[Y]*S2[Y][c]+ \
                                    S1[Z]*S2[Z][c] + S1[W]*S2[W][c]
#define DOTPROD4(R, S1, S2)         R = 			     \
                                    S1[X]*S2[X] + S1[Y]*S2[Y] +      \
                                    S1[Z]*S2[Z] + S1[W]*S2[W]
#define DOTPROD3I(R, S1, S2, c)     R[c] = 			     \
                                    S1[X]*S2[X][c] + S1[Y]*S2[Y][c]+ \
                                    S1[Z]*S2[Z][c]
#define DOTPROD3(R, S1, S2)         R = 			     \
                                    S1[X]*S2[X] + S1[Y]*S2[Y] +      \
                                    S1[Z]*S2[Z]
#ifdef PXPL
#define XFORMV(res, mat, pt)   { 				     \
                                    DOTPROD3(res[X], mat[X], pt);    \
                                    DOTPROD3(res[Y], mat[Y], pt);    \
                                    DOTPROD3(res[Z], mat[Z], pt);    \
				}

#define XFORMP(res, mat, pt, coord) { 				     \
                                    DOTPROD3(res[X], mat[X], pt);    \
                                    DOTPROD3(res[Y], mat[Y], pt);    \
                                    DOTPROD3(res[Z], mat[Z], pt);    \
                                    if(coord == COORD) {             \
                                         res[X] += mat[X][W];	     \
                                         res[Y] += mat[Y][W];	     \
                                         res[Z] += mat[Z][W];	     \
                                    }                                \
                                    else {                           \
                                         res[X] += mat[X][W]*pt[W];  \
                                         res[Y] += mat[Y][W]*pt[W];  \
                                         res[Z] += mat[Z][W]*pt[W];  \
                                         tmp = 1.0/pt[W];            \
                                         res[X] *= tmp;              \
                                         res[Y] *= tmp;              \
                                         res[Z] *= tmp;              \
                                    }                                \
				    }
#else
extern Matrix M1;
#define XFORMP(pt, res)	        { \
                                     DOTPROD4I(res, pt, M1, X);      \
                                     DOTPROD4I(res, pt, M1, Y);      \
                                     DOTPROD4I(res, pt, M1, Z);      \
                                     DOTPROD4I(res, pt, M1, W);      \
                        	}
#endif
#endif
