#include "defs.h"

extern		allocDeterminant();

/* Divide a polynomial given in the form of a Dixon's matrix by the
   factors (s-a) and (t-b). Refer Sederberg's thesis for terminology.
*/
void divide_dixon(pndet, m, n)
NDETERMINANT		*pndet;
int			m, n;
{ 
   int			d, i, j, k, l;
   NDETERMINANT		temp_ndet;

   allocDeterminant(&temp_ndet, m, n, UNFACTORED );
   zeroTheDeterminant(temp_ndet);
   /* factor out (s-a) */
   for(i = m; i > 0; i--)		/* powers of s */
     for(j = 2*n; j >= 0; j--)		/* powers of t */
       for(k = 2*m-1; k >= 0; k--)  	/* powers of a */
	 for(l = n; l >= 0; l--)	/* powers of b */
	   for(d = 0; d < 4; d++)	/* all four dimensions */
	   { 
	     temp_ndet.coeffs[ROW_INDEX(k, l, n)][COL_INDEX(i-1,j, m)].dCoord[d]
	     =pndet->coeffs[ROW_INDEX(k, l, n)][COL_INDEX(i, j, m)].dCoord[d];
	     pndet->coeffs[ROW_INDEX(k+1, l, n)][COL_INDEX(i-1, j, m)].dCoord[d]
	     +=pndet->coeffs[ROW_INDEX(k, l, n)][COL_INDEX(i, j, m)].dCoord[d];
	     pndet->coeffs[ROW_INDEX(k, l, n)][COL_INDEX(i, j, m)].dCoord[d] 
	     = 0.0;
           }


   zeroTheDeterminant(*pndet);
   /* factor out (t-b) */
   for(j = 2*n; j > 0; j--)		/* powers of t */
     for(i = m-1; i >= 0; i--)		/* powers of s */
       for(l = n-1; l >= 0; l--)	/* powers of b */
         for(k = 2*m-1; k >= 0; k--)  	/* powers of a */
	   for(d = 0; d < 4; d++)	/* all four dimensions */
	   { 
	     pndet->coeffs[ROW_INDEX(k, l, n)][COL_INDEX(i,j-1, m)].dCoord[d]
	     =temp_ndet.coeffs[ROW_INDEX(k,l, n)][COL_INDEX(i, j, m)].dCoord[d];
	     temp_ndet.coeffs[ROW_INDEX(k,l+1,n)][COL_INDEX(i,j-1,m)].dCoord[d]
	     +=temp_ndet.coeffs[ROW_INDEX(k,l,n)][COL_INDEX(i, j, m)].dCoord[d];
	     temp_ndet.coeffs[ROW_INDEX(k, l, n)][COL_INDEX(i, j, m)].dCoord[d] 
	     = 0.0;
           }
   free_alloc_determ(&temp_ndet);
}







