#include <stdio.h>
#include "defs.h"

#define DEG_ELEV

#define COORD		3
#define WCOORD		4
#define MAX_DEGREE	6	/* was 4 previously */
#define X		0
#define Y		1
#define Z		2
#define W		3

typedef double	WPOINT[WCOORD];

fillnc(Nc, n)
int Nc[], n;
{
int mn, i;

   if (n < 0) return;
   Nc[0] = Nc[n] = 1; Nc[1] = n;
   if (n > 0) Nc[n-1] = n;

   mn = n-2;
   for(i = 2; i < mn; i++)
      Nc[i] = Nc[i-1]*(n-i+1)/i;
   if(mn > 0)
      Nc[mn] = Nc[mn-1]*(n-mn+1)/mn;

}

#ifdef CUBEEXP
cubeexp(cntrl1, cntrl3, m1, n1, coord1, coord3)
WPOINT cntrl1[][MAX_DEGREE*3];
WPOINT cntrl3[][MAX_DEGREE*3];
int m1, n1, coord1, coord3;
{
int i, j, k, l;
int mc[12], nc[12], m1c[12], n1c[12], m2c[12], n2c[12];

   fillnc(m1c, m1);
   fillnc(n1c, n1);
   fillnc(mc, m1+m1+m1);
   fillnc(nc, m1+n1+n1);
/*
   printf(" m1, n1, m2, n2 = %d %d %d %d\n", m1, n1, m2, n2);
   for (i=0; i<12; i++) 
     printf("m1c,n1c,m2c,n2c of %d = %d %d %d %d\n", i, m1c[i],n1c[i],
             m2c[i], n2c[i]);
*/

   for (i=0; i<=m1+m1; i++)
   for (j=0; j<=n1+n1; j++)
     cntrl3[i][j][coord3] = 0.0;

   for(i=0; i<=m1; i++)
     for(j=0; j<=n1; j++)
         for(k=0; k<=m2; k++)
            for(l=0; l<=n2; l++)
            {
	       cntrl3[i+k][j+l][coord3] += m1c[i]*n1c[j]*m2c[k]*n2c[l]*
                          cntrl1[i][j][coord1]*cntrl2[k][l][coord2];
            }

   for (i=0; i<=m1+m2; i++)
   for (j=0; j<=n1+n2; j++) {
     cntrl3[i][j][coord3] /= (mc[i]*nc[j]);
     printf("cntrl3[%d][%d] = %lf\n", i, j, cntrl3[i][j][coord3]);
   }
}
#endif

multexp(cntrl1, cntrl2, cntrl3, m1, n1, m2, n2, coord1, coord2, coord3)
WPOINT cntrl1[][MAX_DEGREE*3];
WPOINT cntrl2[][MAX_DEGREE*3];
WPOINT cntrl3[][MAX_DEGREE*3];
int m1, m2, n1, n2, coord1, coord2, coord3;
{
int i, j, k, l;
int mc[12], nc[12], m1c[12], n1c[12], m2c[12], n2c[12];

   fillnc(m1c, m1);
   fillnc(n1c, n1);
   fillnc(m2c, m2);
   fillnc(n2c, n2);
   fillnc(mc, m1+m2);
   fillnc(nc, n1+n2);
#ifdef YESPRINT
   printf(" m1, n1, m2, n2 = %d %d %d %d\n", m1, n1, m2, n2);
   for (i=0; i<12; i++) 
     printf("m1c,n1c,m2c,n2c of %d = %d %d %d %d\n", i, m1c[i],n1c[i],
             m2c[i], n2c[i]);
#endif

   for (i=0; i<=m1+m2; i++)
   for (j=0; j<=n1+n2; j++)
     cntrl3[i][j][coord3] = 0.0;

   for(i=0; i<=m1; i++)
     for(j=0; j<=n1; j++)
         for(k=0; k<=m2; k++)
            for(l=0; l<=n2; l++)
            {
	       cntrl3[i+k][j+l][coord3] += m1c[i]*n1c[j]*m2c[k]*n2c[l]*
                          cntrl1[i][j][coord1]*cntrl2[k][l][coord2];
#ifdef YESPRINT
	       printf(" %d && %d && %d && %d :: %lf == %lf\n",
		i,j,k,l,cntrl1[i][j][coord1],cntrl2[k][l][coord2]); 
#endif
            }

   for (i=0; i<=m1+m2; i++)
   for (j=0; j<=n1+n2; j++) {
     cntrl3[i][j][coord3] /= (mc[i]*nc[j]);
#ifdef YESPRINT
     printf("cntrl3[%d][%d] = %lf\n", i, j, cntrl3[i][j][coord3]);
#endif
   }
}

crosspexp(cntrl1, cntrl2, m1, n1, m2, n2, cntrl3)
WPOINT cntrl1[][MAX_DEGREE*3];
WPOINT cntrl2[][MAX_DEGREE*3];
WPOINT cntrl3[][MAX_DEGREE*3];
int m1, m2, n1, n2;
{
int i, j, k, m, n;
WPOINT cntrlt[MAX_DEGREE*3][MAX_DEGREE*3];

   m = m1+m2; n = n1+n2;
   multexp(cntrl1, cntrl2, cntrl3, m1, n1, m2, n2, Y, Z, X);
/*
   for(i=0; i<=m; i++)
      for(j=0; j<=n; j++) {
         for(k=0; k<WCOORD; k++)
	   printf("%lf ", cntrl3[i][j][k]);
	 printf("\n");
      }
*/

   multexp(cntrl1, cntrl2, cntrlt, m1, n1, m2, n2, Z, Y, X);
   for(i=0; i<= m; i++)
      for(j=0; j<= n; j++)
         cntrl3[i][j][X] -= cntrlt[i][j][X];

   multexp(cntrl1, cntrl2, cntrl3, m1, n1, m2, n2, Z, X, Y);
   multexp(cntrl1, cntrl2, cntrlt, m1, n1, m2, n2, X, Z, Y);
   for(i=0; i<= m; i++)
      for(j=0; j<= n; j++)
         cntrl3[i][j][Y] -= cntrlt[i][j][Y];

   multexp(cntrl1, cntrl2, cntrl3, m1, n1, m2, n2, X, Y, Z);
   multexp(cntrl1, cntrl2, cntrlt, m1, n1, m2, n2, Y, X, Z);
   for(i=0; i<= m; i++)
      for(j=0; j<= n; j++)
         cntrl3[i][j][Z] -= cntrlt[i][j][Z];

}

do_deg_elev(cntrlFrom, cntrlTo, deg0, deg1, coord)
WPOINT cntrlFrom[][MAX_DEGREE*3];
WPOINT cntrlTo[][MAX_DEGREE*3];
int deg0, deg1, coord;
{
  int i, j, k;
  int newDeg0, newDeg1;
  WPOINT tmpcntrl[MAX_DEGREE*3][MAX_DEGREE*3];

  if (coord < 0 || coord > 2) {
    printf("Wrong Input for COORD\n");
    return;
  }

  newDeg0 = deg0 + 1;
  newDeg1 = deg1;

  for (j=0; j<=newDeg1; j++) {
    tmpcntrl[0][j][coord] = cntrlFrom[0][j][coord];
    tmpcntrl[newDeg0][j][coord] = cntrlFrom[deg0][j][coord];
  }

  for (i=1; i<newDeg0; i++)
  for (j=0; j<=newDeg1; j++)
    tmpcntrl[i][j][coord] = (i*cntrlFrom[i-1][j][coord] + (newDeg0-i)*
                             cntrlFrom[i][j][coord]) / newDeg0;

  newDeg1++; /* To degree elevate V */

  for (i=0; i<=newDeg0; i++) {
    cntrlTo[i][0][coord] = tmpcntrl[i][0][coord];
    cntrlTo[i][newDeg1][coord] = tmpcntrl[i][deg1][coord];
  }

  for (i=0; i<=newDeg0; i++)
  for (j=1; j<newDeg1; j++)
    cntrlTo[i][j][coord] = (j*tmpcntrl[i][j-1][coord] + (newDeg1-j)*
                               tmpcntrl[i][j][coord]) / newDeg1;
}

gaussmap(cntrl, udegree, vdegree, cntrln)
WPOINT cntrl[][MAX_DEGREE], cntrln[][MAX_DEGREE*3];
int udegree, vdegree;
{
int mc[16];
int nc[16];
WPOINT lcntrl[MAX_DEGREE*3][MAX_DEGREE*3];
WPOINT cntrlt[MAX_DEGREE*3][MAX_DEGREE*3];
WPOINT cntrlt2[MAX_DEGREE*3][MAX_DEGREE*3];
WPOINT cntrl2[MAX_DEGREE*3][MAX_DEGREE*3];
WPOINT cntrl3[MAX_DEGREE*3][MAX_DEGREE*3];
WPOINT tmpcntrl[MAX_DEGREE*3][MAX_DEGREE*3];
int m, n, m1, n1, i, j, k;
int tmp_m, tmp_n;

   m = udegree+udegree+udegree;
   n = vdegree+vdegree+vdegree;
   tmp_m = m-1;
   tmp_n = n-1;

   for(i=0; i<=m; i++)
      for(j=0; j<=n; j++)
         for(k=0; k<WCOORD; k++)
	    cntrln[i][j][k] = 0;

   for(i=0; i<=udegree; i++)
      for(j=0; j<=vdegree; j++)
         for(k=0; k<WCOORD; k++)
            lcntrl[i][j][k] = cntrl[i][j][k];
   for(i=0; i<udegree; i++)
      for(j=0; j<=vdegree; j++) {
         for(k=0; k<WCOORD; k++) {
            cntrl2[i][j][k] = udegree*(cntrl[i+1][j][k]-cntrl[i][j][k]);
         }
      }
   for(i=0; i<=udegree; i++)
      for(j=0; j<vdegree; j++)
         for(k=0; k<WCOORD; k++)
            cntrl3[i][j][k] = vdegree*(cntrl[i][j+1][k]-cntrl[i][j][k]);

   crosspexp(cntrl2,cntrl3,udegree-1,vdegree,udegree,vdegree-1,cntrlt);
   m1 = (udegree-1)+(udegree); n1 = (vdegree)+(vdegree-1);
   multexp(cntrlt, lcntrl,cntrln, m1, n1, udegree, vdegree, X, W, X);
   multexp(cntrlt, lcntrl,cntrln, m1, n1, udegree, vdegree, Y, W, Y);
   multexp(cntrlt, lcntrl,cntrln, m1, n1, udegree, vdegree, Z, W, Z);

   crosspexp(lcntrl,cntrl3,udegree,vdegree,udegree,vdegree-1,cntrlt);
   m1 = (udegree)+(udegree); n1 = (vdegree)+(vdegree-1);
   multexp(cntrlt,cntrl2,cntrlt2, m1, n1, udegree-1, vdegree, X, W, X);
   multexp(cntrlt,cntrl2,cntrlt2, m1, n1, udegree-1, vdegree, Y, W, Y);
   multexp(cntrlt,cntrl2,cntrlt2, m1, n1, udegree-1, vdegree, Z, W, Z);
   m1 += udegree-1; n1 += vdegree;
   for(i=0; i<=m1; i++)
      for(j=0; j<=n1; j++)
         for(k=0; k<COORD; k++)
	    cntrln[i][j][k] -= cntrlt2[i][j][k];

   crosspexp(cntrl2,lcntrl,udegree-1,vdegree,udegree,vdegree,cntrlt);
   m1 = (udegree-1)+(udegree); n1 = (vdegree)+(vdegree);
   multexp(cntrlt,cntrl3,cntrlt2, m1, n1, udegree, vdegree-1, X, W, X);
   multexp(cntrlt,cntrl3,cntrlt2, m1, n1, udegree, vdegree-1, Y, W, Y);
   multexp(cntrlt,cntrl3,cntrlt2, m1, n1, udegree, vdegree-1, Z, W, Z);
   m1 += udegree; n1 += vdegree-1;
   for(i=0; i<=m1; i++)
      for(j=0; j<=n1; j++)
         for(k=0; k<COORD; k++)
	    cntrln[i][j][k] -= cntrlt2[i][j][k];

   multexp(lcntrl,lcntrl,cntrlt,udegree,vdegree,udegree,vdegree,W,W,W);
   multexp(cntrlt,lcntrl,cntrln,2*udegree,2*vdegree,udegree,vdegree,W,W,W);

   for(i=0; i<m; i++)
   for(j=0; j<n; j++)
     for(k=0; k<WCOORD; k++) 
       tmpcntrl[i][j][k] = cntrln[i][j][k];

#ifdef DEG_ELEV
   do_deg_elev(tmpcntrl, cntrln, tmp_m, tmp_n, X);
   do_deg_elev(tmpcntrl, cntrln, tmp_m, tmp_n, Y);
   do_deg_elev(tmpcntrl, cntrln, tmp_m, tmp_n, Z);
#endif

#ifdef WRITE_INTO_FILE
   fprintf(fp, "%d %d\n", m, n);
   for(i=0; i<=m; i++)
      for(j=0; j<=n; j++) {
         for(k=0; k<WCOORD; k++) {
	    fprintf(fp, "%lf ", cntrln[i][j][k]);
	 }
	 fprintf(fp, "\n");
      }
#endif
}

void DetGaussMap(tp, out_tp)
TENSOR_PATCH tp, *out_tp;
{
  WPOINT cntrl[MAX_DEGREE][MAX_DEGREE];
  WPOINT cntrln[3*MAX_DEGREE][3*MAX_DEGREE];
  FILE *fp1, *fp2;
  int udeg, vdeg, i, j, k, l, numPatches;

  udeg = tp.iDeg0; 
  vdeg = tp.iDeg1; 

  for (i=0; i<=udeg; i++)
  for (j=0; j<=vdeg; j++)
    for (k=0; k<WCOORD; k++)
      cntrl[i][j][k] = tp.coeffs[i][j].dCoord[k];

  gaussmap(cntrl, udeg, vdeg, cntrln);

  out_tp->iDeg0 = 3*udeg;
  out_tp->iDeg1 = 3*vdeg;
  allocate_tensor_patch(out_tp);

  for (i=0; i<=out_tp->iDeg0; i++)
  for (j=0; j<=out_tp->iDeg1; j++)
    for (k=0; k<WCOORD; k++)
      out_tp->coeffs[i][j].dCoord[k] = cntrln[i][j][k];
}

void EvalUnitNormal(tp, u, v, x, y, z)
TENSOR_PATCH *tp;
double u, v;
double *x, *y, *z;
{
  double tmpx, tmpy, tmpz, magn;

  EvalPointOnPatch(*tp, u, v, &tmpx, &tmpy, &tmpz);

  magn = 0.0;
  magn = tmpx*tmpx + tmpy*tmpy + tmpz*tmpz;

  magn = sqrt(magn);

  *x = tmpx / magn;
  *y = tmpy / magn;
  *z = tmpz / magn;
}

