#include "defs.h"
#include "linalg.h"

/* This routine is called only when the patches have spline reprns and */
/* returns the graph of the solid */
void obtain_graph_for_solid(sol, num, graph)
TRIM_PATCH_INFO *sol;
int num, **graph;
{
  int i, j, k, l, m;
  TRIM_PORTION_SPLINE_TYPE *tpst;
  int unique;

  l = 0;
  for (i=0; i<num; i++)
    for (j=0; j<sol[i].NumTrimPortions; j++) {
      tpst = &sol[i].TrimPortion[j].SplinePortion;
      for (k=0; k<tpst->NumOfCurves; k++) {
	/* make sure this neighbor is not already marked */
	unique = 1;
	for (m=0; m<l; m++)
	  if (graph[i][m] == tpst->AdjInfo[k]) {
	    unique = 0;
	    break;
	  }

	if (unique)
	  if (l == MAX_SPLINES_PER_TRIM_REGION) {
	    printf("obtain_graph_for_solid: Too many neighbors\n");
	    exit(-1);
	  } else
	    graph[i][l++] = tpst->AdjInfo[k];
      }
    }
}
