#ifndef _hostgp_h
#define _hostgp_h
#include <math.h>

#include "colortrim.h"

/* #define MAX_PKD_CNTRL_PTS	(16*17*MAX_PATCH_GP) */
/* #define MAX_TRIMCURVEALL	(70*MAX_PATCH_GP) */
#define MAX_PKD_CNTRL_PTS	(10*16*MAX_PATCH_GP)
#define MAX_TRIMCURVEALL	(40*MAX_PATCH_GP)
#define MAX_STATIC_TRIS		(800)
#define MAX_PATCHMEM		(MAX_PKD_CNTRL_PTS+MAX_TRIMCURVEALL)
/* Header file for definitions shared by host and GP code */

/* #define    F_CDEBUG		0x1 */
/* #define    F_DEBUG		0x2 */
/* #define    F_WIRE		0x4 */
#define    F_MULTI		0x8
/* #define    F_BACKFACE		0x10 */
#define    F_INVERT		0x20
#define    F_RETURN		0x40
#define    F_ISSIMPLE		0x4
#define    F_BIGCRACKS		0x1
#define    F_EACHFRAMETEST	0x2

#define    F_FREEZES		0x100
#define    F_FREEZEH		0x200
#define    F_FREEZE		0x300

#define    F_RATIONAL	0x1

#define    VERTNORM	4

/* Global variables in sample callback program */

/* Particle data passed to GP in user callback */

#if 0

typedef struct {
    byte    udegree;
    byte    vdegree;
    byte    NumTcurves;			/* Number of trim curves */
    byte    Flags;			/* RATIONAL ? */
/*  short   patchno;		        /* = 0 for last one */
    short   CntrlAdr;
    short   TcDegree[MAX_TRIMCURVE];	/* And Type */
    short   TcAdr[MAX_TRIMCURVE];	/* Pointers to trimpoints */
    byte    solid;			/* solid number */
    byte    subsolid;			/* solid number */
    byte    TcBreaks[MAX_TRIMCURVE][MAX_TRIMBREAKS]; /*Critical Points*/
    int     diff;			/* Diffused color */
    int     spec;			/* Specular color */
} CallbackParam0;

typedef struct {
    ElementHeader E;
    unsigned char udegree;
    unsigned char vdegree;
    unsigned char num_curves;
    unsigned char extra_len;
    short         patchno; /* Can't handle >65535 patches/GP anyway */
    short         flags;   /* back-reject flat shade - indirect verts ? */
    int           pdiff;   /* Send only packed Color */
    int           pspec;   /* Send only packed Color */
} BezierPatchHeader;

typedef struct  {
    BezierPatchHeader H;
    int data[MAX_BEZSPACE];      /* Control points and curves */
} BezierPatchRecord;

typedef struct {
    short   Flags;
            /* cdebug, debug, wire, firsttime, inverttri,freeze */
    short   TriFlag;       /* flag for rendering tessellated triangles */
    int     cache;         /* Allocated by the host, Temporary: Remove */
    float   tolerance;
    float   curvparam;
    float   newskiplen;
    unsigned char     TestFrequency;
} BezParamType;

#endif

typedef struct {
    short   FirstPatchno;  /* Keep if patchno not in CallbackParam */
    short   NumPatches;    /* */
    short   arbit;
    int     cache;
    byte    NumSolids;
    byte    NumSubSolids;
    WTYPE   box[MAX_SOLIDS][MINMAX][COORD];
    WTYPE   sbox[MAX_SUBSOLIDS][MINMAX][COORD];
    WTYPE   invPatchCnt[MAX_SUBSOLIDS];
} BezEnvStuff;

typedef struct {
     BezEnvStuff bezenv;
     int         PatchMem[MAX_PATCHMEM];
} CallbackParam;

typedef struct {
    int   solidnum;
} InstanceParam;

typedef struct {
    WTYPE   cntrl[MAX_PKD_CNTRL_PTS];
} PassCntrlParam;

typedef struct {
    WTYPE   tcurve[MAX_TRIMCURVEALL][UVCOORD];
} PassCurveParam;

#ifdef SGI
typedef int		TriangleRecord;
#endif

typedef struct {
    /* WTYPE   tri[MAX_STATIC_TRIS][VERTNORM][COORD]; */
    TriangleRecord   tri[MAX_STATIC_TRIS];
} PassTriParam;

#endif /*_hostgp_h*/
/* nsteps has color */
