#include <stdio.h>
#include "defs.h"
#ifdef __GL
#include <gl.h>
#include <gl/gl.h>
#endif

void read_tensor_patch();
/* void allocate_tensor_patch(); */
void scale_tensor_patch();
extern double	Scale;
extern int sp;
#ifdef __GL
extern Matrix  Mmpi, Mm2pi;
#endif

void
read_input(ptpPatch0, ptpPatch1, num_first, num_second, infile)
TENSOR_PATCH	*ptpPatch0, *ptpPatch1;
int		*num_first, *num_second;
char		*infile;
{
  FILE		*fp;

  if (!(fp = fopen(infile, "r"))) {
    fprintf(stderr,"\nFile %s does not exist. Exiting ...\n",infile);
    exit(-2);
  }

  fscanf(fp, "%d", num_first);
  fscanf(fp, "%d", num_second);

  read_tensor_patch(ptpPatch0, *num_first, fp, 0);

  read_tensor_patch(ptpPatch1, *num_second, fp, 1);

#ifdef _SCALE
  scale_tensor_patch(ptpPatch0, *num_first);

  scale_tensor_patch(ptpPatch1, *num_second);
#else
  Scale = 1.0;
#endif

  fclose(fp);

}

void
scale_tensor_patch(ptpPatch, num_of_patches)
TENSOR_PATCH	*ptpPatch;
int		num_of_patches;
{
    int i,k,j, l;
  /* scale the values down */
  for (l=0; l<num_of_patches; l++) {
    for(i = 0; i <= ptpPatch[l].iDeg0; i++)
      for(j = 0; j <= ptpPatch[l].iDeg1; j++)
        for(k = X; k <= Z; k++) 
  	  ptpPatch[l].coeffs[i][j].dCoord[k] /= Scale;
  }
}

void
read_tensor_patch(ptpPatch, num_of_patches, fp, zo)
TENSOR_PATCH	*ptpPatch;
int		num_of_patches, zo;
FILE		*fp;
{ 
  int		i, j, k, l, r;
  double	q[4],qq[4];

  for (l=0; l<num_of_patches; l++) {
    fscanf(fp, "%d %d\n", &(ptpPatch[l].iDeg0), &(ptpPatch[l].iDeg1));

    /* allocate memory and set up pointers*/
    allocate_tensor_patch(&(ptpPatch[l]));

    /* read in values */
      for(i = 0; i <= ptpPatch[l].iDeg0; i++)
        for(j = 0; j <= ptpPatch[l].iDeg1; j++) {
          for(k = X; k <=W; k++) {
	    ptpPatch[l].coeffs[i][j].dCoord[k] = 0.0;
            fscanf(fp, "%lf ", &q[k]); 
          }
	  if (!sp) {
            for(k = X; k <=W; k++) 
	        ptpPatch[l].coeffs[i][j].dCoord[k] = q[k];
	  } else {
            if (zo) {
              for(k = X; k <=W; k++) 
	          ptpPatch[l].coeffs[i][j].dCoord[k] = q[k];
	    }
#ifdef __GL
	    else {
              for(k = X; k <=W; k++) 
	        for (r=0; r<4; r++)
	          ptpPatch[l].coeffs[i][j].dCoord[k] += q[r] * Mmpi[r][k];
	    }
#endif
	  }
          for(k = X; k <=Z; k++) 
	    if (Scale < fabs(ptpPatch[l].coeffs[i][j].dCoord[k]))
	        Scale = fabs(ptpPatch[l].coeffs[i][j].dCoord[k]);
          fscanf(fp, "\n");
        }
  }
}

