#include <stdio.h>
#include <string.h>
#include "defs.h"

extern void evaluateBernstein();
extern void allocate_tensor_patch();
extern double Scale;
double cpoints[4][4][3];


print_tensor_patch(tpPatch, fp)
TENSOR_PATCH		tpPatch;
FILE			*fp;
{ 
  int			i, j, k;
  static int fFirst=1;

  fprintf(fp, "Tensor Patch degrees %d %d\n", tpPatch.iDeg0, tpPatch.iDeg1);

  for(i = 0; i <= tpPatch.iDeg0; i++)
  { for(j = 0; j <= tpPatch.iDeg1; j++)
    { fprintf(fp, "(");
      for(k = 0; k < 4; k++)  {
	  if (k<=Z) {
	      fprintf(fp, " %4.2f",tpPatch.coeffs[i][j].dCoord[k]*Scale);
	      cpoints[i][j][k]=tpPatch.coeffs[i][j].dCoord[k]*Scale/
		                       tpPatch.coeffs[i][j].dCoord[3];
	  }
	  else {
	      fprintf(fp, " %4.2f",tpPatch.coeffs[i][j].dCoord[k]);
	  }
      }
      fprintf(fp, ") ");
    }
    fprintf(fp, "\n");
  }
  fprintf(fp, "\n");
/*
  if (fFirst) {
      initSurface1( cpoints );
      fFirst=0;
  }
  else
      initSurface2( cpoints );
*/
}


void outputPolyLines( pf, pchName, plp4D, tp, iParam0, iParam1, work_type, cRed, cGreen, cBlue)
FILE         *pf;
char         *pchName;
LIST_POINT4D *plp4D;
TENSOR_PATCH tp;
int	     work_type, iParam0, iParam1;
int         cRed, cGreen, cBlue;
{
    POINT4D  p4D;
    POINT2D  p2D;
    static int red, green, blue;

    if (work_type == START)
    { fprintf(pf,"\nstructure %s posted {", pchName);
      fprintf(pf,"\ncolor sphere {");
      fprintf(pf,"\ndiff %d %d %d 0 %d %d %d 0", 
	      cRed, cGreen, cBlue, cRed, cGreen, cBlue );
      fprintf(pf,"\nspec 255 255 255 1 255 255 255 1\n};");
      red=cRed, green=cGreen, blue=cBlue;
    }
    
    for (;plp4D;plp4D=plp4D->plp4DNext) {
	p2D.u = plp4D->p4D.dCoord[iParam0];
	p2D.v = plp4D->p4D.dCoord[iParam1];
	evaluateBernstein( tp, p2D, &p4D );
	p4D.dCoord[W]/=Scale;
	if (FP_EQ(p4D.dCoord[W],0.0))
	    fprintf(stderr,"\noutputPolyLines: Point at infinity.\n");
	else {
	    if ((cRed!=red) || (cBlue!=blue) || (cGreen!=green)) {
		fprintf(pf,"\ncolor sphere {");
		fprintf(pf,"\ndiff %d %d %d 0 %d %d %d 0", 
			cRed, cGreen, cBlue, cRed, cGreen, cBlue );
		fprintf(pf,"\nspec 255 255 255 1 255 255 255 1\n};");
		red=cRed, green=cGreen, blue=cBlue;
	    }
	    fprintf(pf,"\nsphere %3.4lf %3.4lf %3.4lf 1.0 ;",
		    p4D.dCoord[X]/p4D.dCoord[W], 
		    p4D.dCoord[Y]/p4D.dCoord[W], 
		    p4D.dCoord[Z]/p4D.dCoord[W] );
	}
    }

    if(work_type == FINISH)
      fprintf(pf,"\n};");
    fflush(pf);
}

void outputQuad( pf, tp, i, j )
FILE          *pf;
TENSOR_PATCH  tp;
int           i,j;
{
    if (FP_EQ(tp.coeffs[i][j].dCoord[W],0.0) || 
	FP_EQ(tp.coeffs[i][j+1].dCoord[W],0.0) ||
	FP_EQ(tp.coeffs[i+1][j].dCoord[W],0.0) || 
	FP_EQ(tp.coeffs[i+1][j+1].dCoord[W],0.0))
	fprintf(stderr,"\noutput_patch_mesh: Point at infinity.\n");
    else {
	fprintf(pf,"\npolygon 3 {");
	fprintf(pf,"\n%3.4lf %3.4lf %3.4lf;",
		tp.coeffs[i][j].dCoord[X]/tp.coeffs[i][j].dCoord[W],
		tp.coeffs[i][j].dCoord[Y]/tp.coeffs[i][j].dCoord[W],
		tp.coeffs[i][j].dCoord[Z]/tp.coeffs[i][j].dCoord[W]);
	fprintf(pf,"\n%3.4lf %3.4lf %3.4lf;",
		tp.coeffs[i][j+1].dCoord[X]/tp.coeffs[i][j+1].dCoord[W],
		tp.coeffs[i][j+1].dCoord[Y]/tp.coeffs[i][j+1].dCoord[W],
		tp.coeffs[i][j+1].dCoord[Z]/tp.coeffs[i][j+1].dCoord[W]);
	fprintf(pf,"\n%3.4lf %3.4lf %3.4lf;",
		tp.coeffs[i+1][j].dCoord[X]/tp.coeffs[i+1][j].dCoord[W],
		tp.coeffs[i+1][j].dCoord[Y]/tp.coeffs[i+1][j].dCoord[W],
		tp.coeffs[i+1][j].dCoord[Z]/tp.coeffs[i+1][j].dCoord[W]);
	fprintf(pf,"\n};");
	fprintf(pf,"\npolygon 3 {");
	fprintf(pf,"\n%3.4lf %3.4lf %3.4lf;",
		tp.coeffs[i+1][j].dCoord[X]/tp.coeffs[i+1][j].dCoord[W],
		tp.coeffs[i+1][j].dCoord[Y]/tp.coeffs[i+1][j].dCoord[W],
		tp.coeffs[i+1][j].dCoord[Z]/tp.coeffs[i+1][j].dCoord[W]);
	fprintf(pf,"\n%3.4lf %3.4lf %3.4lf;",
		tp.coeffs[i][j+1].dCoord[X]/tp.coeffs[i][j+1].dCoord[W],
		tp.coeffs[i][j+1].dCoord[Y]/tp.coeffs[i][j+1].dCoord[W],
		tp.coeffs[i][j+1].dCoord[Z]/tp.coeffs[i][j+1].dCoord[W]);
	fprintf(pf,"\n%3.4lf %3.4lf %3.4lf;",
		tp.coeffs[i+1][j+1].dCoord[X]/tp.coeffs[i+1][j+1].dCoord[W],
		tp.coeffs[i+1][j+1].dCoord[Y]/tp.coeffs[i+1][j+1].dCoord[W],
		tp.coeffs[i+1][j+1].dCoord[Z]/tp.coeffs[i+1][j+1].dCoord[W]);
	fprintf(pf,"\n};");
    }
}

#define MAX_EXT_LEN  25

void output_patch_mesh( pf, pchName, tp, iRed, iGreen, iBlue, cFine )
FILE         *pf;
char         *pchName;
int          iRed, iGreen, iBlue;
TENSOR_PATCH tp;
int          cFine;
{
    char          *pch;
    int           i,j;
    TENSOR_PATCH  tpDraw;
    POINT2D       p2D;
    double        du, dv;

    fprintf(pf, "\ngouraud;");
    ALLOCN( pch, char, strlen(pchName) + MAX_EXT_LEN );

    /* ASSUMES TENSOR PRODUCT WITH BERNSTEIN BASIS */
    
    /* control pts */
    strcpy( pch, pchName );
    strcat( pch, "CtrlPoints" );
    fprintf(pf,"\nstructure %s posted {", pch);
    fprintf(pf,"\ncolor sphere {");
    fprintf(pf,"\ndiff 255 0 0 0 255 0 0 0");
    fprintf(pf,"\nspec 255 255 255 1 255 255 255 1\n};");
    for (i=0;i<=tp.iDeg0;i++)
	for (j=0;j<=tp.iDeg1;j++) {
	    tp.coeffs[i][j].dCoord[W]/=Scale;
	    if (FP_EQ(tp.coeffs[i][j].dCoord[W],0.0))
		fprintf(stderr,"\noutput_patch_mesh: Point at infinity.\n");
	    else
		fprintf(pf,"\nsphere %3.4lf %3.4lf %3.4lf 5.0 ;",
			tp.coeffs[i][j].dCoord[X]/tp.coeffs[i][j].dCoord[W],
			tp.coeffs[i][j].dCoord[Y]/tp.coeffs[i][j].dCoord[W],
			tp.coeffs[i][j].dCoord[Z]/tp.coeffs[i][j].dCoord[W]);
	    tp.coeffs[i][j].dCoord[W]*=Scale;
	}
    fprintf(pf,"\n};");
	    

    /* control mesh */
    strcpy( pch, pchName );
    strcat( pch, "CtrlMesh" );
    fprintf(pf,"\nstructure %s posted {", pch);
    fprintf(pf,"\ncolor line {");
    fprintf(pf,"\ndiff 0 255 0 0 0 255 0 0");
    fprintf(pf,"\nspec 255 255 255 1 255 255 255 1\n};");
    for (i=0;i<tp.iDeg0;i++)
	for (j=0;j<=tp.iDeg1;j++) {
	    tp.coeffs[i][j].dCoord[W]/=Scale;
	    tp.coeffs[i+1][j].dCoord[W]/=Scale;
	    if (FP_EQ(tp.coeffs[i][j].dCoord[W],0.0) || 
		FP_EQ(tp.coeffs[i+1][j].dCoord[W],0.0))
		fprintf(stderr,"\noutputoutput_patch_mesh: Point at infinity.\n");
	    else
		fprintf(pf,"\nline %3.4lf %3.4lf %3.4lf %3.4lf %3.4lf %3.4lf;\n",
			tp.coeffs[i][j].dCoord[X]/tp.coeffs[i][j].dCoord[W],
			tp.coeffs[i][j].dCoord[Y]/tp.coeffs[i][j].dCoord[W],
			tp.coeffs[i][j].dCoord[Z]/tp.coeffs[i][j].dCoord[W],
			tp.coeffs[i+1][j].dCoord[X]/tp.coeffs[i+1][j].dCoord[W],
			tp.coeffs[i+1][j].dCoord[Y]/tp.coeffs[i+1][j].dCoord[W],
			tp.coeffs[i+1][j].dCoord[Z]/tp.coeffs[i+1][j].dCoord[W]);
	    tp.coeffs[i][j].dCoord[W]*=Scale;
	    tp.coeffs[i+1][j].dCoord[W]*=Scale;
	}
	    
    for (j=0;j<tp.iDeg1;j++)
	for (i=0;i<=tp.iDeg0;i++) {
	    tp.coeffs[i][j].dCoord[W]/=Scale;
	    tp.coeffs[i][j+1].dCoord[W]/=Scale;
	    if (FP_EQ(tp.coeffs[i][j].dCoord[W],0.0) || 
		FP_EQ(tp.coeffs[i][j+1].dCoord[W],0.0))
		fprintf(stderr,"\noutputoutput_patch_mesh: Point at infinity.\n");
	    else
		fprintf(pf,"\nline %3.4lf %3.4lf %3.4lf %3.4lf %3.4lf %3.4lf;\n",
			tp.coeffs[i][j].dCoord[X]/tp.coeffs[i][j].dCoord[W],
			tp.coeffs[i][j].dCoord[Y]/tp.coeffs[i][j].dCoord[W],
			tp.coeffs[i][j].dCoord[Z]/tp.coeffs[i][j].dCoord[W],
			tp.coeffs[i][j+1].dCoord[X]/tp.coeffs[i][j+1].dCoord[W],
			tp.coeffs[i][j+1].dCoord[Y]/tp.coeffs[i][j+1].dCoord[W],
			tp.coeffs[i][j+1].dCoord[Z]/tp.coeffs[i][j+1].dCoord[W]);
	    tp.coeffs[i][j].dCoord[W]*=Scale;
	    tp.coeffs[i][j+1].dCoord[W]*=Scale;
	}
	    
    fprintf(pf,"\n};");

    /* surface at points */
    strcpy( pch, pchName );
    strcat( pch, "PolySurface" );
    fprintf(pf,"\nstructure %s posted {", pch);
    fprintf(pf,"\ncolor polygon {");
    fprintf(pf,"\ndiff %d %d %d 0 %d %d %d 0", iRed, iGreen, iBlue,
	    iRed, iGreen, iBlue);
    fprintf(pf,"\nspec 255 255 255 1 255 255 255 1\n};");

    tpDraw.iDeg0 = cFine;
    tpDraw.iDeg1 = cFine;

    allocate_tensor_patch( &tpDraw );
    
    du = dv = 0.0;
    if (tpDraw.iDeg0)
	du = 1.0 / (double) tpDraw.iDeg0;
    if (tpDraw.iDeg1)
	dv = 1.0 / (double) tpDraw.iDeg1;

    /* calc the actual points for the surface */
    for (i=0;i<=tpDraw.iDeg0;i++)
	for (j=0;j<=tpDraw.iDeg1;j++) {
	    p2D.u = i * du;
	    p2D.v = j * dv;
	    evaluateBernstein( tp, p2D, &(tpDraw.coeffs[i][j]) );
	    tpDraw.coeffs[i][j].dCoord[W]/=Scale;
	}

    /* now output them as quads or tris */
    for (i=0;i<tpDraw.iDeg0;i++)
	for (j=0;j<tpDraw.iDeg1;j++) {
	    outputQuad( pf, tpDraw, i, j );
	}

    fprintf(pf,"\n};");

/* CHECK IF THIS IS THE CORRECT WAY TO FREE A PATCH */

    myfree(tpDraw.coeffs[0]);
    myfree(tpDraw.coeffs);

    myfree(pch);
}





