#ifndef __def_bezier__

#define __def_bezier__

/* Conditional includes */
#ifdef PXPL
#include <pphigs.h>
#include <pg_sys.h>
#include <pg_dlist.h>
#include <pg_dglob.h>
#include <ros.h>
#include <math.h>
#include <stdio.h>
#include <sys/time.h>
#else		
#include <gl.h>	
#include <gl/gl.h>
#define SGITYPE	
#endif

#include <math.h>
#include <stdio.h>
#include <sys/time.h>

#include "bez_defaults.h"
#include "triangles.h"

#define INFINITY	HUGE_VAL
#define SQRT2           1.414213562

#define	X		0
#define	Y		1
#define	Z		2
#define	W		3
#define COORD		3
#define WCOORD		4
#define U		0
#define V		1
#define UVCOORD         2
#define UVWCOORD        3

#define BEZIERTCURVE    0
#define PIECEWISETCURVE 1


/* MAX Definitions */
/* #define MAX_DEGREE	6 */
#define MAX_DEGREE	12
#define MAX_ORDER	(1+MAX_DEGREE)
#define MAX_TRIMBREAKS  40
#define MAX_NO_POINTS   5	/* divisions on a patch */
#define MAX_NO_POINTS2  (MAX_NO_POINTS+2)
#define MAX_NO_POINTS1  (MAX_NO_POINTS+1)
#define MAX_NO_POINTS_1 (MAX_NO_POINTS-1)
#define MAX_NO_POINTS_2 (MAX_NO_POINTS-2)
#define ULTI_POINTS     MAX_NO_POINTS /* Too many points */
#define MAX_CDEGREE     210     /* Max degree of a TrimCurve (>1) */
#define MAX_CORDER      (1+MAX_CDEGREE)
#define MAX_CURVATUR    5	/* curvature estimate */

#define MAX_SOLIDS	20
#define MAX_SUBSOLIDS	100
#define BMIN		0
#define BMAX		1
#define MINMAX		2


#define MAX_TRIMCURVE   1
#define MAX_TRIMCURVE   5

#ifdef  PXPL
#define MAX_GP		55
/* #define MAX_PATCH_GP	20      /* Brakehub on Jason */
/* #define MAX_PATCH_GP	22      /* Brakehub on Hugin */
#define MAX_PATCH_GP	601	/* Works for pivot. All too ? */
/* #define MAX_PATCH	1096	/* Maximum number of patches */
#else
#define MAX_GP           1
#define MAX_PATCH_GP     600	/* Patches per GP(1) that can be cached */
#define MAX_PATCH        MAX_PATCH_GP
#endif

#define NAMESIZE	64
#define	FLOAT		sizeof(float);
	/* Flags for extra info in the file */
#define F_COLOR         0x1
#define F_TRIMBREAKS    0x2

typedef u_char          byte;
typedef	float		WTYPE;
typedef WTYPE           POINT[WCOORD]; /* TODO Need to Change to COORD */
typedef WTYPE           TPOINT[UVCOORD];
typedef char            NAME[NAMESIZE];


#ifdef _D_DEBUG_ALL_
#define ALLDEBUG(x)     x
#define TRACECODE
#else
#define ALLDEBUG(x)
#endif

#undef TRACECODE
#ifdef TRACECODE
#define TRACE(x)	x
#else
#define TRACE(x)
#endif

#ifndef DEMOTIME
#define FEATURE(x)	x
#else
#define FEATURE(x)
#endif


#ifdef NOERRORCHECK
#define ERR(x)
#else
#define ERR(x)          x
#endif


#define PACKCOL(col,c)         ((col[0]) | (col[1] << DiffuseLen) | \
                               (col[2] << DiffuseLen2)|(c << DiffuseLen3))
#define COLFILL1(x,f,col,c)    {x.r = col[0]; x.g = col[1];\
                                      x.b = col[2]; x.f = c;}
#define COLFILL1D(x,col,c)      COLFILL1(x,a,col,c)
#define COLFILL1S(x,col,c)      COLFILL1(x,p,col,c)
#define COLFILL(x,pf,col,c)     x.pf = PACKCOL(col,c)
#define COLFILLD(x,col,c)       COLFILL(x,pdiff,col,c)
#define COLFILLS(x,col,c)       COLFILL(x,pspec,col,c)
#define COLFILLALL(x,f,pf,col,c){COLFILL1(x,f,col,c);COLFILL(x,pf,col,c);}
#define COLFILLALLD(x,col,c)    COLFILLALL(x,a,pdiff,col,c)
#define COLFILLALLS(x,col,c)    COLFILLALL(x,p,pspec,col,c)

#define NORMALIZE(a,b) {				\
		tmp = 1.0/SQRT(DOUBLE a[0]*a[0]+a[1]*a[1]+a[2]*a[2]);\
		b[0] = a[0]*tmp;			\
		b[1] = a[1]*tmp;			\
		b[2] = a[2]*tmp;			\
	        }
#define crossp(a,b,c) 	{				\
			   c[0] = a[1]*b[2]-a[2]*b[1];	\
			   c[1] = a[2]*b[0]-a[0]*b[2];	\
			   c[2] = a[0]*b[1]-a[1]*b[0];	\
			}

#endif
