/* #include "gl.h" */
/* #include "device.h" */
/* #include "initd.c" */

#ifdef __GL
#include <gl.h>
#include <device.h>

#define ROTAT	1
#define SCALI	2
#define TRANS	3
#define QUIT	99

long curr_win = 3;
extern long gidxyz;
extern long giduv;
extern int curve_or_full;
extern int multi_color;
extern int sp;

init_events()
/* 
 */
{
/*-------------------------------------------------------------------*/
qreset();
qdevice(LEFTMOUSE);
qdevice(MIDDLEMOUSE);
qdevice(RIGHTMOUSE);
qdevice(ESCKEY);
qdevice(REDRAW);
qdevice(WINTHAW);
qdevice(INPUTCHANGE);
qdevice(KEYBD);
qdevice(F1KEY);
qdevice(F2KEY);
qdevice(F3KEY);
qdevice(F4KEY);
qdevice(F5KEY);
qdevice(F6KEY);
qdevice(F7KEY);
qdevice(F8KEY);
qdevice(F9KEY);
qdevice(F10KEY);
qdevice(F11KEY);
qdevice(F12KEY);
qreset();
/*-------------------------------------------------------------------*/
}

int getinput()
/* handle_events(surfptr) */
/* Surface *surfptr; */
/*
 * HANDLE ALL EVENTS 
 */
{
Device device;
short actionflag = 0;
short button,junk;
static int sign = 0, dot = 0, action = ROTAT;
static float runit = 0.3, sunit = 1.1, tunit = 0.02;
float t;
/*-------------------------------------------------------------------*/
/* qreset(); */
/*
/* action = ROTAT; */
/* prefsize(200,200); */
/* winopen("input"); */
/* color(BLACK); */
/* clear(); */
/* init_events(); */
/* while( 1 ) */
  /* { */
    if( device = qtest() ) 
       {
       switch( device ) 
             {
	       case LEFTMOUSE:
		    qread(&actionflag);
		    if(actionflag) dot = 'X'; else dot = 0;
                    /* qreset(); */
		    break;
	       case MIDDLEMOUSE: /* exercises all interactive control */
		    qread(&actionflag);
		    if(actionflag) dot = 'Y'; else dot = 0;
                    /* qreset(); */
		    break;		    
	       case RIGHTMOUSE:
		    qread(&actionflag);
		    if(actionflag) dot = 'Z'; else dot = 0;
                    /* qreset(); */
		    break;
	       case F1KEY:
		    qread(&actionflag);
		    if(actionflag) break;
		    action = ROTAT;
		    /* qreset(); */
		    break;
	       case F2KEY:
		    qread(&actionflag);
		    if(actionflag) break;
		    action = SCALI;
		    /* qreset(); */
		    break;
	       case F3KEY:
		    qread(&actionflag);
		    if(actionflag) break;
		    action = TRANS;
		    /* qreset(); */
		    break;
	       case F4KEY:
		    qread(&actionflag);
		    if(actionflag) break;
		    sign = !sign;
		    /* qreset(); */
		    break;
	       case F7KEY:
		    qread(&junk);
		    if (junk) break;
		    curve_or_full = 1 - curve_or_full;
		    /* qreset(); */
		    break;
	       case F9KEY:
		    qread(&junk);
		    if (junk) break;
		    multi_color = 1 - multi_color;
		    /* qreset(); */
		    break;
/*
	       case F8KEY:
		    qread(&junk);
		    if (junk) break;
		    sp = 1 - sp;
		    qreset();
		    break;
*/
	       case F5KEY:
		    qread(&actionflag);
		    if(actionflag) break;
		    switch(action)
			{
			case ROTAT:
				runit += 2.0;
				/* printf("New Rotation unit = %g\n", runit); */
			case SCALI:
				sunit += 0.05;
				/* printf("New Scaling unit = %g\n", runit); */
			case TRANS:
				tunit += 0.1;
				/* printf("New Translation unit = %g\n", runit); */
			}
		    /* qreset(); */
		    break;
               case INPUTCHANGE:
                    qread(&junk);
                    curr_win = junk;
                    break;
	       case F6KEY:
		    qread(&actionflag);
		    if(actionflag) break;
		    switch(action)
			{
			case ROTAT:
				runit -= 2.0;
			/* printf("New Rotation unit = %g\n", runit); */
			case SCALI:
				sunit -= 0.05;
			/* printf("New Scaling unit = %g\n", runit); */
			case TRANS:
				tunit -= 0.1;
			/* printf("New Translation unit = %g\n", runit); */
			}
		    /* qreset(); */
		    break;
	       case KEYBD:
		    qread(&junk);
		    if (junk == 'q' || junk == 'Q')
			return QUIT;
		     /* printf("Keyboard = %d\n", junk); */
		    break;
	       case ESCKEY:
		    qreset(); exit(1);
	       default:
                    qread(&junk);
                     /* printf("Unknown Device= %3d State= %d\n", device,junk);  */
                     /* qreset();  */
                    break;
            } /* end of switch */
       }     /* end of while  */
   /* if ((curr_win == gidxyz) || (curr_win == giduv)) */
    if(dot) {
     winset(curr_win);
     switch(action)
	{
	case ROTAT:
		if(sign) rot(-(runit/2), dot); else rotate(runit,dot);
		/* printf("Rotate %g around X\n", sign); */
		break;
	case SCALI:
		if(sign) scale(1/sunit, 1/sunit, 1/sunit);
		else scale(sunit, sunit, sunit);
		/* printf("Scale %g \n", sunit); */
		break;
	case TRANS:
		if(sign) t = -tunit; else t = tunit;
		if(dot == 'X')
		   translate(t, 0, 0);
		else if(dot == 'Y')
		   translate(0, t, 0);
		else if(dot == 'Z')
		   translate(0, 0, t);
		/* printf("Translate %g around X\n", tunit); */
		break;
	}
      winset(gidxyz);
     }
  /* } */
/*-------------------------------------------------------------------*/
}
#endif
