#ifdef __GL
#define SGIDEF2
#include "color.h"

/* int debug, nsteps; */
extern int cdebug, debug;

extern Matrix M1;
extern WTYPE vx, vy, vz, hx, hy, hz, ex, ey, ez, r, rx, ry, rz, tanxy, hither,
             yon, fov;

negate(a,b)
VECTOR a,b;
{
b[0] = -b[0];
b[1] = a[2]*b[0]-a[0]*b[2];
b[2] = a[0]*b[1]-a[1]*b[0];
}

add(a,b,c)
POINT a,c;
VECTOR b;
{
c[0] = a[0] + b[0];
c[1] = a[1] + b[1];
c[2] = a[2] + b[2];
}

dotp(a,b,c)
VECTOR a,b,c;
{
c[0] = a[0] * b[0];
c[1] = a[1] * b[1];
c[2] = a[2] * b[2];
}

mod(a)
VECTOR a;
{
return SQRT(DOUBLE a[0]*a[0] + a[1]*a[1] + a[2]*a[2]);
}

crossp(a,b,c)
VECTOR a,b,c;
{
c[0] = a[1]*b[2]-a[2]*b[1];
c[1] = a[2]*b[0]-a[0]*b[2];
c[2] = a[0]*b[1]-a[1]*b[0];
}

normalize(a,b)
VECTOR a,b;
{
WTYPE tmp;

tmp = SQRT(DOUBLE a[0]*a[0]+a[1]*a[1]+a[2]*a[2]);
b[0] = a[0]/tmp;
b[1] = a[1]/tmp;
b[2] = a[2]/tmp;
}

big_point(pt)
POINT pt;
{
POINT pt1, pt2;

	pt1[0] = pt[0]+.02; pt1[1] = pt[1]; pt1[2] = pt[2];
	pt2[0] = pt[0]; pt2[1] = pt[1]+.02; pt2[2] = pt[2];
   bgnpolygon();
	v3t(pt);
	v3t(pt1);
	v3t(pt2);
	pt1[0] = pt[0]; pt1[2] = pt[2]+.02;
	v3t(pt1);
   endpolygon();
}

mymult(pt1, pt2)
POINT pt1, pt2;
{
POINT pt3;
int i, j;

/* pt1[3] = 1; */
for(i=0; i<4; i++)
   pt2[i] = 0;
/* for(i=0; i<4; i++) */
   /* pt3[i] = 0; */
for(i=0; i<4; i++)
   for(j=0; j<4; j++)
      pt2[i] += pt1[j]*M1[j][i];
}

myview(pt1, pt2)
POINT pt1, pt2;
{
WTYPE tmp;

 pt2[0] = pt1[0]-ex; pt2[1] = pt1[1]-ey; pt2[2] = pt1[2]-ez;
 tmp = pt2[0]*rx + pt2[1]*ry + pt2[2]*rz; 
 pt2[0] *= r/tmp; pt2[1] *= r/tmp; pt2[2] *= r/tmp;
 pt2[0] += ex; pt2[1] += ey; pt2[2] += ez;
}

WTYPE realarea(pts, no)
POINT *pts;
int no;
{
WTYPE sarea, area;
int i;

area = 0;
for(i=1; i<no; i++)
   {
   sarea = (pts[i-1][0]*(pts[i][1]-pts[i-1][1])
	   -pts[i-1][1]*(pts[i][0]-pts[i-1][0]))/2;
   if(sarea < 0) area -= sarea;
   else area += sarea;
   }
sarea = (pts[no-1][0]*(pts[0][1]-pts[no-1][1])
        -pts[no-1][1]*(pts[0][0]-pts[no-1][0]))/2;
if(sarea < 0) area -= sarea;
else area += sarea;
/* return area; */
return SQRT(area);
}

/*
myarea(pts, no, center)
{
WTYPE area;

area = 0;
for(i=0; i<no; i++)
   {
   area += SQRT((center[1]-pts[i][1])*(center[1]-pts[i][1])
              + (center[0]-pts[i][0])*(center[0]-pts[i][0]));
   }
return area;
}
*/

long init_gl(x0,y0,x1,y1,bkgrnd,win_name)
int x0, x1, y0, y1;
Colorindex bkgrnd;
char *win_name;
{
POINT tmp1, tmp2;
    long xorig, yorig, xsize, ysize;
    long gid;
    int i;

    /* set up graphics environment */
    prefposition(x0, x1, y0, y1);
    FOREGROUND;
    gid = winopen(win_name);
    color(bkgrnd);
    getorigin(&xorig, &yorig);
    getsize(&xsize, &ysize);
     /* singlebuffer(); */
    if(cdebug || debug) singlebuffer();
    else doublebuffer();
    RGBmode();
    gconfig();
    lsetdepth(0, 0x7FFFFF);
    zbuffer(TRUE);
    /* Use mmode() to set up projection & viewing matrices for lighting */
    mmode(MPROJECTION);		
    hither = 0.01; yon = 57.0;
    perspective(900, xsize/(float)ysize, hither, yon);
    tanxy = 1.0;
    fov = 1.0; /* arccot(fov) */
    /* getmatrix(Mp); */
    mmode(MVIEWING);
    def_light_calc(); 
    use_light_calc(); 
    shademodel(GOURAUD);
    c3f(navyvec);	/* clear the frame */
    clear();
    zclear();
    lmbind(MATERIAL, 1);
/*
    lmbind(LIGHT0, 27);
    lmbind(LIGHT1, 28);
    lmbind(LIGHT2, 29);
    lmbind(LMODEL, 14);
*/

    /* lmbind(BACKMATERIAL, 17); */

    /* ex = 5.0; ey = 5.0; ez = 5.0; rx = 0.1; ry = 0.1; rz = 2.5; */
    ex = 0.0; ey = 0.0; ez = -2.0; rx = 0.5; ry = 0.5; rz = 0.5;
     /* ex = 0.0; ey = 0.0; ez = -1.0; rx = 0.5; ry = 0.5; rz = 0.5; */
    lookat(ex, ey, ez, rx, ry, rz, 0);  
    getmatrix(M1);
    rx = rx-ex; ry = ry-ey; rz = rz - ez;
    r = SQRT(DOUBLE rx*rx + ry*ry + rz*rz);
    vx = -rx*ry; vy = rz*rz+rx*rx; vz = -ry*rz;
    hx = rz; hz = -rx;
    return gid;
}


/*
** def_light_calc()
** Tell the Graphics Library to DEFINE a simple
** lighting calculation that accounts for diffuse
** and ambient reflection.  This simple
** lighting calculation happens to use the default
** lighting parameters in the Graphics Library.
*/

def_light_calc() {
/*
    lmdef(DEFMATERIAL, 1, 0, shiny_material);
    lmdef(DEFMATERIAL, 2, 15, shiny_material1);
*/
    lmdef(DEFMATERIAL, 1, 0, yellow);
    lmdef(DEFMATERIAL, 2, 15, blue);
    lmdef(DEFMATERIAL, 3, 5, green);
    lmdef(DEFMATERIAL, 4, 11, lavender);
    lmdef(DEFMATERIAL, 5, 0, purple);
    lmdef(DEFMATERIAL, 6, 0, pink);
    lmdef(DEFMATERIAL, 7, 0, orange);
    lmdef(DEFMATERIAL, 8, 0, darkred);
    lmdef(DEFMATERIAL, 9, 0, white);
    lmdef(DEFMATERIAL, 10, 0, cyan);
    lmdef(DEFMATERIAL, 11, 0, black);
    lmdef(DEFMATERIAL, 12, 0, gray);
    lmdef(DEFMATERIAL, 13, 0, green);
    lmdef(DEFMATERIAL, 14, 0, navy);
    lmdef(DEFMATERIAL, 15, 0, blueg);
    lmdef(DEFMATERIAL, 16, 0, greenb);
    lmdef(DEFMATERIAL, 17, 0, shiny_material);
    lmdef(DEFLIGHT, 1, 0, light);
    lmdef(DEFLIGHT, 2, 10, white_light);
    lmdef(DEFLIGHT, 3, 0, light2);
    lmdef(DEFLIGHT, 4, 0, light3);
    lmdef(DEFLIGHT, 5, 0, light4);
    /* lmdef(DEFLMODEL, 1, 0, NULL); */
    lmdef(DEFLMODEL, 1, 0, lighting_model);
}

/*
** use_light_calc()
** Tell the Graphics Library to USE the
** simple lighting calculation that we
** defined earlier.
*/
use_light_calc()
{
    lmbind(LIGHT0, 3);
    lmbind(LIGHT1, 4);
    lmbind(LIGHT2, 5);
    lmbind(LIGHT3, 1);
    lmbind(LIGHT4, 2);
    lmbind(LMODEL, 1);
}


WTYPE diffnorm(p1, p2)
POINT p1, p2;
{
WTYPE tmp1, tmp2;

tmp1 = p1[0] - p2[0]; tmp2 = tmp1*tmp1;
tmp1 = p1[1] - p2[1]; tmp2 += tmp1*tmp1;
return SQRT(DOUBLE tmp2);
}

WTYPE diffnorm3(p1, p2)
POINT p1, p2;
{
WTYPE tmp1, tmp2;

tmp1 = p1[0] - p2[0]; tmp2 = tmp1*tmp1;
tmp1 = p1[1] - p2[1]; tmp2 += tmp1*tmp1;
tmp1 = p1[2] - p2[2]; tmp2 += tmp1*tmp1;
return SQRT(DOUBLE tmp2);
}


bez_t(cntrl, udegree, vdegree, u, v, coord, res)
WTYPE cntrl[MAX_DEGREE][MAX_DEGREE][WCOORD], u, v;
int udegree, vdegree;
POINT res;
{
int i, j, k;
WTYPE u1[MAX_DEGREE], v1[MAX_DEGREE], tmp;
WTYPE u2[MAX_DEGREE], v2[MAX_DEGREE];
int mc[MAX_DEGREE], nc[MAX_DEGREE];

u2[udegree] = v2[vdegree] = u1[0] = v1[0] = 1.0;
mc[0] = nc[0] = 1;
tmp = 1-u;
for(i=udegree-1; i>=0; i--)
   u2[i] = u2[i+1]*tmp;
for(i=1; i<=udegree; i++)
   {
   u1[i] = u1[i-1]*u;
   mc[i] = (mc[i-1]*(udegree-i+1))/i;
   }
tmp = 1-v;
for(i=vdegree-1; i>=0; i--)
   v2[i] = v2[i+1]*tmp;
for(i=1; i<=vdegree; i++)
   {
   v1[i] = v1[i-1]*v;
   nc[i] = (nc[i-1]*(vdegree-i+1))/i;
   }

for(i=0; i<coord; i++)
   res[i] = 0.0; /* cntrl[i][j]*B(m,i,u)*B(n,j,v); */

for(i=0; i<=udegree; i++)
   for(j=0; j<=vdegree; j++)
      for(k=0; k<coord; k++)
         res[k] += cntrl[i][j][k]*(mc[i]*u1[i]*u2[i])*(nc[j]*v1[j]*v2[j]);
}

bez_test(cntrl, udegree, vdegree, u, v, coord)
WTYPE cntrl[MAX_DEGREE][MAX_DEGREE][WCOORD], u, v;
int udegree, vdegree;
{
int k;
POINT res;

bez_t(cntrl, udegree, vdegree, u, v, coord, res);
if(coord == WCOORD)
   {
   printf("Rational ");
   for(k=0; k<COORD; k++)
      res[k] /= res[COORD];
   }
printf("TEST(%g,%g) = ", u,v);
for(k=0; k<COORD; k++)
   printf("%g ", res[k]);
printf("\n");
}

bez_alltest(cntrl, udegree, vdegree, u, v, coord)
WTYPE cntrl[MAX_DEGREE][MAX_DEGREE][WCOORD], u, v;
int udegree, vdegree;
{
int i, j, k;
POINT res, n1, n2, n;
WTYPE cntrl2[MAX_DEGREE][MAX_DEGREE][WCOORD];
WTYPE cntrl3[MAX_DEGREE][MAX_DEGREE][WCOORD];

bez_t(cntrl, udegree, vdegree, u, v, coord, res);

for(i=0; i<= udegree; i++)
   for(j=0; j< vdegree; j++)
      for(k=0; k< coord; k++)
         cntrl2[i][j][k] = cntrl[i][j+1][k] - cntrl[i][j][k];
bez_t(cntrl, udegree, vdegree, u, v, coord, n1);

for(i=0; i< udegree; i++)
   for(j=0; j<= vdegree; j++)
      for(k=0; k< coord; k++)
         cntrl3[i][j][k] = cntrl[i+1][j][k] - cntrl[i][j][k];
bez_t(cntrl, udegree, vdegree, u, v, coord, n2);

if(coord == WCOORD)
   {
   printf("Rational ");

   for(k=0; k<COORD; k++)
      n1[k]  = (res[COORD]*n1[k] - res[k]*n1[COORD])/(res[COORD]*res[COORD]);

   for(k=0; k<COORD; k++)
      n2[k]  = (res[COORD]*n2[k] - res[k]*n2[COORD])/(res[COORD]*res[COORD]);

   for(k=0; k<COORD; k++)
      res[k] /= res[COORD];
   }

crossp(n1, n2, n);
normalize(n, n);

printf("TEST(%g,%g) = ", u,v);
for(k=0; k<COORD; k++)
   printf("%g ", res[k]);
printf("\n");

printf("-- Normal = ");
for(k=0; k<COORD; k++)
   printf("%g ", n[k]);
printf("\n");
}
#endif

